#pragma once

void * Runtime_DynamicCast(void * srcObj, const void * fromType, const void * toType);

#define DYNAMIC_CAST(obj, from, to) ( ## to *) Runtime_DynamicCast((void*)(obj), RTTI_ ## from, RTTI_ ## to)

extern const void * RTTI_IAIWorldLocation;
extern const void * RTTI_BGSAIWorldLocation;
extern const void * RTTI_BGSAIWorldLocationInteriorCell;
extern const void * RTTI_BGSAIWorldLocationPointRadius;
extern const void * RTTI_BGSAIWorldLocationPrimitive;
extern const void * RTTI_FindTriangleForLocationFilter;
extern const void * RTTI_FindTriangleForLocationFilterCheckDeltaZ;
extern const void * RTTI_BGSAIWorldLocationRefRadius;
extern const void * RTTI_BSTArrayBase__IAllocatorFunctor;
extern const void * RTTI_IPackageDataTypeCheck;
extern const void * RTTI_IProcedureTreeExecState;
extern const void * RTTI_IProcedure;
extern const void * RTTI_BGSProcedureBase;
extern const void * RTTI_BGSProcedureHeadtrack;
extern const void * RTTI_BGSProcedureHeadtrackExecState;
extern const void * RTTI_BGSProcedurePlayIdle;
extern const void * RTTI_BGSProcedurePlayIdleExecState;
extern const void * RTTI_TESActionData;
extern const void * RTTI_BGSActionData;
extern const void * RTTI_Setting;
extern const void * RTTI_INISettingCollection;
extern const void * RTTI_hkBaseObject;
extern const void * RTTI_hknpCollisionQueryCollector;
extern const void * RTTI_hknpClosestHitCollector;
extern const void * RTTI_GameSettingCollection;
extern const void * RTTI_IMovementParameters;
extern const void * RTTI_MovementParameters;
extern const void * RTTI_BGSProcedureRange;
extern const void * RTTI_BGSProcedureRangeExecState;
extern const void * RTTI_BGSProcedureStayAway;
extern const void * RTTI_BGSProcedureStayAwayExecState;
extern const void * RTTI_IAnimationEventDataForEachFunctor;
extern const void * RTTI_BGSRetargetOnDeleteExtraData;
extern const void * RTTI_IForEachDynamicIdleInDir;
extern const void * RTTI_DynamicIdleDataSingletonHelper;
extern const void * RTTI_BGSObjectInstanceExtra;
extern const void * RTTI_BSExtraData;
extern const void * RTTI_ExtraInitActions;
extern const void * RTTI_BaseFormComponent;
extern const void * RTTI_BGSAttachParentArray;
extern const void * RTTI_BGSCraftingUseSound;
extern const void * RTTI_BGSFeaturedItemMessage;
extern const void * RTTI_BGSForcedLocRefType;
extern const void * RTTI_BGSInstanceNamingRulesForm;
extern const void * RTTI_BGSMod__Template__Items;
extern const void * RTTI_TESFullName;
extern const void * RTTI_BGSMod__Template__Item;
extern const void * RTTI_BGSModelMaterialSwap;
extern const void * RTTI_BGSNativeTerminalForm;
extern const void * RTTI_BGSPreviewTransform;
extern const void * RTTI_BGSPropertySheet;
extern const void * RTTI_BGSSoundTagComponent;
extern const void * RTTI_InitActionI;
extern const void * RTTI_BGSConveyorBelt__ConveyorBelt;
extern const void * RTTI_hkReferencedObject;
extern const void * RTTI_hknpAction;
extern const void * RTTI_hknpUnaryAction;
extern const void * RTTI_BGSMotorAction__Action;
extern const void * RTTI_BGSMotorAction__FanMotor;
extern const void * RTTI_NiRefObject;
extern const void * RTTI_hknpPhysicsSystemData;
extern const void * RTTI_CellHfCollision;
extern const void * RTTI_hknpCollisionFilter;
extern const void * RTTI_hknpAllHitsCollector;
extern const void * RTTI_hknpBSCustomCollisionFilter;
extern const void * RTTI_hknpFlippedGetClosestPointsQueryCollector;
extern const void * RTTI_IFormFactory;
extern const void * RTTI_AlchemyItem;
extern const void * RTTI_BGSDualCastData;
extern const void * RTTI_EffectArchetypes__MainStatusHandler;
extern const void * RTTI_EffectSetting;
extern const void * RTTI_EnchantmentItem;
extern const void * RTTI_IngredientItem;
extern const void * RTTI_BSModelDB__QueuedHandles;
extern const void * RTTI_AnimationSystemUtils__TESModelAndAnimationHandles;
extern const void * RTTI_TESModelDB__TESQueuedHandles;
extern const void * RTTI_MagicItem;
extern const void * RTTI_MagicItem__PreloadableVisitor;
extern const void * RTTI_MagicItemTraversalFunctor;
extern const void * RTTI_MagicItemFindFunctor;
extern const void * RTTI_MagicItemFindKeywordFunctor;
extern const void * RTTI_FindNonExcludedDeliveryFunctor;
extern const void * RTTI_FindEqualsFunctor;
extern const void * RTTI_GetCostliestEffectFunctor;
extern const void * RTTI_LongestDurationFunctor;
extern const void * RTTI_LargestAreaFunctor;
extern const void * RTTI_GetMagicItemDescriptionFunctor;
extern const void * RTTI_ScrollItem;
extern const void * RTTI_SpellItem;
extern const void * RTTI_ExtraCell3D;
extern const void * RTTI_ExtraHavok;
extern const void * RTTI_ExtraRegionList;
extern const void * RTTI_ExtraCellSkyRegion;
extern const void * RTTI_ExtraCellImageSpace;
extern const void * RTTI_ExtraCellGodRays;
extern const void * RTTI_ExtraSeenData;
extern const void * RTTI_ExtraNorthRotation;
extern const void * RTTI_ExtraDetachTime;
extern const void * RTTI_ExtraProcessMiddleLow;
extern const void * RTTI_ExtraCellMusicType;
extern const void * RTTI_ExtraCellAcousticSpace;
extern const void * RTTI_ExtraCellWaterType;
extern const void * RTTI_TESObjectREFRDef__IAliasFunctor;
extern const void * RTTI_TESObjectREFRDef__ILinkedReferenceFunctor;
extern const void * RTTI_ExtraCulledBone;
extern const void * RTTI_ExtraLock;
extern const void * RTTI_ExtraTeleport;
extern const void * RTTI_ExtraStartingPosition;
extern const void * RTTI_ExtraOwnership;
extern const void * RTTI_ExtraGlobal;
extern const void * RTTI_ExtraRank;
extern const void * RTTI_ExtraCount;
extern const void * RTTI_ExtraLeveledItem;
extern const void * RTTI_ExtraOutfitItem;
extern const void * RTTI_ExtraHealth;
extern const void * RTTI_ExtraTimeLeft;
extern const void * RTTI_ExtraCharge;
extern const void * RTTI_ExtraScale;
extern const void * RTTI_ExtraFollower;
extern const void * RTTI_ExtraOriginalReference;
extern const void * RTTI_ExtraPoison;
extern const void * RTTI_ExtraHeadingTarget;
extern const void * RTTI_ExtraCreatureAwakeSound;
extern const void * RTTI_ExtraObjectHealth;
extern const void * RTTI_ExtraActorCause;
extern const void * RTTI_ExtraRadioData;
extern const void * RTTI_ExtraPatrolRefData;
extern const void * RTTI_ExtraNavMeshPortal;
extern const void * RTTI_ExtraOcclusionPlaneRefData;
extern const void * RTTI_ExtraPortalRefData;
extern const void * RTTI_ExtraSceneData;
extern const void * RTTI_ExtraBadPosition;
extern const void * RTTI_ExtraHeadTrackingWeight;
extern const void * RTTI_ExtraFavorCost;
extern const void * RTTI_ExtraTextDisplayData;
extern const void * RTTI_ExtraHorse;
extern const void * RTTI_ExtraEnchantment;
extern const void * RTTI_ExtraForcedTarget;
extern const void * RTTI_ExtraUniqueID;
extern const void * RTTI_ExtraFlags;
extern const void * RTTI_ExtraWaterCurrentZoneData;
extern const void * RTTI_ExtraMissingRefIDs;
extern const void * RTTI_ExtraRangedDistOverride;
extern const void * RTTI_ExtraSoundOutputOverride;
extern const void * RTTI_ExtraEditorID;
extern const void * RTTI_ExtraFavorite;
extern const void * RTTI_ExtraPrimitive;
extern const void * RTTI_ExtraAmmo;
extern const void * RTTI_ExtraCombinedRefs;
extern const void * RTTI_ExtraPreVisRefs;
extern const void * RTTI_ExtraTransitionCellCount;
extern const void * RTTI_ExtraGIDBuffer;
extern const void * RTTI_ExtraFromAlias;
extern const void * RTTI_ExtraOpenCloseActivateRef;
extern const void * RTTI_ExtraTeleportName;
extern const void * RTTI_ExtraCachedScale;
extern const void * RTTI_ExtraReferenceHandles;
extern const void * RTTI_ExtraLocation;
extern const void * RTTI_ExtraTresPassPackage;
extern const void * RTTI_ExtraAttachRef;
extern const void * RTTI_ExtraAttachRefChildren;
extern const void * RTTI_ExtraPowerLinks;
extern const void * RTTI_ExtraReflectedRefs;
extern const void * RTTI_ExtraReflectorRefs;
extern const void * RTTI_ExtraWaterLightRefs;
extern const void * RTTI_ExtraLitWaterRefs;
extern const void * RTTI_ExtraHasNoRumors;
extern const void * RTTI_ExtraModelSwap;
extern const void * RTTI_ExtraRadius;
extern const void * RTTI_ExtraCombatStyle;
extern const void * RTTI_ExtraPackageData;
extern const void * RTTI_ExtraCollisionData;
extern const void * RTTI_ExtraLargeRefOwnerCells;
extern const void * RTTI_ExtraLightData;
extern const void * RTTI_ExtraModRank;
extern const void * RTTI_ExtraAttachedArrows3D;
extern const void * RTTI_ExtraAlphaCutoff;
extern const void * RTTI_ExtraForcedLandingMarker;
extern const void * RTTI_ExtraCellWaterEnvMap;
extern const void * RTTI_ExtraKeywords;
extern const void * RTTI_ExtraMaterialSwap;
extern const void * RTTI_ExtraProjectedDecalData;
extern const void * RTTI_ExtraActivateText;
extern const void * RTTI_ExtraRadioReceiver;
extern const void * RTTI_ExtraRadioRepeater;
extern const void * RTTI_ExtraAnimSounds;
extern const void * RTTI_ExtraActorValueStorage;
extern const void * RTTI_ExtraObjectBreakable;
extern const void * RTTI_ExtraObjectSavedDynamicIdles;
extern const void * RTTI_ExtraObjectSavedUnrecoverableSubgraphs;
extern const void * RTTI_ExtraIgnoredAttractKeywords;
extern const void * RTTI_ExtraInteriorLODWorldspace;
extern const void * RTTI_ExtraBoneScaleMap;
extern const void * RTTI_ExtraFXPickNodes;
extern const void * RTTI_ExtraEssentialProtected;
extern const void * RTTI_ExtraInvestedGold;
extern const void * RTTI_ExtraVoiceType;
extern const void * RTTI_Workshop__ExtraData;
extern const void * RTTI_NonActorMagicCaster;
extern const void * RTTI_ExtraAnimGraphManager;
extern const void * RTTI_ExtraDismemberedLimbs;
extern const void * RTTI_ExtraBiped;
extern const void * RTTI_ExtraLight;
extern const void * RTTI_ExtraLeveledCreature;
extern const void * RTTI_ExtraMapMarker;
extern const void * RTTI_ExtraAction;
extern const void * RTTI_ExtraShouldWear;
extern const void * RTTI_ExtraSeed;
extern const void * RTTI_ExtraPackage;
extern const void * RTTI_ExtraPlayerCrimeList;
extern const void * RTTI_ExtraRunOncePacks;
extern const void * RTTI_ExtraDistantData;
extern const void * RTTI_ExtraEnableStateParent;
extern const void * RTTI_ExtraEnableStateChildren;
extern const void * RTTI_ExtraLinkedRef;
extern const void * RTTI_ExtraLinkedRefChildren;
extern const void * RTTI_ExtraLocationRefType;
extern const void * RTTI_ExtraActivateRef;
extern const void * RTTI_ExtraActivateRefChildren;
extern const void * RTTI_ExtraRandomTeleportMarker;
extern const void * RTTI_ExtraCannotWear;
extern const void * RTTI_ExtraLastFinishedSequence;
extern const void * RTTI_ExtraGhost;
extern const void * RTTI_ExtraItemDropper;
extern const void * RTTI_ExtraDroppedItemList;
extern const void * RTTI_ExtraSavedAnimation;
extern const void * RTTI_ExtraSavedHavokData;
extern const void * RTTI_ExtraRefractionProperty;
extern const void * RTTI_ExtraSound;
extern const void * RTTI_ExtraCreatureMovementSound;
extern const void * RTTI_ExtraActivateLoopSound;
extern const void * RTTI_ExtraFactionChanges;
extern const void * RTTI_ExtraSayTopicInfoOnceADay;
extern const void * RTTI_ExtraEncounterZone;
extern const void * RTTI_ExtraRoomRefData;
extern const void * RTTI_ExtraPatrolRefInUseData;
extern const void * RTTI_ExtraFollowerSwimBreadcrumbs;
extern const void * RTTI_ExtraAliasInstanceArray;
extern const void * RTTI_ExtraDecalGroup;
extern const void * RTTI_ExtraCanTalkToPlayer;
extern const void * RTTI_ExtraSayToTopicInfo;
extern const void * RTTI_ExtraInteraction;
extern const void * RTTI_ExtraLockList;
extern const void * RTTI_ExtraSoul;
extern const void * RTTI_ExtraPackageStartLocation;
extern const void * RTTI_ExtraMasterFileCell;
extern const void * RTTI_ExtraMasterLocation;
extern const void * RTTI_ExtraPersistentCell;
extern const void * RTTI_ExtraRagDollData;
extern const void * RTTI_ExtraUsedMarkers;
extern const void * RTTI_ExtraReservedMarkers;
extern const void * RTTI_ExtraAshPileRef;
extern const void * RTTI_ExtraLeveledItemBase;
extern const void * RTTI_ExtraLevCreaModifier;
extern const void * RTTI_ExtraSpawnContainer;
extern const void * RTTI_ExtraAcousticParent;
extern const void * RTTI_ExtraEmittanceSource;
extern const void * RTTI_ExtraMultiBoundData;
extern const void * RTTI_ExtraMultiBoundRef;
extern const void * RTTI_ExtraMultiBound;
extern const void * RTTI_ExtraPortal;
extern const void * RTTI_ExtraRoom;
extern const void * RTTI_ExtraOcclusionShape;
extern const void * RTTI_ExtraFriendHits;
extern const void * RTTI_ExtraStartingWorldOrCell;
extern const void * RTTI_ExtraEditorRef3DData;
extern const void * RTTI_ExtraEditorRefMoveData;
extern const void * RTTI_ExtraGuardedRefData;
extern const void * RTTI_ExtraIgnoredBySandbox;
extern const void * RTTI_ExtraPromotedRef;
extern const void * RTTI_ExtraAnimationSequencer;
extern const void * RTTI_ExtraRefrPath;
extern const void * RTTI_ExtraCellGrassData;
extern const void * RTTI_ExtraWaterData;
extern const void * RTTI_ExtraGroupConstraint;
extern const void * RTTI_ExtraScriptedAnimDependence;
extern const void * RTTI_ExtraRaceData;
extern const void * RTTI_ExtraMagicCaster;
extern const void * RTTI_ExtraBendableSplineParams;
extern const void * RTTI_ExtraInstanceData;
extern const void * RTTI_ExtraPowerArmor;
extern const void * RTTI_ExtraPowerArmorPreload;
extern const void * RTTI_ExtraInputEnableLayer;
extern const void * RTTI_ExtraDirectAtTarget;
extern const void * RTTI_ExtraRefWeaponSounds;
extern const void * RTTI_ExtraAnimGraphPreload;
extern const void * RTTI_ExtraFurnitureEntryData;
extern const void * RTTI_BSTextureDB__QueuedHandlesWithCallback;
extern const void * RTTI_QueuedActor;
extern const void * RTTI_QueuedCharacter;
extern const void * RTTI_QueuedHead;
extern const void * RTTI_AttachDistant3DTask;
extern const void * RTTI_QueuedModel;
extern const void * RTTI_QueuedReference;
extern const void * RTTI_QueuedAnimationObject;
extern const void * RTTI_BackgroundProcessThread;
extern const void * RTTI_Scaleform__SysAllocBase;
extern const void * RTTI_Scaleform__SysAlloc;
extern const void * RTTI_Scaleform__SysAllocMalloc;
extern const void * RTTI_Scaleform__AcquireInterface;
extern const void * RTTI_QueuedTree;
extern const void * RTTI_QueuedPlayer;
extern const void * RTTI_INIPrefSettingCollection;
extern const void * RTTI_TES;
extern const void * RTTI_AddCellGrassTask;
extern const void * RTTI_BGSLoadFormBuffer;
extern const void * RTTI_BGSStoryManagerBranchNode;
extern const void * RTTI_NEW_REFR_DATA;
extern const void * RTTI_TESDataHandler__ArchiveRegistrationListener;
extern const void * RTTI_TESDataHandler__PSGRegistrationListener;
extern const void * RTTI_BGSStoryManagerTreeForm;
extern const void * RTTI_BGSStoryManagerNodeBase;
extern const void * RTTI_BSModelDB__BSModelProcessor;
extern const void * RTTI_BGSAttackDataForm;
extern const void * RTTI_BGSBipedObjectForm;
extern const void * RTTI_BGSBlockBashData;
extern const void * RTTI_BGSDestructibleObjectForm;
extern const void * RTTI_BGSEquipType;
extern const void * RTTI_BGSIdleCollection;
extern const void * RTTI_IKeywordFormBase;
extern const void * RTTI_BGSKeywordForm;
extern const void * RTTI_BGSMenuDisplayObject;
extern const void * RTTI_BGSMessageIcon;
extern const void * RTTI_BGSOverridePackCollection;
extern const void * RTTI_PerkRankVisitor;
extern const void * RTTI_BGSPerkRankArray;
extern const void * RTTI_BGSPickupPutdownSounds;
extern const void * RTTI_BGSSkinForm;
extern const void * RTTI_TESActorBaseData;
extern const void * RTTI_TESAIForm;
extern const void * RTTI_TESAttackDamageForm;
extern const void * RTTI_TESModelRDT;
extern const void * RTTI_TESBipedModelForm;
extern const void * RTTI_TESContainer;
extern const void * RTTI_TESDescription;
extern const void * RTTI_TESEnchantableForm;
extern const void * RTTI_TESForm;
extern const void * RTTI_IFormFactory__IFactoryVisitor;
extern const void * RTTI_BSStorage;
extern const void * RTTI_BSMemStorage;
extern const void * RTTI_BSVMLoadTask;
extern const void * RTTI_TESHealthForm;
extern const void * RTTI_TESIcon;
extern const void * RTTI_TESImageSpaceModifiableForm;
extern const void * RTTI_TESLeveledList;
extern const void * RTTI_TESModel;
extern const void * RTTI_TESProduceForm;
extern const void * RTTI_TESRaceForm;
extern const void * RTTI_TESReactionForm;
extern const void * RTTI_TESSpellList;
extern const void * RTTI_TESTexture;
extern const void * RTTI_TESValueForm;
extern const void * RTTI_TESWeightForm;
extern const void * RTTI_ActionInput;
extern const void * RTTI_BSAttachTechniques__BSAttachTechnique;
extern const void * RTTI_BGSAttachTechniquesUtil__ProcessTechniquesFunctor;
extern const void * RTTI_BGSAttachTechniquesUtil__AttachTechniquesFunctor;
extern const void * RTTI_BGSAttachTechniquesUtil__DetachTechniquesFunctor;
extern const void * RTTI_BGSParticleArrayAttach;
extern const void * RTTI_BGSParticleArrayAttach__EmitterPolicy;
extern const void * RTTI_BGSParticleArrayAttach__CollectEmitterPolicy;
extern const void * RTTI_BGSParticleArrayAttach__ClearEmitterPolicy;
extern const void * RTTI_BGSHavokGeometryAttach;
extern const void * RTTI_BGSHavokGeometryAttach__ActionPolicy;
extern const void * RTTI_BGSHavokGeometryAttach__AttachPolicy;
extern const void * RTTI_BGSHavokGeometryAttach__DetachPolicy;
extern const void * RTTI_BGSNamedNodeAttach;
extern const void * RTTI_BGSNamedNodeAttach__ActionPolicy;
extern const void * RTTI_BGSNamedNodeAttach__AttachPolicy;
extern const void * RTTI_BGSNamedNodeAttach__DetachPolicy;
extern const void * RTTI_BGSMultiTechniqueAttach;
extern const void * RTTI_BGSMultiTechniqueAttach__ActionPolicy;
extern const void * RTTI_BGSMultiTechniqueAttach__AttachPolicy;
extern const void * RTTI_BGSMultiTechniqueAttach__DetachPolicy;
extern const void * RTTI_ITempEffectFactory;
extern const void * RTTI_BSMultiBoundAABB;
extern const void * RTTI_BSMultiBoundOBB;
extern const void * RTTI_BGSDecalNode;
extern const void * RTTI_QueuedPromoteReferencesTask;
extern const void * RTTI_BSResource__Location;
extern const void * RTTI_BSResource__LooseFileLocation;
extern const void * RTTI_BGSQueuedGrassModelHandles;
extern const void * RTTI_hknpShape;
extern const void * RTTI_hknpConvexShape;
extern const void * RTTI_hknpSphereShape;
extern const void * RTTI_IRaceSubGraphDataFunctor;
extern const void * RTTI_InteractionCombatDataCollectFunctor;
extern const void * RTTI_BGSInventoryItem__StackDataCompareFunctor;
extern const void * RTTI_BGSInventoryItem__CheckStackIDFunctor;
extern const void * RTTI_BGSInventoryItem__CheckExtraDataFunctor;
extern const void * RTTI_BGSInventoryItem__StackDataWriteFunctor;
extern const void * RTTI_BGSInventoryItem__ModCountFunctor;
extern const void * RTTI_SetPlayerHasTakenStackFunctor;
extern const void * RTTI_RemoveExtraFunctor;
extern const void * RTTI_BGSInventoryItem__Stack;
extern const void * RTTI_BGSInventoryItem__FindEquippedStackFunctor;
extern const void * RTTI_BGSInventoryItem__IsUIEquivalentStackFunctor;
extern const void * RTTI_BGSInventoryItem__SetFlagFunctor;
extern const void * RTTI_MatchEquippedAndFavoriteDataFunctor;
extern const void * RTTI_IsFavoriteFunctor;
extern const void * RTTI_SetFavoriteFunctor;
extern const void * RTTI_RemoveFavoriteFunctor;
extern const void * RTTI_SetPoisonFunctor;
extern const void * RTTI_SetEnchantmentFunctor;
extern const void * RTTI_BGSInventoryItem__HasExtraDataFunctor;
extern const void * RTTI_RefMatchFunctor;
extern const void * RTTI_RemoveQuestAliasFunctor;
extern const void * RTTI_SetTimeLeftFunctor;
extern const void * RTTI_ModTimeLeftFunctor;
extern const void * RTTI_ProcessWeaponStrikeMagicFunctor;
extern const void * RTTI_SetItemOwnershipFunctor;
extern const void * RTTI_SetItemOriginalReferenceFunctor;
extern const void * RTTI_BSConnectPoint__ChildOrigin;
extern const void * RTTI_BGSObjectVisibilityManager;
extern const void * RTTI_BSPortal;
extern const void * RTTI_BGSPrimitiveLine;
extern const void * RTTI_BGSPrimitivePlane;
extern const void * RTTI_BGSPrimitiveBox;
extern const void * RTTI_BGSPrimitiveSphere;
extern const void * RTTI_BGSPrimitiveEllipsoid;
extern const void * RTTI_BGSPrimitive;
extern const void * RTTI_BSMultiBoundSphere;
extern const void * RTTI_ReferenceEffectController;
extern const void * RTTI_OwnedController;
extern const void * RTTI_BSAttachRefController;
extern const void * RTTI_BSCloneReserver;
extern const void * RTTI_NiProperty;
extern const void * RTTI_NiAlphaProperty;
extern const void * RTTI_GridArray;
extern const void * RTTI_GridCellArray;
extern const void * RTTI_BSExternalAudioIO__ExternalIOInterface;
extern const void * RTTI_LipSynchAnimDB__LipAudioInterface;
extern const void * RTTI_BSInputEventUser;
extern const void * RTTI_TESCameraState;
extern const void * RTTI_LocalMapCamera;
extern const void * RTTI_LocalMapCamera__DefaultState;
extern const void * RTTI_BSSplatterExtraData;
extern const void * RTTI_hknpConvexPolytopeShape;
extern const void * RTTI_hknpCapsuleShape;
extern const void * RTTI_IMessageBoxCallback;
extern const void * RTTI_ExamineConfirmMenu__ICallback;
extern const void * RTTI_hknpUniqueBodyIdHitCollector;
extern const void * RTTI_hknpAnyHitCollector;
extern const void * RTTI_hknpFlippedShapeCastQueryCollector;
extern const void * RTTI_Workshop__hknpWorkshopCastCollector;
extern const void * RTTI_Workshop__CheckBuildRadiusCollector;
extern const void * RTTI_Workshop__hknpCheckShelterHitsCollector;
extern const void * RTTI_Workshop__RequestScrapCallback;
extern const void * RTTI_Workshop__RequestStoreCallback;
extern const void * RTTI_Workshop__RequestRepairCallback;
extern const void * RTTI_Workshop__hknpWorkshopIntersectCollector;
extern const void * RTTI_Workshop__hknpClosestConnectPointCollector;
extern const void * RTTI_Workshop__hknpCountIntersectingRefsCollector;
extern const void * RTTI_Workshop__ForwardCastCollector;
extern const void * RTTI_Workshop__GroundIntersectCollector;
extern const void * RTTI_Workshop__MainStatusHandler;
extern const void * RTTI_Workshop__WorkshopReferenceEventSink;
extern const void * RTTI_std__error_category;
extern const void * RTTI_std___Generic_error_category;
extern const void * RTTI_std___Iostream_error_category;
extern const void * RTTI_NVFlex__DebrisInstanceManager;
extern const void * RTTI_NVFlex__DebrisNode;
extern const void * RTTI_NVFlex__DebrisRenderer;
extern const void * RTTI_NVFlex__FlexThread;
extern const void * RTTI_hkGeometry;
extern const void * RTTI_MovementHandlerAgentAnimationDriven;
extern const void * RTTI_MovementHandlerAgentGraphDrivenAnimationDriven;
extern const void * RTTI_IPipelineStageInterface;
extern const void * RTTI_IMovementTweenerAgent;
extern const void * RTTI_IMovementInterface;
extern const void * RTTI_IMovementQueryDesiredDeltas;
extern const void * RTTI_IMovementSetPlayerControls;
extern const void * RTTI_MovementHandlerAgentPlayerControls;
extern const void * RTTI_NavMeshObstacleCoverManager;
extern const void * RTTI_BSPathingStreamRead;
extern const void * RTTI_PathingStreamMasterFileRead;
extern const void * RTTI_QuestPathingRequest;
extern const void * RTTI_IPathBuilderFactoryBase;
extern const void * RTTI_TESRegion;
extern const void * RTTI_TESRegionData;
extern const void * RTTI_TESRegionDataGrass;
extern const void * RTTI_TESRegionDataLandscape;
extern const void * RTTI_TESRegionDataManager;
extern const void * RTTI_TESRegionDataMap;
extern const void * RTTI_TESRegionDataObjects;
extern const void * RTTI_TESRegionDataSound;
extern const void * RTTI_TESRegionDataWeather;
extern const void * RTTI_TESRegionObjectBase;
extern const void * RTTI_TESRegionGrassObject;
extern const void * RTTI_TESRegionGrassObjectList;
extern const void * RTTI_TESRegionList;
extern const void * RTTI_TESRegionNoiseFunction;
extern const void * RTTI_TESRegionObject;
extern const void * RTTI_TESRegionObjectList;
extern const void * RTTI_BGSAttractionRule;
extern const void * RTTI_BGSCharacterTint__Entry;
extern const void * RTTI_BGSCharacterTint__MaskEntry;
extern const void * RTTI_BGSCharacterTint__PaletteEntry;
extern const void * RTTI_BGSCharacterTint__Template__Entry;
extern const void * RTTI_BGSCharacterTint__Template__Mask;
extern const void * RTTI_BGSCharacterTint__Template__Palette;
extern const void * RTTI_BGSCharacterTint__TextureSetEntry;
extern const void * RTTI_BGSCharacterTint__Template__TextureSet;
extern const void * RTTI_BGSRefCollectionAlias;
extern const void * RTTI_BSShaderMaterialExtraData;
extern const void * RTTI_BSDismembermentLimbExtraData;
extern const void * RTTI_BSDismembermentExtraData;
extern const void * RTTI_BGSSceneAction;
extern const void * RTTI_BGSSceneActionConversationBase;
extern const void * RTTI_BGSSceneActionPlayerDialogue;
extern const void * RTTI_BGSSceneActionStartScene;
extern const void * RTTI_BSIAudioEffectChain;
extern const void * RTTI_BGSAudioEffectChain;
extern const void * RTTI_BSISoundDescriptor;
extern const void * RTTI_BGSSoundDescriptor;
extern const void * RTTI_BGSAutoWeaponSoundDef;
extern const void * RTTI_BGSComponent;
extern const void * RTTI_BGSCompoundSoundDef;
extern const void * RTTI_BGSDamageType;
extern const void * RTTI_BGSDefaultObject;
extern const void * RTTI_BGSInstanceNamingRules;
extern const void * RTTI_BGSMaterialSwap;
extern const void * RTTI_BGSSoundCategorySnapshot;
extern const void * RTTI_BGSSoundKeywordMapping;
extern const void * RTTI_BGSSoundTagSet;
extern const void * RTTI_BGSTransform;
extern const void * RTTI_BGSAddonNode;
extern const void * RTTI_BGSAddonNodeSoundHandleExtra;
extern const void * RTTI_BGSAimModel;
extern const void * RTTI_BGSArtObject;
extern const void * RTTI_BGSArtObjectCloneTask;
extern const void * RTTI_BGSBendableSpline;
extern const void * RTTI_BGSConstructibleObject;
extern const void * RTTI_BGSDebris;
extern const void * RTTI_BGSPreloadable;
extern const void * RTTI_BGSExplosion;
extern const void * RTTI_BGSHazard;
extern const void * RTTI_BGSLensFlare;
extern const void * RTTI_BSLensFlareSpriteRenderData;
extern const void * RTTI_BGSLensFlareSprite;
extern const void * RTTI_BGSMovableStatic;
extern const void * RTTI_BGSMod__Attachment__Mod;
extern const void * RTTI_BGSOutfit;
extern const void * RTTI_BGSPackIn;
extern const void * RTTI_BGSProjectile;
extern const void * RTTI_BGSStaticCollection;
extern const void * RTTI_BGSStaticCollection__RootFacade;
extern const void * RTTI_BGSTalkingActivator;
extern const void * RTTI_BGSTerminal;
extern const void * RTTI_BGSZoomData;
extern const void * RTTI_TESAmmo;
extern const void * RTTI_TESCombatStyle;
extern const void * RTTI_TESEffectShader;
extern const void * RTTI_TESFlora;
extern const void * RTTI_BGSMod__Property__BridgeI;
extern const void * RTTI_TESFurniture;
extern const void * RTTI_TESGrass;
extern const void * RTTI_TESKey;
extern const void * RTTI_TESLevCharacter;
extern const void * RTTI_TESLevItem;
extern const void * RTTI_TESLevSpell;
extern const void * RTTI_BGSOpenCloseForm;
extern const void * RTTI_TESObjectLIGH;
extern const void * RTTI_TESBoundObject;
extern const void * RTTI_TBO_InstanceData;
extern const void * RTTI_TESObject;
extern const void * RTTI_TESBoundAnimObject;
extern const void * RTTI_TESObjectACTI;
extern const void * RTTI_TESObjectANIO;
extern const void * RTTI_TESObjectARMA;
extern const void * RTTI_TESObjectARMO;
extern const void * RTTI_TESObjectARMO__InstanceData;
extern const void * RTTI_TESObjectBOOK;
extern const void * RTTI_TESObjectCONT;
extern const void * RTTI_TESObjectDOOR;
extern const void * RTTI_IFadeDoneCallback;
extern const void * RTTI_TESObjectMISC;
extern const void * RTTI_TESObjectSTAT;
extern const void * RTTI_TESObjectTREE;
extern const void * RTTI_TESObjectWEAP;
extern const void * RTTI_TESObjectWEAP__InstanceData;
extern const void * RTTI_TESObjectWEAP__Data;
extern const void * RTTI_TESSoulGem;
extern const void * RTTI_BSStaticTriShapeDB__IBatchRequestIter;
extern const void * RTTI_BGSCombinedCellGeometryDB__LoadTask;
extern const void * RTTI_BGSCombinedCellGeometryDB__ModelDB__QueuedHandles;
extern const void * RTTI_BGSCombinedCellGeometryDB__CDX;
extern const void * RTTI_BGSCombinedCellGeometryDB__CDX__PsgBatchIter;
extern const void * RTTI_BGSCombinedCellGeometryDB__PreloadTask;
extern const void * RTTI_BGSCombinedCellGeometryDB__Unpacker__Thread;
extern const void * RTTI_BGSEncounterZone;
extern const void * RTTI_BGSGodRays;
extern const void * RTTI_QueuedPromoteLargeReferencesTask;
extern const void * RTTI_BGSLightingTemplate;
extern const void * RTTI_BGSLocation;
extern const void * RTTI_QueuedPromoteLocationReferencesTask;
extern const void * RTTI_BGSLocationRefType;
extern const void * RTTI_BGSReferenceEffect;
extern const void * RTTI_BGSReferenceGroup;
extern const void * RTTI_BSParticleShaderEmitter;
extern const void * RTTI_BSParticleShaderCubeEmitter;
extern const void * RTTI_BSParticleShaderSnowEmitter;
extern const void * RTTI_BSParticleShaderRainEmitter;
extern const void * RTTI_BGSShaderParticleGeometryData;
extern const void * RTTI_CellLoaderTask;
extern const void * RTTI_ImageSpaceModifierInstanceForm;
extern const void * RTTI_ImageSpaceModifierInstance;
extern const void * RTTI_ImageSpaceModifierInstanceTemp;
extern const void * RTTI_ImageSpaceModifierInstanceDOF;
extern const void * RTTI_ImageSpaceModifierInstanceRB;
extern const void * RTTI_TESClimate;
extern const void * RTTI_TESImageSpace;
extern const void * RTTI_NiFloatData;
extern const void * RTTI_NiColorData;
extern const void * RTTI_TESImageSpaceModifier;
extern const void * RTTI_TESChildCell;
extern const void * RTTI_TESObjectLAND;
extern const void * RTTI_hknpBSMaterialProperties;
extern const void * RTTI_TESLandTexture;
extern const void * RTTI_hkSlot;
extern const void * RTTI_TESObjectCELL;
extern const void * RTTI_TESObjectCELL__IDecalRefFunctor;
extern const void * RTTI_BSHandleRefObject;
extern const void * RTTI_TESObjectREFR;
extern const void * RTTI_ActorValueOwner;
extern const void * RTTI_BGSInventoryItem__ClearEquipFlagsFunctor;
extern const void * RTTI_BGSInventoryList__InventoryWeightFunctor;
extern const void * RTTI_TESObjectREFR__HandleOutfitItemsFunctor;
extern const void * RTTI_OwnedCameraEffectController;
extern const void * RTTI_BSInputEnableManager__IDebugNameFunctor;
extern const void * RTTI_RemoveOutfitItemsFunctor;
extern const void * RTTI_CalcContainerWeight;
extern const void * RTTI_InventoryScoringFunctor;
extern const void * RTTI_GetBestWeaponFunctor;
extern const void * RTTI_GetBestAmmoFunctor;
extern const void * RTTI_GetBestArmorFunctor;
extern const void * RTTI_GetBestLightFunctor;
extern const void * RTTI_IAnimationStreamWrite;
extern const void * RTTI_IAnimationStreamRead;
extern const void * RTTI_BSAnimGraphVisit__BShkbVisitor;
extern const void * RTTI_AnimationStreamLoadGame;
extern const void * RTTI_AnimationStreamSaveGame;
extern const void * RTTI_REFREventCallbacks__IEventCallback;
extern const void * RTTI_REFREventCallbacks__IEventCallbackFactory;
extern const void * RTTI_TESObjectREFRSync__REFRSyncController;
extern const void * RTTI_TESWaterForm;
extern const void * RTTI_TESTexture1024;
extern const void * RTTI_TESWeather;
extern const void * RTTI_TESWorldSpace;
extern const void * RTTI_BGSAcousticSpace;
extern const void * RTTI_NiFormArray;
extern const void * RTTI_BGSCameraPath;
extern const void * RTTI_BGSCameraShot;
extern const void * RTTI_BGSCollisionLayer;
extern const void * RTTI_BGSColorForm;
extern const void * RTTI_BGSDefaultObjectManager;
extern const void * RTTI_BGSFootstep;
extern const void * RTTI_BGSFootstepSet;
extern const void * RTTI_BGSImpactData;
extern const void * RTTI_BGSImpactDataSet;
extern const void * RTTI_BGSListForm;
extern const void * RTTI_BSMaterialObject;
extern const void * RTTI_BGSMaterialObject;
extern const void * RTTI_BGSMaterialType;
extern const void * RTTI_BGSMenuIcon;
extern const void * RTTI_BGSMessage;
extern const void * RTTI_BGSMusicPaletteTrack;
extern const void * RTTI_BGSMusicSilenceTrack;
extern const void * RTTI_BGSMusicSingleTrack;
extern const void * RTTI_BSIMusicTrack;
extern const void * RTTI_BGSMusicTrack;
extern const void * RTTI_BGSMusicTrackFormWrapper;
extern const void * RTTI_BSIMusicType;
extern const void * RTTI_BGSMusicType;
extern const void * RTTI_BSIReverbType;
extern const void * RTTI_BGSReverbParameters;
extern const void * RTTI_BSISoundCategory;
extern const void * RTTI_BGSSoundCategory;
extern const void * RTTI_BGSSoundDescriptorForm;
extern const void * RTTI_BSISoundOutputModel;
extern const void * RTTI_BSISoundOutputModel__BSIAttenuationCharacteristics;
extern const void * RTTI_BGSSoundOutput;
extern const void * RTTI_BGSSoundOutput__DynamicAttenuationCharacteristics;
extern const void * RTTI_BSISoundDescriptor__BSIPlaybackCharacteristics;
extern const void * RTTI_BGSStandardSoundDef;
extern const void * RTTI_BGSStandardSoundDef__SoundPlaybackCharacteristics;
extern const void * RTTI_BSShaderTextureSet;
extern const void * RTTI_BSTextureSet;
extern const void * RTTI_BGSTextureSet;
extern const void * RTTI_IVisitProcedures;
extern const void * RTTI_MiscStatManager__IMiscStatVisitor;
extern const void * RTTI_MiscStatManager__FindStatByCRC;
extern const void * RTTI_TESGlobal;
extern const void * RTTI_TESLoadScreen;
extern const void * RTTI_Script;
extern const void * RTTI_MovementLargeDelta__IEnumVisitor;
extern const void * RTTI_DefaultMessageBoxCallback;
extern const void * RTTI_BSStream;
extern const void * RTTI_IUIMessageData;
extern const void * RTTI_MobIterOperator;
extern const void * RTTI_ConsoleData;
extern const void * RTTI_TESShout;
extern const void * RTTI_TESSound;
extern const void * RTTI_TESWordOfPower;
extern const void * RTTI_BGSAction;
extern const void * RTTI_BGSAssociationType;
extern const void * RTTI_BGSBodyPartData;
extern const void * RTTI_BGSDialogueBranch;
extern const void * RTTI_PerkEntryVisitor;
extern const void * RTTI_BGSEntryPointFunctionData;
extern const void * RTTI_BGSEntryPointFunctionDataOneValue;
extern const void * RTTI_BGSEntryPointFunctionDataTwoValue;
extern const void * RTTI_BGSEntryPointFunctionDataAVAndValue;
extern const void * RTTI_BGSEntryPointFunctionDataLeveledList;
extern const void * RTTI_BGSEntryPointFunctionDataSpellItem;
extern const void * RTTI_BGSEntryPointFunctionDataBooleanGraphVariable;
extern const void * RTTI_BGSEntryPointFunctionDataText;
extern const void * RTTI_BGSEntryPointFunctionDataActivateChoice;
extern const void * RTTI_BGSEquipSlot;
extern const void * RTTI_TESModelTri;
extern const void * RTTI_BGSHeadPart;
extern const void * RTTI_BGSIdleMarker;
extern const void * RTTI_BGSKeyword;
extern const void * RTTI_BGSBaseAlias;
extern const void * RTTI_BGSLocAlias;
extern const void * RTTI_BGSMovementType;
extern const void * RTTI_BGSNote;
extern const void * RTTI_BGSPerkEntry;
extern const void * RTTI_BGSPerk;
extern const void * RTTI_BGSQuestPerkEntry;
extern const void * RTTI_BGSAbilityPerkEntry;
extern const void * RTTI_BGSEntryPointPerkEntry;
extern const void * RTTI_BGSRefAlias;
extern const void * RTTI_BGSRelationship;
extern const void * RTTI_BGSScene;
extern const void * RTTI_BGSSceneActionDialogue;
extern const void * RTTI_BGSSceneActionPackage;
extern const void * RTTI_BGSSceneActionNPCResponseDialogue;
extern const void * RTTI_BGSSceneActionRadio;
extern const void * RTTI_BGSSceneActionTimer;
extern const void * RTTI_BGSVoiceType;
extern const void * RTTI_Reset3DMobIterator;
extern const void * RTTI_TESClass;
extern const void * RTTI_TESEyes;
extern const void * RTTI_TESFaction;
extern const void * RTTI_TESIdleForm;
extern const void * RTTI_TESActorBase;
extern const void * RTTI_TESNPC;
extern const void * RTTI_TESNPC__InstanceData;
extern const void * RTTI_BSTransformExtra;
extern const void * RTTI_TESQuest;
extern const void * RTTI_QueuedPromoteQuestTask;
extern const void * RTTI_BGSTextureModel;
extern const void * RTTI_BGSBehaviorGraphModel;
extern const void * RTTI_TESRace;
extern const void * RTTI_TESTopic;
extern const void * RTTI_TESTopicInfo;
extern const void * RTTI_ZoneEntry;
extern const void * RTTI_TargetEntry;
extern const void * RTTI_BGSZoneTargetListener;
extern const void * RTTI_TrapTargetEntry;
extern const void * RTTI_FOCollisionListener;
extern const void * RTTI_hkStreamWriter;
extern const void * RTTI_hknpModifier;
extern const void * RTTI_hkError;
extern const void * RTTI_hkStreamReader;
extern const void * RTTI_hkFileSystem;
extern const void * RTTI_HavokFileStreambufReader;
extern const void * RTTI_HavokFileStreambufWriter;
extern const void * RTTI_RagdollFurnitureModifier;
extern const void * RTTI_hkWin32FileSystem;
extern const void * RTTI_HavokStreambufFactory;
extern const void * RTTI_HavokError;
extern const void * RTTI_LoadedAreaBound;
extern const void * RTTI_SpecificItemCollector;
extern const void * RTTI_bhkTrapListener;
extern const void * RTTI_TrapEntry;
extern const void * RTTI_TESTrapListener;
extern const void * RTTI_Atmosphere;
extern const void * RTTI_Clouds;
extern const void * RTTI_NiBillboardNode;
extern const void * RTTI_Moon;
extern const void * RTTI_Precipitation;
extern const void * RTTI_Sky;
extern const void * RTTI_TESWeather__SkyStaticFunctor;
extern const void * RTTI_SkyEffectController;
extern const void * RTTI_SkyStaticFindFunctor;
extern const void * RTTI_TempLoadGameBuffer;
extern const void * RTTI_SkyObject;
extern const void * RTTI_Stars;
extern const void * RTTI_Sun;
extern const void * RTTI_BShkNonTransformController;
extern const void * RTTI_BShkFloatController;
extern const void * RTTI_BGShkPhonemeController;
extern const void * RTTI_BSFaceGenAnimationData;
extern const void * RTTI_FutBinaryFileC;
extern const void * RTTI_BSResourceFaceGenBinaryFile;
extern const void * RTTI_BSFaceGenPendingHeadData;
extern const void * RTTI_BSFaceGenDB__TRI__QueuedHandles;
extern const void * RTTI_BSFaceGenModel;
extern const void * RTTI_BSFaceGenModelExtraData;
extern const void * RTTI_BSFaceGenModelMap__Entry;
extern const void * RTTI_BSFaceGenMorphData;
extern const void * RTTI_BSFaceGenMorphDataHead;
extern const void * RTTI_BSFaceGenMorphDataHair;
extern const void * RTTI_BSFaceGenBaseMorphExtraData;
extern const void * RTTI_BSFaceGenNiNode;
extern const void * RTTI_BSFadeNodeCuller;
extern const void * RTTI_ActorValueInfo;
extern const void * RTTI_BGSAttackData;
extern const void * RTTI_BGSAttackDataMap;
extern const void * RTTI_IPackageData;
extern const void * RTTI_IAIWorldLocationHandle;
extern const void * RTTI_IPackageDataAIWorldLocationHandle;
extern const void * RTTI_IAITarget;
extern const void * RTTI_BGSPackageDataBool;
extern const void * RTTI_BGSPackageDataFloat;
extern const void * RTTI_BGSPackageDataInt;
extern const void * RTTI_BGSPackageDataRefOLD;
extern const void * RTTI_BGSPackageDataLocation;
extern const void * RTTI_BGSPackageDataLocationWrapper;
extern const void * RTTI_BGSPackageDataTargetSelector;
extern const void * RTTI_BGSPackageDataObjectList;
extern const void * RTTI_ObjectListItem;
extern const void * RTTI_BGSPackageDataRef;
extern const void * RTTI_BGSPackageDataTopic;
extern const void * RTTI_IProcedureTreeItem;
extern const void * RTTI_BGSProcedureDoneExecState;
extern const void * RTTI_BGSProcedureTreeConditionalItem;
extern const void * RTTI_BGSProcedureTreeBranch;
extern const void * RTTI_BGSProcedureTreeOneChildExecState;
extern const void * RTTI_BGSProcedureTreeSequence;
extern const void * RTTI_BGSProcedureTreeSequenceExecState;
extern const void * RTTI_BGSProcedureTreeStacked;
extern const void * RTTI_BGSProcedureTreeStackedExecState;
extern const void * RTTI_BGSProcedureTreeSimultaneous;
extern const void * RTTI_BGSProcedureTreeSimultaneousExecState;
extern const void * RTTI_BGSProcedureTreeRandom;
extern const void * RTTI_BGSProcedureTreeRandomExecState;
extern const void * RTTI_BGSProcedureDialogueExecState;
extern const void * RTTI_BGSProcedureEatExecState;
extern const void * RTTI_BGSProcedureFindExecState;
extern const void * RTTI_BGSProcedureHoldPositionExecState;
extern const void * RTTI_BGSProcedureKeepAnEyeOnExecState;
extern const void * RTTI_BGSProcedureSayExecState;
extern const void * RTTI_BGSProcedureWaitExecState;
extern const void * RTTI_BGSProcedureDone;
extern const void * RTTI_BGSProcedureAcquire;
extern const void * RTTI_BGSProcedureAcquireExecState;
extern const void * RTTI_BGSProcedureActivate;
extern const void * RTTI_BGSProcedureActivateExecState;
extern const void * RTTI_BGSProcedureDialogue;
extern const void * RTTI_BGSProcedureDialogueActivate;
extern const void * RTTI_BGSProcedureDialogueActivateExecState;
extern const void * RTTI_BGSProcedureEat;
extern const void * RTTI_BGSProcedureEscort;
extern const void * RTTI_BGSProcedureEscortExecState;
extern const void * RTTI_BGSProcedureFind;
extern const void * RTTI_BGSProcedureFlee;
extern const void * RTTI_BGSProcedureFleeExecState;
extern const void * RTTI_BGSProcedureFlightGrab;
extern const void * RTTI_BGSProcedureFlightGrabExecState;
extern const void * RTTI_BGSProcedureFollow;
extern const void * RTTI_BGSProcedureFollowTo;
extern const void * RTTI_BGSProcedureFollowExecState;
extern const void * RTTI_BGSProcedureForceGreet;
extern const void * RTTI_BGSProcedureGuard;
extern const void * RTTI_BGSProcedureGuardArea;
extern const void * RTTI_BGSProcedureGuardExecState;
extern const void * RTTI_BGSProcedureHoldPosition;
extern const void * RTTI_BGSProcedureHover;
extern const void * RTTI_BGSProcedureHoverExecState;
extern const void * RTTI_BGSProcedureKeepAnEyeOn;
extern const void * RTTI_BGSProcedureLock;
extern const void * RTTI_BGSProcedureUnlock;
extern const void * RTTI_BGSProcedureLockUnlockExecState;
extern const void * RTTI_BGSProcedureOrbit;
extern const void * RTTI_BGSProcedureOrbitExecState;
extern const void * RTTI_BGSProcedurePatrolExecState;
extern const void * RTTI_BGSProcedurePatrol;
extern const void * RTTI_BGSProcedurePursue;
extern const void * RTTI_BGSProcedureSandboxExecState;
extern const void * RTTI_BGSProcedureSandbox;
extern const void * RTTI_BGSProcedureSay;
extern const void * RTTI_BGSProcedureSit;
extern const void * RTTI_BGSProcedureSleep;
extern const void * RTTI_BGSProcedureSitSleepExecState;
extern const void * RTTI_BGSProcedureTravel;
extern const void * RTTI_BGSProcedureTravelExecState;
extern const void * RTTI_BGSProcedureTreeProcedure;
extern const void * RTTI_BGSProcedureUseIdleMarker;
extern const void * RTTI_BGSProcedureUseIdleMarkerExecState;
extern const void * RTTI_BGSProcedureUseMagic;
extern const void * RTTI_BGSProcedureUseMagicExecState;
extern const void * RTTI_BGSProcedureUseWeapon;
extern const void * RTTI_BGSProcedureUseWeaponExecState;
extern const void * RTTI_BGSProcedureWait;
extern const void * RTTI_BGSProcedureWander;
extern const void * RTTI_BGSProcedureWanderExecState;
extern const void * RTTI_BGSVisitProceduresInitActorLocation;
extern const void * RTTI_BGSVisitProceduresCheckGuardWarnTarget;
extern const void * RTTI_TESPackage;
extern const void * RTTI_PackageCreator;
extern const void * RTTI_DialoguePackage;
extern const void * RTTI_TESPackageData;
extern const void * RTTI_TESAmbushPackageData;
extern const void * RTTI_TESCustomPackageData;
extern const void * RTTI_IProcedureTreeVisitor;
extern const void * RTTI_CustomUtils__HasForceGreetVisitor;
extern const void * RTTI_TESDialoguePackageData;
extern const void * RTTI_TESEatPackageData;
extern const void * RTTI_TESEscortPackageData;
extern const void * RTTI_TESFollowPackageData;
extern const void * RTTI_TESPatrolPackageData;
extern const void * RTTI_TESUseItemPackageData;
extern const void * RTTI_TESUseWeaponPackageData;
extern const void * RTTI_ActorPackageData;
extern const void * RTTI_UseWeaponActorPackageData;
extern const void * RTTI_PackageLocation;
extern const void * RTTI_BSTempEffect;
extern const void * RTTI_BSTempEffectDebris;
extern const void * RTTI_BSTempEffectGeometryDecal;
extern const void * RTTI_BGSParticleObjectCloneTask;
extern const void * RTTI_BSTempEffectParticle;
extern const void * RTTI_BSTempEffectSPG;
extern const void * RTTI_BSTempEffectWeaponBlood;
extern const void * RTTI_BSTerrainEffect;
extern const void * RTTI_BSPSysHavokUpdateModifier__ICollisionObjectHandler;
extern const void * RTTI_NavMesh;
extern const void * RTTI_BSNavmeshInfoMap__IVisitor;
extern const void * RTTI_NavMeshInfoMap;
extern const void * RTTI_BSNavmeshReferenceObstacleArray;
extern const void * RTTI_ObstacleTaskData;
extern const void * RTTI_PathingCoverLocation;
extern const void * RTTI_BSPathingCellManager;
extern const void * RTTI_Pathing;
extern const void * RTTI_BSPathingCell;
extern const void * RTTI_PathingCell;
extern const void * RTTI_BSPathingDoor;
extern const void * RTTI_PathingDoor;
extern const void * RTTI_BSPathingLockData;
extern const void * RTTI_PathingLockData;
extern const void * RTTI_BSPathingNumericIDVisitor;
extern const void * RTTI_PathingNumericIDVisitor;
extern const void * RTTI_PathingRequest;
extern const void * RTTI_BSPathingSpace;
extern const void * RTTI_PathingSpace;
extern const void * RTTI_TeleportDoorSearch;
extern const void * RTTI_NavMeshSearchClosePoint;
extern const void * RTTI_NavMeshSearchFitSphere;
extern const void * RTTI_NavMeshSearchFlee;
extern const void * RTTI_NavMeshSearchHide;
extern const void * RTTI_BSNavmeshSearchHideFilter;
extern const void * RTTI_NavMeshSearchLOS;
extern const void * RTTI_NavMeshSearchMaxCost;
extern const void * RTTI_BSNavmeshSearchMaxCostFilters;
extern const void * RTTI_NavMeshSearchMultipleGoals;
extern const void * RTTI_NavMeshSearchSLPoint;
extern const void * RTTI_PathingRequestClosePoint;
extern const void * RTTI_PathingRequestClosestGoal;
extern const void * RTTI_PathingRequestCover;
extern const void * RTTI_PathingRequestFlee;
extern const void * RTTI_PathingRequestFly;
extern const void * RTTI_PathingRequestFlyAction;
extern const void * RTTI_PathingRequestFlyHover;
extern const void * RTTI_PathingRequestFlyLand;
extern const void * RTTI_PathingRequestFlyOrbit;
extern const void * RTTI_PathingRequestFlyTakeOff;
extern const void * RTTI_PathingRequestHide;
extern const void * RTTI_PathingRequestLOS;
extern const void * RTTI_PathingRequestOptimalLocation;
extern const void * RTTI_PathingRequestRotate;
extern const void * RTTI_PathingRequestSafeStraightLine;
extern const void * RTTI_PathingRequestStopMoving;
extern const void * RTTI_BGSQueuedTerrainUpdate;
extern const void * RTTI_BGSQueuedTerrainUpgrade;
extern const void * RTTI_BGSQueuedTerrainDowngrade;
extern const void * RTTI_BGSQueuedTerrainInitialLoad;
extern const void * RTTI_BGSQueuedObjectUpgrade;
extern const void * RTTI_BGSQueuedObjectDowngrade;
extern const void * RTTI_BGSQueuedObjectInitialLoad;
extern const void * RTTI_BGSWaterCollisionManager__BGSWaterUpdateI;
extern const void * RTTI_BGSWaterCollisionManager__bhkPlaceableWater;
extern const void * RTTI_BGSWaterCollisionManager__bhkWaterfall;
extern const void * RTTI_BGSWaterCollisionManager__AutoWater;
extern const void * RTTI_TESWaterObject;
extern const void * RTTI_TESWaterReflections;
extern const void * RTTI_TESWaterNormals;
extern const void * RTTI_TESWaterDisplacement;
extern const void * RTTI_BGSStoryManagerTreeVisitor;
extern const void * RTTI_BGSStoryManagerQuestFinder;
extern const void * RTTI_BGSStoryManager;
extern const void * RTTI_BGSStoryManagerEventNode;
extern const void * RTTI_BGSStoryManagerQuestNode;
extern const void * RTTI_BGSStoryTeller;
extern const void * RTTI_BGSLOSData;
extern const void * RTTI_AnimationSystemUtils__QueuedReferenceAnimationTask;
extern const void * RTTI_hkaRaycastInterface;
extern const void * RTTI_hkbSpatialQueryInterface;
extern const void * RTTI_BSIFootIkRaycastInterfaceDB;
extern const void * RTTI_CachedRaycastData;
extern const void * RTTI_BGSFootIkRaycastInterfaceDB;
extern const void * RTTI_IGamebryoSequenceGeneratorHolderSingleton;
extern const void * RTTI_BGSGamebryoSequenceGeneratorHolderSingleton;
extern const void * RTTI_ISynchronizedAnimationSingleton;
extern const void * RTTI_BGSSynchronizedAnimationInstance;
extern const void * RTTI_BGSSynchronizedAnimationManager;
extern const void * RTTI_SynchronizedAnimationSingleton;
extern const void * RTTI_BSLimbIKModifierUtilityCastInfo;
extern const void * RTTI_BSLimbIKModifierUtility;
extern const void * RTTI_IAnimationGraphManagerHolder;
extern const void * RTTI_IAnimationGraphManagerLoadingTask;
extern const void * RTTI_SimpleAnimationGraphManagerLoadingTask;
extern const void * RTTI_SimpleAnimationGraphManagerHolder;
extern const void * RTTI_WeaponAnimationGraphManagerHolder;
extern const void * RTTI_TESCamera;
extern const void * RTTI_BSAlignBoneModifierInterface;
extern const void * RTTI_BSLookAtModifierInterface;
extern const void * RTTI_AttractionObjectLOSUtils__CacheEntry;
extern const void * RTTI_ThirdPersonState;
extern const void * RTTI_DialogueCameraState;
extern const void * RTTI_VATSCamera__BaseState;
extern const void * RTTI_VATSCamera__ModifierBase;
extern const void * RTTI_VATSCamera__StationaryCameraState;
extern const void * RTTI_VATSCamera__LookAtCameraState;
extern const void * RTTI_VATSCamera__ActorLookCameraState;
extern const void * RTTI_AimModel__Component;
extern const void * RTTI_AimModelPlayerComponent;
extern const void * RTTI_CombatPath;
extern const void * RTTI_CombatObject;
extern const void * RTTI_CombatObjectBase;
extern const void * RTTI_CombatPathDestinationRef;
extern const void * RTTI_CombatPathDestinationActor;
extern const void * RTTI_CombatChargingSearchData;
extern const void * RTTI_CombatBehaviorTreeWrapperNode;
extern const void * RTTI_CombatBehaviorTreeCreateContextNodeBase;
extern const void * RTTI_CombatBehaviorTreeChargingMovement;
extern const void * RTTI_CombatBehaviorTreeChargingCloseMovement;
extern const void * RTTI_CombatSharedObject;
extern const void * RTTI_CombatMovementRequest;
extern const void * RTTI_CombatMovementRequestFollowActor;
extern const void * RTTI_CombatBehaviorTreeMovementRequest;
extern const void * RTTI_CombatBehaviorTreeGrenade;
extern const void * RTTI_CombatBehaviorTreeGun;
extern const void * RTTI_CombatBehaviorTreeThrow;
extern const void * RTTI_CombatArea;
extern const void * RTTI_CombatAreaShape;
extern const void * RTTI_CombatPathingSearchArea;
extern const void * RTTI_CombatPathingRequestCovered;
extern const void * RTTI_CombatCoveredPathDebugData;
extern const void * RTTI_CombatCoveredPath;
extern const void * RTTI_CombatPathBuilderCovered;
extern const void * RTTI_CombatPositionTracker;
extern const void * RTTI_CombatSuppressiveFireBehavior;
extern const void * RTTI_CombatPathController;
extern const void * RTTI_CombatTunnelPathController;
extern const void * RTTI_CombatViewController;
extern const void * RTTI_CombatViewControllerStandard;
extern const void * RTTI_CombatViewControllerGlance;
extern const void * RTTI_CombatViewControllerPath;
extern const void * RTTI_MovementParametersFixed;
extern const void * RTTI_PassengerInteraction;
extern const void * RTTI_BGSPerk__FindPerkInRanksVisitor;
extern const void * RTTI_BGSPerk__AddPerkVisitor;
extern const void * RTTI_BGSPerk__ApplyPerksVisitor;
extern const void * RTTI_BGSInventoryItem__SetHealthFunctor;
extern const void * RTTI_BGSInventoryItem__ModifyModDataFunctor;
extern const void * RTTI_PowerArmor__EventHandler;
extern const void * RTTI_BSInputEventReceiver;
extern const void * RTTI_BSIdleInputWatcher;
extern const void * RTTI_BSInputEventSingleUser;
extern const void * RTTI_BuildABot__InputHandler;
extern const void * RTTI_CheckFastTravelCommand;
extern const void * RTTI_ClearIdleCommand;
extern const void * RTTI_DropItemCommand;
extern const void * RTTI_FastTravelCommand;
extern const void * RTTI_CheckHardcoreFastTravelCommand;
extern const void * RTTI_PipboyCommandResult;
extern const void * RTTI_FastTravelCommandResult;
extern const void * RTTI_LocalMapSnapshotCommand;
extern const void * RTTI_PipboyCommand;
extern const void * RTTI_RemoveCustomMapMarkerCommand;
extern const void * RTTI_SetCustomMapMarkerCommand;
extern const void * RTTI_SetQuickkeyCommand;
extern const void * RTTI_SortInventoryCommand;
extern const void * RTTI_ToggleComponentFavoriteCommand;
extern const void * RTTI_ToggleQuestActiveStatusCommand;
extern const void * RTTI_ToggleRadioStationCommand;
extern const void * RTTI_UseItemCommand;
extern const void * RTTI_Json__FastWriter;
extern const void * RTTI_PipboyCompanionService;
extern const void * RTTI_ButtonHintBar;
extern const void * RTTI_FlatScreenModel;
extern const void * RTTI_HUDScreenModel;
extern const void * RTTI_HUDActionPointMeter;
extern const void * RTTI_HUDActiveEffectsDisplay;
extern const void * RTTI_HUDActiveEffectsModel;
extern const void * RTTI_HUDActorValueMeterBase;
extern const void * RTTI_HUDAmmoCounter;
extern const void * RTTI_HUDExplosiveAmmoCounter;
extern const void * RTTI_HUDCompassBase;
extern const void * RTTI_HUDCompass;
extern const void * RTTI_PowerArmorHUDCompass;
extern const void * RTTI_HUDCompassMarkerBase;
extern const void * RTTI_HUDCompassDirectionMarker;
extern const void * RTTI_HUDCompassMarker;
extern const void * RTTI_HUDComponentBase;
extern const void * RTTI_HUDCriticalMeter;
extern const void * RTTI_HUDCrosshair;
extern const void * RTTI_HUDCrosshair__FXCrosshairBase;
extern const void * RTTI_HUDCrosshair__FXCrosshairBase__FXCrosshairTicks;
extern const void * RTTI_HUDDirectionalHitIndicatorDataModel;
extern const void * RTTI_HUDEnemyHealthMeter;
extern const void * RTTI_HUDExperienceMeter;
extern const void * RTTI_HUDExplosivesDataModel;
extern const void * RTTI_HUDFatigueWarning;
extern const void * RTTI_HUDFloatingQuestMarkers;
extern const void * RTTI_HUDFloatingQuestMarkers__QuestMarker;
extern const void * RTTI_HUDMessages;
extern const void * RTTI_HUDMessagesModel;
extern const void * RTTI_HUDMeterBase;
extern const void * RTTI_HUDMeter;
extern const void * RTTI_GameUIModel;
extern const void * RTTI_HUDDataModel;
extern const void * RTTI_HUDNotificationsModel;
extern const void * RTTI_HUDPerkVaultBoy;
extern const void * RTTI_HUDPerkVaultBoyModel;
extern const void * RTTI_HUDPlayerHealthMeter;
extern const void * RTTI_HUDQuestVaultBoy;
extern const void * RTTI_HUDObjectiveUpdates;
extern const void * RTTI_HUDQuestUpdates;
extern const void * RTTI_HUDQuickContainer;
extern const void * RTTI_HUDQuickContainerDataModel;
extern const void * RTTI_HUDRadiationMeter;
extern const void * RTTI_HUDRadiationModel;
extern const void * RTTI_HUDRollover;
extern const void * RTTI_HUDRolloverModel;
extern const void * RTTI_HUDSubtitleText;
extern const void * RTTI_HUDTutorialText;
extern const void * RTTI_HUDData;
extern const void * RTTI_HUDDataBase;
extern const void * RTTI_ContainerMenuBase__IValidFunc;
extern const void * RTTI_OpenBarterMenuMessage;
extern const void * RTTI_BarterMenu;
extern const void * RTTI_InventoryUpdateData;
extern const void * RTTI_nsBarterMenu__ValidFunc;
extern const void * RTTI_nsBarterMenu__VendorCapsTooLowCallback;
extern const void * RTTI_nsBarterMenu__CancelTradeInProgressCallback;
extern const void * RTTI_nsBarterMenu__ConfirmTradeCallback;
extern const void * RTTI_nsBarterMenu__HideMenuCallback;
extern const void * RTTI_nsBarterMenu__ConfirmInvestmentCallback;
extern const void * RTTI_ButtonBarMenu;
extern const void * RTTI_ContainerMenuBase;
extern const void * RTTI_ContainerMenuBase__FXQuantityMenu;
extern const void * RTTI_CookingMenu;
extern const void * RTTI_ExamineConfirmMenu;
extern const void * RTTI_ExamineConfirmMenu__InitData;
extern const void * RTTI_ExamineConfirmMenu__InitDataBuild;
extern const void * RTTI_ExamineConfirmMenu__InitDataScrap;
extern const void * RTTI_ExamineConfirmMenu__InitDataRepairFailure;
extern const void * RTTI_Scaleform__GFx__Value__ObjectInterface__ArrVisitor;
extern const void * RTTI_BGSInventoryItem__WriteTextExtra;
extern const void * RTTI_ExamineMenu;
extern const void * RTTI_ExamineMenu__FXExamineMenu;
extern const void * RTTI_ExamineMenu__FXExamineMenu__FXExamineSubMenu;
extern const void * RTTI_GameMenuBase;
extern const void * RTTI_GenericMenu;
extern const void * RTTI_PipboyOpeningSequenceMenu;
extern const void * RTTI_FlashHitIndicator;
extern const void * RTTI_FlashStealth;
extern const void * RTTI_FlashLocationText;
extern const void * RTTI_FlashVaultBoyCondition;
extern const void * RTTI_FlashExplosiveIndicators;
extern const void * RTTI_FlashExplosiveIndicators__SingleExplosiveIndicator;
extern const void * RTTI_FlashDirectionalHitIndicators;
extern const void * RTTI_FlashDirectionalHitIndicators__SingleDirectionalHitIndicator;
extern const void * RTTI_LevelUpMenu;
extern const void * RTTI_nsLevelUpMenu__LevelUpPromptRequest;
extern const void * RTTI_InputEvent;
extern const void * RTTI_IDEvent;
extern const void * RTTI_ButtonEvent;
extern const void * RTTI_LooksInputRepeatHandler;
extern const void * RTTI_LooksMenu;
extern const void * RTTI_LooksMenuUtils__ExitConfirmCallback;
extern const void * RTTI_LooksMenuUtils__ChangePresetConfirmCallback;
extern const void * RTTI_CreationClubMenu;
extern const void * RTTI_CreationClub__AsyncModRequest;
extern const void * RTTI_CreationClub__CreationListRequest;
extern const void * RTTI_CreationClub__BundleChildrenRequest;
extern const void * RTTI_CreationClub__CategorySearchRequest;
extern const void * RTTI_CreationClub__GetCreationRequest;
extern const void * RTTI_CreationClub__GetIntRequest;
extern const void * RTTI_CreationClub__DownloadImageRequest;
extern const void * RTTI_CreationClub__StringStringRequest;
extern const void * RTTI_CreationClub__SavedGFxValueRequest;
extern const void * RTTI_CreationClub__DownloadCreationRequest;
extern const void * RTTI_CreationClub__CreationChanged_ConfirmResetCallback;
extern const void * RTTI_ModManager__AsyncModRequest;
extern const void * RTTI_ModManager__DownloadModRequest;
extern const void * RTTI_ModManager__CategorySearchRequest;
extern const void * RTTI_ModManager__GetDetailsRequest;
extern const void * RTTI_ModManager__GetDependencyRequest;
extern const void * RTTI_ModManager__DownloadImageRequest;
extern const void * RTTI_ModManager__SavedGFxValueRequest;
extern const void * RTTI_ModManager__GetIntRequest;
extern const void * RTTI_ModManager__StringStringRequest;
extern const void * RTTI_ModManager__ModsChanged_ConfirmResetCallback;
extern const void * RTTI_ModManager__ReportMod_CategoryCallback;
extern const void * RTTI_ModManager__ReportMod_ConfirmCallback;
extern const void * RTTI_ModManager__DeleteMod_ConfirmCallback;
extern const void * RTTI_ModManager__DeleteLibraryMod_ConfirmCallback;
extern const void * RTTI_ModManager__DeleteAllMods_ConfirmCallback;
extern const void * RTTI_ModManager__CloseModManager_ConfirmCallback;
extern const void * RTTI_IMultiActivateUser;
extern const void * RTTI_MultiActivateManager;
extern const void * RTTI_MultiActivateMenu;
extern const void * RTTI_CompanionListener;
extern const void * RTTI_ActivateChoiceListener;
extern const void * RTTI_PauseMenu;
extern const void * RTTI_BSUIMessageData;
extern const void * RTTI_nsPauseMenu__UserDisengagedCallback;
extern const void * RTTI_HolotapeDataManager;
extern const void * RTTI_HolotapeMenu;
extern const void * RTTI_PipboyHolotapeMenu;
extern const void * RTTI_TerminalHolotapeMenu;
extern const void * RTTI_PipboyLogMenu;
extern const void * RTTI_PipboyMapMenu;
extern const void * RTTI_PipboyInventoryMenu;
extern const void * RTTI_PipboyMenu;
extern const void * RTTI_PipboyPerksMenu;
extern const void * RTTI_PipboyQuestMenu;
extern const void * RTTI_PipboyRadioMenu;
extern const void * RTTI_PipboyPlayerInfoMenu;
extern const void * RTTI_PipboySpecialMenu;
extern const void * RTTI_PipboyStatsMenu;
extern const void * RTTI_PipboySubMenu;
extern const void * RTTI_PipboyWorkshopMenu;
extern const void * RTTI_PlayBinkMenu;
extern const void * RTTI_nsPlayBinkMenu__InitDataMessage;
extern const void * RTTI_PowerArmorModMenu;
extern const void * RTTI_IPromptMenuRequest;
extern const void * RTTI_PromptMenu;
extern const void * RTTI_PromptMenuData;
extern const void * RTTI_RobotModMenu;
extern const void * RTTI_ScopeMenuUtil__FadeCallback;
extern const void * RTTI_ScopeMenu;
extern const void * RTTI_SPECIALMenu;
extern const void * RTTI_nsSPECIALMenu__ConfirmResetPointsCallback;
extern const void * RTTI_StartMenuBase;
extern const void * RTTI_nsStartMenu_InputMapping__RemapHandler;
extern const void * RTTI_StreamingInstallMenu;
extern const void * RTTI_TerminalMenu;
extern const void * RTTI_TerminalRunResultsCallback;
extern const void * RTTI_TerminalMenuButtons;
extern const void * RTTI_TerminalMenuUtils__HolotapeSelectionCallback;
extern const void * RTTI_Scaleform__RefCountImpl;
extern const void * RTTI_Scaleform__RefCountImplCore;
extern const void * RTTI_Scaleform__GFx__FunctionHandler;
extern const void * RTTI_SWFToCodeFunctionHandler;
extern const void * RTTI_VATSMenuPrivate__VatsMenuObj;
extern const void * RTTI_VATSMenu;
extern const void * RTTI_HUDActionPointData;
extern const void * RTTI_VATSMenuPrivate__ASFunctionHandler;
extern const void * RTTI_VATSMenuPrivate__VatsMenuObj__FXPartInfo;
extern const void * RTTI_VertibirdMenu;
extern const void * RTTI_VignetteMenu;
extern const void * RTTI_WorkbenchMenuBase;
extern const void * RTTI_nsInventory3DManager__NewInventoryMenuItemLoadTask;
extern const void * RTTI_nsInventory3DManager__WorkshopMenuItemLoadTask;
extern const void * RTTI_WorkshopMenuGeometry;
extern const void * RTTI_WorkshopMenu;
extern const void * RTTI_WorkshopMenu__FXWorkshopMenu;
extern const void * RTTI_nsWorkshopMenu__WorkshopMenuPromptRequest;
extern const void * RTTI_nsWS_Caravan__MessageData;
extern const void * RTTI_Workshop_CaravanMenu;
extern const void * RTTI_Workshop_CaravanMenu__FXWorkshopCaravanMenu;
extern const void * RTTI_PipboyArray;
extern const void * RTTI_PipboyDataGroup;
extern const void * RTTI_PipboyInventoryData;
extern const void * RTTI_PipboyLogData;
extern const void * RTTI_PipboyLogData__PopulateStatsVisitor;
extern const void * RTTI_PipboyManager;
extern const void * RTTI_IPipboyThrottledValue;
extern const void * RTTI_PipboyMapData;
extern const void * RTTI_PipboyObject;
extern const void * RTTI_PipboyPerksData;
extern const void * RTTI_PipboyQuestData;
extern const void * RTTI_PipboyPlayerInfoData;
extern const void * RTTI_PipboySpecialData;
extern const void * RTTI_PipboyStatsData;
extern const void * RTTI_PipboyStatusData;
extern const void * RTTI_PipboyValue;
extern const void * RTTI_PipboyWorkshopData;
extern const void * RTTI_PipboyRadioData;
extern const void * RTTI_AbsorbEffect;
extern const void * RTTI_AccumulatingValueModifierEffect;
extern const void * RTTI_ActiveEffect;
extern const void * RTTI_ActiveEffectReferenceEffectController;
extern const void * RTTI_ActiveEffect__ForEachHitEffectVisitor;
extern const void * RTTI_BSAnimationGraphChannel;
extern const void * RTTI_MagicItemDataCollector;
extern const void * RTTI_ActorMagicCaster;
extern const void * RTTI_BSAttachTechniques__AttachTechniqueInput;
extern const void * RTTI_RefAttachTechniqueInput;
extern const void * RTTI_CloakEffect;
extern const void * RTTI_MagicTarget__IPostCreationModification;
extern const void * RTTI_CommandEffect;
extern const void * RTTI_CommandSummonedEffect;
extern const void * RTTI_CureEffect;
extern const void * RTTI_DamageEffect;
extern const void * RTTI_DarknessEffect;
extern const void * RTTI_DetectLifeEffect;
extern const void * RTTI_DisarmEffect;
extern const void * RTTI_DisguiseEffect;
extern const void * RTTI_DisguiseEffect__DetectionChecker;
extern const void * RTTI_DispelEffect;
extern const void * RTTI_DualValueModifierEffect;
extern const void * RTTI_EtherealizationEffect;
extern const void * RTTI_GuideEffect;
extern const void * RTTI_ImmunityEffect;
extern const void * RTTI_InvisibilityEffect;
extern const void * RTTI_JetpackEffect;
extern const void * RTTI_LightEffect;
extern const void * RTTI_LockEffect;
extern const void * RTTI_MagicCaster;
extern const void * RTTI_MagicCaster__PostCreationCallback;
extern const void * RTTI_ProcessLists__GetActorsFilter;
extern const void * RTTI_ActorTargetCheck;
extern const void * RTTI_MagicTarget;
extern const void * RTTI_FindEffectKeywordOnTargetFunctor;
extern const void * RTTI_ModelReferenceEffect;
extern const void * RTTI_NightEyeEffect;
extern const void * RTTI_NonActorMagicTarget;
extern const void * RTTI_OpenEffect;
extern const void * RTTI_ParalysisEffect;
extern const void * RTTI_PeakValueModifierEffect;
extern const void * RTTI_ReanimateEffect;
extern const void * RTTI_ReferenceEffect;
extern const void * RTTI_WeaponEnchantmentController;
extern const void * RTTI_ScriptEffect;
extern const void * RTTI_ScriptedRefEffect;
extern const void * RTTI_ShaderReferenceEffect;
extern const void * RTTI_SlowTimeEffect;
extern const void * RTTI_SoulTrapEffect;
extern const void * RTTI_StaggerEffect;
extern const void * RTTI_StimpakEffect;
extern const void * RTTI_BSPathing__CheckLineOfSightFilter;
extern const void * RTTI_CheckLineOfSightFilterMisc;
extern const void * RTTI_SummonPlacementEffect;
extern const void * RTTI_SummonCreatureEffect;
extern const void * RTTI_TargetValueModifierEffect;
extern const void * RTTI_RallyEffect;
extern const void * RTTI_DemoralizeEffect;
extern const void * RTTI_TurnUndeadEffect;
extern const void * RTTI_BanishEffect;
extern const void * RTTI_CalmEffect;
extern const void * RTTI_FrenzyEffect;
extern const void * RTTI_TelekinesisEffect;
extern const void * RTTI_ValueModifierEffect;
extern const void * RTTI_TESAudio__ScriptedMusicState;
extern const void * RTTI_BGSPlayerMusicChanger;
extern const void * RTTI_TESAudio__DuckingMgmt__InstancedIni;
extern const void * RTTI_TESAudio__DuckingMgmt__AttenInstancedIni;
extern const void * RTTI_MenuTopicManager;
extern const void * RTTI_ActorUtils__ArmorRatingVisitorBase;
extern const void * RTTI_BGSGameWarningsHandler__GameWarningsSink;
extern const void * RTTI_JobListManager__ServingThread;
extern const void * RTTI_BGSSaveLoadManager;
extern const void * RTTI_BGSSaveLoadThread;
extern const void * RTTI_BGSSaveLoadStatsMap;
extern const void * RTTI_BGSLoadGameBuffer;
extern const void * RTTI_BGSSaveFormBuffer;
extern const void * RTTI_BGSSaveGameBuffer;
extern const void * RTTI_SaveStorageWrapper;
extern const void * RTTI_LoadStorageWrapper;
extern const void * RTTI_std___System_error_category;
extern const void * RTTI_BSResource__CacheDrive__Op;
extern const void * RTTI_BGSMoviePlayer;
extern const void * RTTI_IExplosionFactory;
extern const void * RTTI_ChainExplosion;
extern const void * RTTI_EnhanceWeaponEffect;
extern const void * RTTI_IGCQueue;
extern const void * RTTI_IDDQueueCollection;
extern const void * RTTI_RegSettingCollection;
extern const void * RTTI_BSTreeManager__IQueryCullingCamera;
extern const void * RTTI_IMovementControllerNPCFunctor;
extern const void * RTTI_HelpMessageManager;
extern const void * RTTI_UISaveLoadManager;
extern const void * RTTI_BGSImpactManager;
extern const void * RTTI_Main;
extern const void * RTTI_MovementAvoidBoxEventAdapter;
extern const void * RTTI_PathManagerPositionPlayerAdapter;
extern const void * RTTI_CharacterCollisionMessagePlayerAdapter;
extern const void * RTTI_PlayerSleepWaitMovementControllerAdapter;
extern const void * RTTI_PlayerSleepWaitMovementControllerAdapter__SwitchToLoadedSetControllerFunctor;
extern const void * RTTI_PlayerSleepWaitMovementControllerAdapter__SwitchToUnloadedSetControllerFunctor;
extern const void * RTTI_DoorObstacleAdapter;
extern const void * RTTI_IMemoryManagerFile;
extern const void * RTTI_IMemoryManagerFileFactory;
extern const void * RTTI_MemoryManagerFile;
extern const void * RTTI_SceneGraph;
extern const void * RTTI_SeenData;
extern const void * RTTI_IntSeenData;
extern const void * RTTI_SpawnHazardEffect;
extern const void * RTTI_bhkIAddToWorld;
extern const void * RTTI_BSShaderProperty__ForEachVisitor;
extern const void * RTTI_ProcessObjectsLocal;
extern const void * RTTI_TextureUpdateStage;
extern const void * RTTI_ProcessObjects;
extern const void * RTTI_ProcessObjectsDetached;
extern const void * RTTI_ProcessObjects1;
extern const void * RTTI_ProcessObjects2;
extern const void * RTTI_ProcessObjects3;
extern const void * RTTI_ProcessObjects4;
extern const void * RTTI_ProcessObjectsLOD;
extern const void * RTTI_ProcessObjectsGrass;
extern const void * RTTI_ProcessObjectsDecals;
extern const void * RTTI_TextureUpdateStart;
extern const void * RTTI_TextureUpdateDone;
extern const void * RTTI_Actor;
extern const void * RTTI_IMovementState;
extern const void * RTTI_PackageList__IPackageVisitor;
extern const void * RTTI_IPostAnimationChannelUpdateFunctor;
extern const void * RTTI_ActorUtils__ArmorRatingVisitor;
extern const void * RTTI_CombatQueuedEvent;
extern const void * RTTI_EquipActorOutfitItemsFunctor;
extern const void * RTTI_SaveLoadMagicCasterVisitor;
extern const void * RTTI_SaveGameMagicCasterVisitor;
extern const void * RTTI_LoadGameMagicCasterVisitor;
extern const void * RTTI_RevertSelectedSpellFunctor;
extern const void * RTTI_Actor__ForEachSpellVisitor;
extern const void * RTTI_HasSpellVisitor;
extern const void * RTTI_ActorMediator;
extern const void * RTTI_ActorState;
extern const void * RTTI_BGSVisitProceduresProcess;
extern const void * RTTI_BGSVisitProceduresInitActorAnimPose;
extern const void * RTTI_AIProcess__PendingActorHeadData;
extern const void * RTTI_DetectionListener;
extern const void * RTTI_EquippedItemData;
extern const void * RTTI_EquippedWeaponData;
extern const void * RTTI_BGSFootstepManager;
extern const void * RTTI_BSDoorHavokController;
extern const void * RTTI_BSPlayerDistanceCheckController;
extern const void * RTTI_BSSimpleScaleController;
extern const void * RTTI_HighActorCuller;
extern const void * RTTI_MountInteraction;
extern const void * RTTI_IMovementPlayerControlsFilter;
extern const void * RTTI_PlayerCharacter;
extern const void * RTTI_BShkbUtils__GraphInspectionFunctor;
extern const void * RTTI_PlayerRegionState;
extern const void * RTTI_ProcessLists;
extern const void * RTTI_IMovementFormIDManager;
extern const void * RTTI_ProcessListMovementInterface;
extern const void * RTTI_RefrInteraction;
extern const void * RTTI_SyncQueueObj;
extern const void * RTTI_ActorMover;
extern const void * RTTI_bhkCharacterCollisionHandler;
extern const void * RTTI_CharacterCollisionHandler;
extern const void * RTTI_IMovementAvoidanceManager;
extern const void * RTTI_MovementAvoidanceManager;
extern const void * RTTI_IMovementMessageInterface;
extern const void * RTTI_IMovementDirectControl;
extern const void * RTTI_IMovementPlannerDirectControl;
extern const void * RTTI_IMovementSelectIdle;
extern const void * RTTI_IMovementMotionDrivenControl;
extern const void * RTTI_IMovementQueryAnimDeltas;
extern const void * RTTI_MovementControllerNPC;
extern const void * RTTI_BSPathingStreamWrite;
extern const void * RTTI_BSPathingStreamSimpleBufferWrite;
extern const void * RTTI_MovementHandlerAgentDirectControl;
extern const void * RTTI_MovementHandlerAgentPlayerControlsActionTrigger;
extern const void * RTTI_IMovementSetSprinting;
extern const void * RTTI_MovementHandlerAgentSprintActionTrigger;
extern const void * RTTI_MovementHandlerAgentStairsHelper;
extern const void * RTTI_MovementMessage;
extern const void * RTTI_MovementMessageActorCollision;
extern const void * RTTI_IMovementQueryState;
extern const void * RTTI_MovementPlannerAgentDirectControl;
extern const void * RTTI_IMovementSetWarp;
extern const void * RTTI_MovementPlannerAgentWarp;
extern const void * RTTI_ITweenerNodeFollowerSetup;
extern const void * RTTI_MovementTweenerAgentNodeFollower;
extern const void * RTTI_PathingStreamLoadGame;
extern const void * RTTI_PathingStreamSaveGame;
extern const void * RTTI_IMovementPlayerControls;
extern const void * RTTI_PlayerInputHandler;
extern const void * RTTI_HeldStateHandler;
extern const void * RTTI_PlayerControls;
extern const void * RTTI_MovementHandler;
extern const void * RTTI_LookHandler;
extern const void * RTTI_SprintHandler;
extern const void * RTTI_ReadyWeaponHandler;
extern const void * RTTI_AutoMoveHandler;
extern const void * RTTI_ToggleRunHandler;
extern const void * RTTI_ActivateHandler;
extern const void * RTTI_JumpHandler;
extern const void * RTTI_AttackBlockHandler;
extern const void * RTTI_RunHandler;
extern const void * RTTI_SneakHandler;
extern const void * RTTI_TogglePOVHandler;
extern const void * RTTI_MeleeThrowHandler;
extern const void * RTTI_GrabRotationHandler;
extern const void * RTTI_IStaticAvoidNodeManager;
extern const void * RTTI_StaticAvoidNodeManager;
extern const void * RTTI_AlarmPackage;
extern const void * RTTI_CustomActorPackageData;
extern const void * RTTI_EscortActorPackageData;
extern const void * RTTI_FleePackage;
extern const void * RTTI_GuardPackageData;
extern const void * RTTI_GuardActorPackageData;
extern const void * RTTI_PatrolActorPackageData;
extern const void * RTTI_SpectatorPackage;
extern const void * RTTI_TrespassPackage;
extern const void * RTTI_ActorKnowledge;
extern const void * RTTI_DetectionCollector;
extern const void * RTTI_DetectionState;
extern const void * RTTI_WeaponSwingHandler;
extern const void * RTTI_AttackWinStartHandler;
extern const void * RTTI_AttackWinEndHandler;
extern const void * RTTI_AttackStopHandler;
extern const void * RTTI_RecoilStopHandler;
extern const void * RTTI_LeftHandSpellFireHandler;
extern const void * RTTI_RightHandSpellFireHandler;
extern const void * RTTI_VoiceSpellFireHandler;
extern const void * RTTI_LeftHandSpellCastHandler;
extern const void * RTTI_RightHandSpellCastHandler;
extern const void * RTTI_VoiceSpellCastHandler;
extern const void * RTTI_WeaponBeginDrawHandler;
extern const void * RTTI_WeaponBeginSheatheHandler;
extern const void * RTTI_WeaponDrawHandler;
extern const void * RTTI_WeaponSheatheHandler;
extern const void * RTTI_CameraOverrideStartHandler;
extern const void * RTTI_CameraOverrideStopHandler;
extern const void * RTTI_HitFrameHandler;
extern const void * RTTI_AnticipateAttackHandler;
extern const void * RTTI_StaggeredStopHandler;
extern const void * RTTI_ChairEnterHandler;
extern const void * RTTI_PlayerChairEnterHandler;
extern const void * RTTI_PlayerTerminalEnterHandler;
extern const void * RTTI_BedEnterHandler;
extern const void * RTTI_PlayerBedEnterHandler;
extern const void * RTTI_ChairFurnitureExitHandler;
extern const void * RTTI_BedFurnitureExitHandler;
extern const void * RTTI_PlayerFurnitureExitHandler;
extern const void * RTTI_KillActorHandler;
extern const void * RTTI_HeadTrackingOnHandler;
extern const void * RTTI_HeadTrackingOffHandler;
extern const void * RTTI_HeadTrackingRotationOnHandler;
extern const void * RTTI_HeadTrackingRotationOffHandler;
extern const void * RTTI_FlightTakeOffHandler;
extern const void * RTTI_FlightCruisingHandler;
extern const void * RTTI_FlightHoveringHandler;
extern const void * RTTI_FlightLandingHandler;
extern const void * RTTI_FlightPerchingHandler;
extern const void * RTTI_FlightLandHandler;
extern const void * RTTI_FlightLandEndHandler;
extern const void * RTTI_FlightActionHandler;
extern const void * RTTI_FlightActionEntryEndHandler;
extern const void * RTTI_FlightActionEndHandler;
extern const void * RTTI_FlightActionGrabHandler;
extern const void * RTTI_FlightActionReleaseHandler;
extern const void * RTTI_FlightCrashLandStartHandler;
extern const void * RTTI_BowDrawnHandler;
extern const void * RTTI_BowReleaseHandler;
extern const void * RTTI_ArrowAttachHandler;
extern const void * RTTI_ArrowDetachHandler;
extern const void * RTTI_BowZoomStartHandler;
extern const void * RTTI_BowZoomStopHandler;
extern const void * RTTI_InterruptCastHandler;
extern const void * RTTI_EndSummonAnimationHandler;
extern const void * RTTI_PickNewIdleHandler;
extern const void * RTTI_DoNotInterruptAnimationHandler;
extern const void * RTTI_DeathStopHandler;
extern const void * RTTI_ActionActivateDoneHandler;
extern const void * RTTI_StopMountCameraHandler;
extern const void * RTTI_PairedStopHandler;
extern const void * RTTI_CameraShakeHandler;
extern const void * RTTI_KillMoveStartHandler;
extern const void * RTTI_KillMoveEndHandler;
extern const void * RTTI_DeathEmoteHandler;
extern const void * RTTI_AddRagdollHandler;
extern const void * RTTI_MotionDrivenHandler;
extern const void * RTTI_AnimationDrivenHandler;
extern const void * RTTI_AllowRotationHandler;
extern const void * RTTI_RemoveRagdollHandler;
extern const void * RTTI_RagdollStartHandler;
extern const void * RTTI_GetUpStartHandler;
extern const void * RTTI_GetUpEndHandler;
extern const void * RTTI_RagdollAndGetUpHandler;
extern const void * RTTI_MountDismountEndHandler;
extern const void * RTTI_NPCAttachHandler;
extern const void * RTTI_NPCDetachHandler;
extern const void * RTTI_EnableCharacterBumperHandler;
extern const void * RTTI_DisableCharacterBumperHandler;
extern const void * RTTI_EnableCollisionHandler;
extern const void * RTTI_DisableCollisionHandler;
extern const void * RTTI_StartFloatingHandler;
extern const void * RTTI_StopFloatingHandler;
extern const void * RTTI_AnimationObjectLoadHandler;
extern const void * RTTI_AnimationObjectDrawHandler;
extern const void * RTTI_EnableCharacterPitchHandler;
extern const void * RTTI_DisableCharacterPitchHandler;
extern const void * RTTI_JumpAnimEventHandler;
extern const void * RTTI_IdleDialogueEnterHandler;
extern const void * RTTI_IdleDialogueExitHandler;
extern const void * RTTI_AnimatedCameraStartHandler;
extern const void * RTTI_AnimatedCameraDeltaStartHandler;
extern const void * RTTI_AnimatedCameraEndHandler;
extern const void * RTTI_PitchOverrideStartHandler;
extern const void * RTTI_PitchOverrideEndHandler;
extern const void * RTTI_ZeroPitchHandler;
extern const void * RTTI_WeaponFireHandler;
extern const void * RTTI_ReloadStateChangeHandler;
extern const void * RTTI_ReloadCompleteHandler;
extern const void * RTTI_SightedStateChangeHandler;
extern const void * RTTI_PlayerSightedStateChangeHandler;
extern const void * RTTI_AttackStateChangeHandler;
extern const void * RTTI_AttackStateChangeHandler0;
extern const void * RTTI_AttackStateChangeHandler1;
extern const void * RTTI_AttackStateChangeHandler2;
extern const void * RTTI_AttackStateChangeHandler3;
extern const void * RTTI_AttackStateChangeHandler4;
extern const void * RTTI_RelaxedStateChangeHandler;
extern const void * RTTI_AlertStateChangeHandler;
extern const void * RTTI_ReadyStateChangeHandler;
extern const void * RTTI_GunDownStateChangeHandler;
extern const void * RTTI_SneakStateChangeHandler;
extern const void * RTTI_PlayerSneakStateChangeHandler;
extern const void * RTTI_LoopingActivateHandler;
extern const void * RTTI_ReevaluateGraphStateHandler;
extern const void * RTTI_UncullBoneHandler;
extern const void * RTTI_CullFurnitureBoneHandler;
extern const void * RTTI_UncullFurnitureBoneHandler;
extern const void * RTTI_CullWeaponsHandler;
extern const void * RTTI_UncullWeaponsHandler;
extern const void * RTTI_IdleFlavorHandler;
extern const void * RTTI_PerformActivationHandler;
extern const void * RTTI_AttachReferenceHandler;
extern const void * RTTI_PipboyBootSequenceHandler;
extern const void * RTTI_FaceEmotionalIdleHandler;
extern const void * RTTI_UseStimpakHandler;
extern const void * RTTI_UseStealthBoyHandler;
extern const void * RTTI_HolotapeLoadedHandler;
extern const void * RTTI_AwakeSoundFadeHandler;
extern const void * RTTI_AwakeSoundStopHandler;
extern const void * RTTI_AwakeSoundPauseHandler;
extern const void * RTTI_AwakeSoundResumeHandler;
extern const void * RTTI_PairedAttackDialogueHandler;
extern const void * RTTI_WeaponAttachHandler;
extern const void * RTTI_WeaponDetachHandler;
extern const void * RTTI_StartPCapVoiceHandler;
extern const void * RTTI_EjectShellCasingHandler;
extern const void * RTTI_SandManKillHandler;
extern const void * RTTI_KnockdownHandler;
extern const void * RTTI_KnockdownTargetHandler;
extern const void * RTTI_SyncDeferDeathHandler;
extern const void * RTTI_SyncEarlyExitHandler;
extern const void * RTTI_PlayerFastEquipSoundHandler;
extern const void * RTTI_DesyncInteractionHandler;
extern const void * RTTI_UpdateSightedHandler;
extern const void * RTTI_AnimationObject;
extern const void * RTTI_BGShkMatFadeController;
extern const void * RTTI_BSDirectAtModifierInterface;
extern const void * RTTI_BSPassByTargetTriggerModifierInterface;
extern const void * RTTI_BSRagdollContactListenerModifierInterface;
extern const void * RTTI_ArrowProjectile;
extern const void * RTTI_BarrierProjectile;
extern const void * RTTI_BeamProjectile;
extern const void * RTTI_ConeProjectile;
extern const void * RTTI_Explosion;
extern const void * RTTI_ExplosionClosestHitCollector;
extern const void * RTTI_FlameProjectile;
extern const void * RTTI_GrenadeProjectile;
extern const void * RTTI_Hazard;
extern const void * RTTI_MissileProjectile;
extern const void * RTTI_Projectile;
extern const void * RTTI_HealthDamageFunctor;
extern const void * RTTI_VATS;
extern const void * RTTI_IValidateGoalFunctor;
extern const void * RTTI_VATSUtils__ValidateStrangerLineOfSightGoalToOriginFunctor;
extern const void * RTTI_CombatAimController;
extern const void * RTTI_CombatAimControllerBase;
extern const void * RTTI_CombatTrackTargetAimController;
extern const void * RTTI_CombatMeleeAimController;
extern const void * RTTI_CombatProjectileAimController;
extern const void * RTTI_CombatDisableAimController;
extern const void * RTTI_CombatMatchTargetAimController;
extern const void * RTTI_CombatProjectileDebugData;
extern const void * RTTI_CombatAreaReference;
extern const void * RTTI_CombatAreaStandard;
extern const void * RTTI_CombatAreaHoldPosition;
extern const void * RTTI_CombatBlackboardMemberBase;
extern const void * RTTI_CombatCoverSearchResult;
extern const void * RTTI_CombatCoverLocation;
extern const void * RTTI_CombatCoverSearchDebugData;
extern const void * RTTI_CombatCoverSearch;
extern const void * RTTI_CombatEnterCoverPathController;
extern const void * RTTI_CombatMantlePathController;
extern const void * RTTI_CombatCluster;
extern const void * RTTI_CombatGroupDetectionListener;
extern const void * RTTI_CombatFormObject;
extern const void * RTTI_CombatInventoryItem;
extern const void * RTTI_CombatInventoryItemComposite;
extern const void * RTTI_CombatInventoryItemMelee;
extern const void * RTTI_CombatInventoryItemRanged;
extern const void * RTTI_CombatInventoryItemThrown;
extern const void * RTTI_CombatInventoryItemGrenade;
extern const void * RTTI_CombatInventoryItemShield;
extern const void * RTTI_CombatInventoryItemOneHandedBlock;
extern const void * RTTI_CombatInventoryItemTorch;
extern const void * RTTI_CombatInventoryItemMagic;
extern const void * RTTI_CombatMagicCaster;
extern const void * RTTI_CombatInventoryItemStaff;
extern const void * RTTI_CombatInventoryItemPotion;
extern const void * RTTI_CombatInventoryItemScroll;
extern const void * RTTI_CombatMagicItemData;
extern const void * RTTI_CombatMagicItemSkillChecker;
extern const void * RTTI_CombatMagicCasterOffensive;
extern const void * RTTI_CombatMagicCasterWard;
extern const void * RTTI_CombatMagicCasterRestore;
extern const void * RTTI_CombatMagicCasterSummon;
extern const void * RTTI_CombatMagicCasterStagger;
extern const void * RTTI_CombatMagicCasterDisarm;
extern const void * RTTI_CombatMagicCasterCloak;
extern const void * RTTI_CombatMagicCasterLight;
extern const void * RTTI_CombatMagicCasterInvisibility;
extern const void * RTTI_CombatMagicCasterChameleon;
extern const void * RTTI_CombatMagicCasterBoundItem;
extern const void * RTTI_CombatMagicCasterArmor;
extern const void * RTTI_CombatMagicCasterTargetEffect;
extern const void * RTTI_CombatMagicCasterReanimate;
extern const void * RTTI_CombatMagicCasterParalyze;
extern const void * RTTI_CombatMagicCasterScript;
extern const void * RTTI_CombatTargetLocationSearchResult;
extern const void * RTTI_CombatTargetLocation;
extern const void * RTTI_CombatTargetLocationSearch;
extern const void * RTTI_CombatTargetSelector;
extern const void * RTTI_CombatTargetSelectorStandard;
extern const void * RTTI_CombatTargetSelectorPreferred;
extern const void * RTTI_CombatTargetSelectorFixed;
extern const void * RTTI_CombatTargetSelectorRandom;
extern const void * RTTI_CombatThreat;
extern const void * RTTI_CombatThreatExplosion;
extern const void * RTTI_CombatThreatProjectile;
extern const void * RTTI_CombatThreatLOF;
extern const void * RTTI_CombatThreatMelee;
extern const void * RTTI_ProjectileLOSCollector;
extern const void * RTTI_CombatBehaviorResource;
extern const void * RTTI_CombatBehaviorTreeRootNode;
extern const void * RTTI_CombatBehaviorTreeLinkNode;
extern const void * RTTI_CombatBehaviorTree;
extern const void * RTTI_CombatBehaviorTreeCombat;
extern const void * RTTI_CombatBehaviorTreeNode;
extern const void * RTTI_CombatAcquireSearchDebugData;
extern const void * RTTI_CombatBehaviorTreeAcquireObject;
extern const void * RTTI_CombatBehaviorTreeAction;
extern const void * RTTI_CombatBehaviorTreeActionEquipmentSelector;
extern const void * RTTI_CombatBehaviorTreeAvoidThreat;
extern const void * RTTI_CombatBehaviorTreeBlock;
extern const void * RTTI_CombatApproachTargetPathController;
extern const void * RTTI_CombatBehaviorTreeCloseMovement;
extern const void * RTTI_CombatBehaviorTreeFindAttackLocation;
extern const void * RTTI_CombatFlankingSearchData;
extern const void * RTTI_CombatBehaviorTreeFlankingMovement;
extern const void * RTTI_CombatBehaviorTreeFlee;
extern const void * RTTI_CombatBehaviorTreeHide;
extern const void * RTTI_CombatBehaviorTreeFlight;
extern const void * RTTI_DiveBombPathController;
extern const void * RTTI_CombatBehaviorTreeLowCombat;
extern const void * RTTI_CombatBehaviorTreeMagic;
extern const void * RTTI_CombatStaticBlackboardMemberBase;
extern const void * RTTI_CombatMeleeDebugData;
extern const void * RTTI_CombatBehaviorTreeMelee;
extern const void * RTTI_CombatDisableActionController;
extern const void * RTTI_CombatBehaviorTreeCheckUnreachableTarget;
extern const void * RTTI_CombatBehaviorTreeReturnToCombatArea;
extern const void * RTTI_CombatBehaviorTreeFindValidLocation;
extern const void * RTTI_CombatBehaviorTreeMovement;
extern const void * RTTI_CombatBehaviorTreeBow;
extern const void * RTTI_CombatBehaviorTreeRangedMovement;
extern const void * RTTI_CombatBehaviorTreeSearch;
extern const void * RTTI_CombatSearchLockData;
extern const void * RTTI_CombatBehaviorTreeUseCover;
extern const void * RTTI_CombatBehaviorMoveInCover;
extern const void * RTTI_CombatFindCoverPathSpeedController;
extern const void * RTTI_CombatChangePositionPathController;
extern const void * RTTI_CombatBehaviorTreeUsePotion;
extern const void * RTTI_CombatPathDestinationFollowActor;
extern const void * RTTI_CombatAnimatedPath;
extern const void * RTTI_CombatPathBuilder;
extern const void * RTTI_CombatNavmeshSearch;
extern const void * RTTI_IPathBuilder;
extern const void * RTTI_CombatPathBuilderStandard;
extern const void * RTTI_CombatPathBuilderOpen;
extern const void * RTTI_CombatPathMovementMessage;
extern const void * RTTI_CombatPathingDebugData;
extern const void * RTTI_CombatPathingRequest;
extern const void * RTTI_CombatPathingRequestStandard;
extern const void * RTTI_CombatPathingRequestAdapter;
extern const void * RTTI_CombatPathingRequestMultiGoal;
extern const void * RTTI_CombatPathDestinationRefs;
extern const void * RTTI_CombatFollowTargetPathController;
extern const void * RTTI_CombatPathingTweener;
extern const void * RTTI_HorseCameraState;
extern const void * RTTI_PlayerCamera;
extern const void * RTTI_AutoVanityState;
extern const void * RTTI_FreeCameraState;
extern const void * RTTI_IronSightsState;
extern const void * RTTI_FurnitureCameraState;
extern const void * RTTI_PlayerCameraTransitionState;
extern const void * RTTI_BleedoutCameraState;
extern const void * RTTI_FirstPersonState;
extern const void * RTTI_TweenMenuCameraState;
extern const void * RTTI_VATSCameraState;
extern const void * RTTI_BookMenu;
extern const void * RTTI_Console;
extern const void * RTTI_IStringForwarder;
extern const void * RTTI_ConsoleNativeUIMenu;
extern const void * RTTI_OpenContainerMenuMessage;
extern const void * RTTI_ContainerMenu;
extern const void * RTTI_nsContainerMenu__ConfirmTakeAllTheThingsCallback;
extern const void * RTTI_nsContainerMenu__CanPickPocketAliasChecker;
extern const void * RTTI_nsContainerMenu__ValidFunc;
extern const void * RTTI_CreditsMenu;
extern const void * RTTI_CursorMenu;
extern const void * RTTI_DialogueMenu;
extern const void * RTTI_FaderMenu;
extern const void * RTTI_FavoritesManager;
extern const void * RTTI_FavoritesMenu;
extern const void * RTTI_PowerArmorGeometry;
extern const void * RTTI_PowerArmorHUDMenu;
extern const void * RTTI_HUDMenu;
extern const void * RTTI_HUDPowerArmorLowBatterWarningText;
extern const void * RTTI_HUDStealthMeter;
extern const void * RTTI_HUDLocationText;
extern const void * RTTI_ExplosiveIndicators;
extern const void * RTTI_DirectionalHitIndicators;
extern const void * RTTI_HUDFlashLightWidget;
extern const void * RTTI_PowerArmorHUDUtils__MainStatusHandler;
extern const void * RTTI_Inventory3DManager;
extern const void * RTTI_nsInventory3DManager__NewInventoryMenuItemMaterialSwapMaterialLoadTask;
extern const void * RTTI_nsInventory3DManager__NewInventoryMenuItemMaterialSwapTextureLoadTask;
extern const void * RTTI_LoadingMenu;
extern const void * RTTI_LockpickingMenu;
extern const void * RTTI_MainMenu;
extern const void * RTTI_nsMainMenu__DeviceSelectCallback;
extern const void * RTTI_nsMainMenu__NoDurangoUserSignedInCallback;
extern const void * RTTI_nsMainMenu__DLCChanged_ConfirmResetCallback;
extern const void * RTTI_MenuControls;
extern const void * RTTI_GFxConvertHandler;
extern const void * RTTI_DisconnectHandler;
extern const void * RTTI_ClickHandler;
extern const void * RTTI_QuickSaveLoadHandler;
extern const void * RTTI_MenuOpenHandler;
extern const void * RTTI_ScreenshotHandler;
extern const void * RTTI_CameraZoomHandler;
extern const void * RTTI_PipboyHandler;
extern const void * RTTI_MessageBoxData;
extern const void * RTTI_MessageBoxMenu;
extern const void * RTTI_MessageBoxMenu__FXMessageBoxMenu;
extern const void * RTTI_SafeZoneMenu;
extern const void * RTTI_SitWaitMenu;
extern const void * RTTI_SleepWaitMenu;
extern const void * RTTI_TitleSequenceMenu;
extern const void * RTTI_TutorialMenu;
extern const void * RTTI_UIBlurManager;
extern const void * RTTI_FaderData;
extern const void * RTTI_RefHandleUIData;
extern const void * RTTI_TESFormUIData;
extern const void * RTTI_LoadingMenuData;
extern const void * RTTI_DialogueMenuUtils__DialogueMessageData;
extern const void * RTTI_GameScript__Internal__AnimationCallbacks;
extern const void * RTTI_GameScript__DelayFunctor;
extern const void * RTTI_GameScript__DelayFunctorFactory;
extern const void * RTTI_BSScript__IHandleReaderWriter;
extern const void * RTTI_GameScript__BaseHandleReaderWriter;
extern const void * RTTI_GameScript__DataFileHandleReaderWriter;
extern const void * RTTI_GameScript__SaveFileHandleReaderWriter;
extern const void * RTTI_GameScript__CombatEventHandler;
extern const void * RTTI_GameScript__FragmentEventHandler;
extern const void * RTTI_GameScript__CustomEventHandler;
extern const void * RTTI_GameScript__Logger;
extern const void * RTTI_GameScript__InventoryEventHandler;
extern const void * RTTI_GameScript__Internal__LOSEventData;
extern const void * RTTI_GameScript__LOSEventHandler;
extern const void * RTTI_GameScript__Internal__LOSDetectionEventData;
extern const void * RTTI_GameScript__Internal__LOSDirectEventData;
extern const void * RTTI_GameScript__MenuEventHandler;
extern const void * RTTI_GameScript__PathingCallbackMgr;
extern const void * RTTI_GameScript__Internal__IProfileCallQuery;
extern const void * RTTI_GameScript__Profiler;
extern const void * RTTI_GameScript__QuestCallbackMgr;
extern const void * RTTI_GameScript__SavePatcher;
extern const void * RTTI_GameScript__SleepEventHandler;
extern const void * RTTI_GameScript__SoundCallbackMgr;
extern const void * RTTI_BSScript__IStore;
extern const void * RTTI_GameScript__Store;
extern const void * RTTI_BSResource__ArchiveFoundStreamCB;
extern const void * RTTI_BSCounterStorage;
extern const void * RTTI_BSScript__IObjectHandlePolicy;
extern const void * RTTI_GameVM;
extern const void * RTTI_GameScript__HandlePolicy;
extern const void * RTTI_GameScript__ObjectBindPolicy;
extern const void * RTTI_BSScript__IStackCallbackFunctor;
extern const void * RTTI_BSScript__IStackCallbackSaveInterface;
extern const void * RTTI_BSScript__IProfilePolicy;
extern const void * RTTI_BSScript__ILoader;
extern const void * RTTI_BSScript__ObjectBindPolicy;
extern const void * RTTI_BSScript__IClientVM;
extern const void * RTTI_BSScript__ISavePatcherInterface;
extern const void * RTTI_GameScript__BasicEventHandler;
extern const void * RTTI_GameScript__TeleportEventHandler;
extern const void * RTTI_GameScript__TimerEventHandler;
extern const void * RTTI_GameScript__TrackedStatsEventHandler;
extern const void * RTTI_GameScript__DistanceEventHandler;
extern const void * RTTI_GameScript__WaitEventHandler;
extern const void * RTTI_CCallbackBase;
extern const void * RTTI_BSSteamSystemUtility;
extern const void * RTTI_BSSteamAwardsSystemUtility;
extern const void * RTTI_Json__StyledWriter;
extern const void * RTTI_Json__Exception;
extern const void * RTTI_Json__RuntimeError;
extern const void * RTTI_Json__LogicError;
extern const void * RTTI_Json__CharReader;
extern const void * RTTI_Json__CharReader__Factory;
extern const void * RTTI_Json__CharReaderBuilder;
extern const void * RTTI_Json__StreamWriter;
extern const void * RTTI_Json__StreamWriter__Factory;
extern const void * RTTI_Json__StreamWriterBuilder;
extern const void * RTTI_Json__Writer;
extern const void * RTTI_Json__OurCharReader;
extern const void * RTTI_Json__BuiltStyledStreamWriter;
extern const void * RTTI_hkLoader;
extern const void * RTTI_BShkbHkxDB__QueuedHandles;
extern const void * RTTI_BShkbGlobalTransitionData;
extern const void * RTTI_BSAnimationDBData;
extern const void * RTTI_BShkbHkxDB__ProjectDBData;
extern const void * RTTI_BShkbHkxDB__hkxDBData;
extern const void * RTTI_BShkbHkxDB__StreamAdaptor;
extern const void * RTTI_hknpRefMaterial;
extern const void * RTTI_hknpMaterialLibrary;
extern const void * RTTI_hknpSurfaceVelocity;
extern const void * RTTI_hknpLinearSurfaceVelocity;
extern const void * RTTI_hkReferencedObjectLock;
extern const void * RTTI_hkTask;
extern const void * RTTI_hknpConstraintSolver;
extern const void * RTTI_hknpWeldingModifier;
extern const void * RTTI_hknpWorld;
extern const void * RTTI_hknpSimulation;
extern const void * RTTI_hknpContactConstraintSolver;
extern const void * RTTI_hknpCollisionDetector;
extern const void * RTTI_hkSecondaryCommandDispatcher;
extern const void * RTTI_hknpInternalCommandProcessor;
extern const void * RTTI_hknpConstraintAtomSolver;
extern const void * RTTI_hknpDefaultModifierSet;
extern const void * RTTI_hknpPostCollideTask;
extern const void * RTTI_hknpPostSolveTask;
extern const void * RTTI_hkDebugCommandProcessor;
extern const void * RTTI_hknpConvexCompositeCollisionDetector;
extern const void * RTTI_hknpCompositeCompositeCollisionDetector;
extern const void * RTTI_hknpCompositeCollisionDetector;
extern const void * RTTI_hknpSetShapeKeyACdDetector;
extern const void * RTTI_hknpShapeKeyArrayCacheCdDetector;
extern const void * RTTI_hknpApiCommandProcessor;
extern const void * RTTI_hknpManifoldEventCreator;
extern const void * RTTI_hknpSingleThreadedSimulation;
extern const void * RTTI_hknpContactImpulseClippedEventCreator;
extern const void * RTTI_hknpContactImpulseEventCreator;
extern const void * RTTI_hknpMassChangerModifier;
extern const void * RTTI_hknpTriggerModifier;
extern const void * RTTI_hknpRestitutionModifier;
extern const void * RTTI_hknpSoftContactModifier;
extern const void * RTTI_hknpTriangleWeldingModifier;
extern const void * RTTI_hknpNeighborWeldingModifier;
extern const void * RTTI_hknpMotionWeldingModifier;
extern const void * RTTI_hknpConvexConvexCollisionDetector;
extern const void * RTTI_hknpSignedDistanceFieldCollisionDetector;
extern const void * RTTI_hknpTriggerCollisionDetector;
extern const void * RTTI_hknpConstraintForceEventCreator;
extern const void * RTTI_hknpConstraintForceExceededEventCreator;
extern const void * RTTI_hknpMxContactSolver;
extern const void * RTTI_hknpStreamContactSolverBase;
extern const void * RTTI_hknpStreamContactSolver;
extern const void * RTTI_hknpActionManager;
extern const void * RTTI_hknpShapeMassProperties;
extern const void * RTTI_hknpPhysicsSystem;
extern const void * RTTI_hknpCompositeShape;
extern const void * RTTI_hknpHeightFieldShape;
extern const void * RTTI_hknpCompressedHeightFieldShape;
extern const void * RTTI_hkCrc32StreamWriter;
extern const void * RTTI_hkTagfileWriter;
extern const void * RTTI_hkTagfileWriter__AddDataObjectListener;
extern const void * RTTI_hkTypeInfoRegistry;
extern const void * RTTI_hkTagfileReader;
extern const void * RTTI_hkBinaryTagfileWriter;
extern const void * RTTI_hkXmlTagfileReader;
extern const void * RTTI_hkXmlTagfileWriter;
extern const void * RTTI_hkMemoryAllocator;
extern const void * RTTI_hkContainerTempAllocator__Allocator;
extern const void * RTTI_hkContainerHeapAllocator__Allocator;
extern const void * RTTI_hkContainerDebugAllocator__Allocator;
extern const void * RTTI_hkVtableClassRegistry;
extern const void * RTTI_hkClassNameRegistry;
extern const void * RTTI_hkBuiltinTypeRegistry;
extern const void * RTTI_hkDynamicClassNameRegistry;
extern const void * RTTI_hkDefaultClassNameRegistry;
extern const void * RTTI_hkDefaultBuiltinTypeRegistry;
extern const void * RTTI_hkLifoAllocator;
extern const void * RTTI_hkcdGskBase__ShapeInterface;
extern const void * RTTI_hkcdGsk_Vector4ShapeInterface;
extern const void * RTTI_hknpTriangleShape;
extern const void * RTTI_hknpDynamicCompoundShapeData;
extern const void * RTTI_hknpShapeKeyMask;
extern const void * RTTI_hknpCompoundShapeKeyMask;
extern const void * RTTI_hknpStaticCompoundShapeData;
extern const void * RTTI_hknpCompoundShapeInternalsKeyMask;
extern const void * RTTI_hknpStaticCompoundShapeKeyMask;
extern const void * RTTI_hkGeometryUtils__IVertices;
extern const void * RTTI_hkcdSimdTree;
extern const void * RTTI_hkcdSimdTree__LeafCollector;
extern const void * RTTI_hknpCompressedMeshShapeData;
extern const void * RTTI_hknpCompressedMeshShapeInternals__KeyMask;
extern const void * RTTI_BSAnimationGraphManager;
extern const void * RTTI_SubgraphAndOffsetDBData;
extern const void * RTTI_AnimationClipDataSingleton;
extern const void * RTTI_hkaSkeleton;
extern const void * RTTI_hkbEventPayload;
extern const void * RTTI_hkbStringEventPayload;
extern const void * RTTI_hkbAnimationBindingSet;
extern const void * RTTI_BShkbAnimationGraph;
extern const void * RTTI_BSIRagdollDriver;
extern const void * RTTI_BSAnimationGraphLoadScrapper;
extern const void * RTTI_bhkIWorldStepListener;
extern const void * RTTI_AnimationSpeedInformationDBData;
extern const void * RTTI_hknpCompoundShape;
extern const void * RTTI_hknpDynamicCompoundShape;
extern const void * RTTI_hkcdSimdTree__BuildContext;
extern const void * RTTI_hknpExternMeshShapeData;
extern const void * RTTI_hknpExternMeshShapeBuildContext;
extern const void * RTTI_hknpCharacterContext;
extern const void * RTTI_IAnimationClipLoaderSingleton;
extern const void * RTTI_AnimationFileManagerSingleton;
extern const void * RTTI_AnimationStanceDataSingletonDBData;
extern const void * RTTI_IAnimationStanceData;
extern const void * RTTI_hkFileSystem__Iterator__Impl;
extern const void * RTTI_hkErrStream;
extern const void * RTTI_hknpScaledConvexShapeBase;
extern const void * RTTI_hknpScaledConvexShape;
extern const void * RTTI_hknpMotionPropertiesLibrary;
extern const void * RTTI_AnimationSpeedContour;
extern const void * RTTI_IndividualClipAnimationSpeedContour;
extern const void * RTTI_SpeedSampledAnimationSpeedContour;
extern const void * RTTI_CollectionAnimationSpeedContour;
extern const void * RTTI_hkbBehaviorGraph__GlobalTransitionData;
extern const void * RTTI_hkbSymbolIdMap;
extern const void * RTTI_IBehaviorGraphSwapSingleton;
extern const void * RTTI_IBehaviorGraphSymbolSwapSingleton;
extern const void * RTTI_BSBehaviorGraphSwapSingleton;
extern const void * RTTI_BShkbUtils__SearchAllStateMachineChildrenFunctor;
extern const void * RTTI_IiStateTaggingListenerSingleton;
extern const void * RTTI_BSiStateTaggingListenerSingleton;
extern const void * RTTI_hkbRagdollDriver;
extern const void * RTTI_BSIRagdollDriverSingleton;
extern const void * RTTI_hkbAssetLoader;
extern const void * RTTI_IStateMachineCallbackSingleton;
extern const void * RTTI_BSStateMachineCallbackSingleton;
extern const void * RTTI_BSSubBehaviorGraphSingletonData;
extern const void * RTTI_BSSubBehaviorGraphSingletonDataAddToDeferredDeleterTask;
extern const void * RTTI_BShkVisibilityController;
extern const void * RTTI_hkbNode;
extern const void * RTTI_hkbGenerator;
extern const void * RTTI_hkbStateListener;
extern const void * RTTI_BSiStateTaggingGenerator;
extern const void * RTTI_BSiStateTaggingStateListener;
extern const void * RTTI_BGSGamebryoSequenceGenerator;
extern const void * RTTI_BSLimbIKModifierCastInfo;
extern const void * RTTI_BSILimbIKModifierSingleton;
extern const void * RTTI_hkaFootPlacementIkSolver;
extern const void * RTTI_BSIAlignBoneModifierSingleton;
extern const void * RTTI_BSILookAtModifierSingleton;
extern const void * RTTI_hknpCharacterStateManager;
extern const void * RTTI_hkbFootIkDriver;
extern const void * RTTI_hkbPoseMatchingGeneratorInternalState;
extern const void * RTTI_hkbRagdollInterface;
extern const void * RTTI_hkbnpSerializedRagdollInterface;
extern const void * RTTI_hkbnpRagdollSkeletonRemapData;
extern const void * RTTI_hkbnpRagdollScaledSkeleton;
extern const void * RTTI_hkbnpRagdollInterface;
extern const void * RTTI_BSIDirectAtModifierSingleton;
extern const void * RTTI_BSIPassByTargetTriggerModifierSingleton;
extern const void * RTTI_BSIRagdollContactListenerModifierSingleton;
extern const void * RTTI_hkbBehaviorGraph;
extern const void * RTTI_hkbNodeInternalStateInfo;
extern const void * RTTI_hkbVariableValueSet;
extern const void * RTTI_hkBufferedStreamReader;
extern const void * RTTI_hkSeekableStreamReader;
extern const void * RTTI_hkResource;
extern const void * RTTI_LOCALNAMESPACE__hkNativeResource;
extern const void * RTTI_hkOstream;
extern const void * RTTI_hkMemoryTrackStreamWriter;
extern const void * RTTI_hkArrayStreamWriter;
extern const void * RTTI_hkSignal0__Slot;
extern const void * RTTI_hkTaskQueue;
extern const void * RTTI_hkTaskQueue__EmptyTask;
extern const void * RTTI_hkBlockStreamCommandWriter;
extern const void * RTTI_ErrorCommandDispatcher;
extern const void * RTTI_hknpBroadPhaseConfig;
extern const void * RTTI_hknpDefaultBroadPhaseConfig;
extern const void * RTTI_hknpShapeTagCodec;
extern const void * RTTI_hknpNullShapeTagCodec;
extern const void * RTTI_hknpConstraintCollisionFilter;
extern const void * RTTI_hknpBodyQualityLibrary;
extern const void * RTTI_hknpEventDispatcher;
extern const void * RTTI_hknpEventMergeAndDispatcher;
extern const void * RTTI_hknpSpaceSplitter;
extern const void * RTTI_hknpSingleCellSpaceSplitter;
extern const void * RTTI_hknpGridSpaceSplitter;
extern const void * RTTI_hknpDynamicSpaceSplitter;
extern const void * RTTI_hknpMultithreadedSimulation;
extern const void * RTTI_hknpNarrowPhaseTask;
extern const void * RTTI_hknpSurfaceVelocityModifier;
extern const void * RTTI_hknpBroadPhase;
extern const void * RTTI_hknpHybridBroadPhase;
extern const void * RTTI_hkOArchive;
extern const void * RTTI_hkPackfileWriter;
extern const void * RTTI_hkIstream;
extern const void * RTTI_hkDataWorld;
extern const void * RTTI_hkDataObjectImpl;
extern const void * RTTI_hkDataArrayImpl;
extern const void * RTTI_hkDataClassImpl;
extern const void * RTTI_hkDataRefCounted;
extern const void * RTTI_hkDataClassDict;
extern const void * RTTI_hkDataObjectDict;
extern const void * RTTI_hkDataWorldDict;
extern const void * RTTI_VariableIntArrayImplementation;
extern const void * RTTI_ByteArrayImplementation;
extern const void * RTTI_ArrayOfTuplesImplementation;
extern const void * RTTI_ArrayOfTuplesImplementation__View;
extern const void * RTTI_RealArrayImplementation;
extern const void * RTTI_RealArrayView;
extern const void * RTTI_VecArrayImplementation;
extern const void * RTTI_PointerArrayImplementation;
extern const void * RTTI_CstringArrayImplementation;
extern const void * RTTI_ArrayArrayImplementation;
extern const void * RTTI_StructArrayImplementation;
extern const void * RTTI_StructArrayImplementation__Object;
extern const void * RTTI_hkDataClassNative;
extern const void * RTTI_hkDataWorldNative;
extern const void * RTTI_hkDataObjectNative;
extern const void * RTTI_hkDataArrayNative;
extern const void * RTTI_hkSubStreamWriter;
extern const void * RTTI_hkBinaryPackfileWriter;
extern const void * RTTI_hkBinaryTagfileReader;
extern const void * RTTI_hkVersionPatchManager;
extern const void * RTTI_hkVersionPatchManager__ClassWrapper;
extern const void * RTTI_hkDefaultClassWrapper;
extern const void * RTTI_hkSerializeDeprecated;
extern const void * RTTI_hkMallocAllocator;
extern const void * RTTI_hkStaticClassNameRegistry;
extern const void * RTTI_hknpGlobals;
extern const void * RTTI_hkgpConvexHull;
extern const void * RTTI_hkcdSimdTree__IParallelBuild__IRunnable;
extern const void * RTTI_hkcdSimdTreeUtils__Build__EmptyRunnable;
extern const void * RTTI_hkcdSimdTreeUtils__Build__IRefit;
extern const void * RTTI_hkcdSimdTreeUtils__Build__Task;
extern const void * RTTI_hkbEventPayloadList;
extern const void * RTTI_hkaSkeletonMapper;
extern const void * RTTI_hkbAnimationBindingWithTriggers;
extern const void * RTTI_hkbCharacterSetup;
extern const void * RTTI_hkbHandIkDriver;
extern const void * RTTI_hkbHandle;
extern const void * RTTI_hkbCharacter;
extern const void * RTTI_hkbDockingDriver;
extern const void * RTTI_hkaBoneAttachment;
extern const void * RTTI_hknpArrayAction;
extern const void * RTTI_hknpEaseConstraintsAction;
extern const void * RTTI_hkHardwareInfo;
extern const void * RTTI_hkDummySingleton;
extern const void * RTTI_hkStdioStreamReader;
extern const void * RTTI_hkWin32StreamWriter;
extern const void * RTTI_hkBufferedStreamWriter;
extern const void * RTTI_hknpDecoratorShape;
extern const void * RTTI_hkbBindable;
extern const void * RTTI_hkbStateMachine;
extern const void * RTTI_hkbStateMachine__TransitionInfoArray;
extern const void * RTTI_hkbStateMachine__EventPropertyArray;
extern const void * RTTI_hkbStateMachine__StateInfo;
extern const void * RTTI_BSBehaviorGraphSwapGenerator;
extern const void * RTTI_hkbReferencePoseGenerator;
extern const void * RTTI_hkbBehaviorReferenceGenerator;
extern const void * RTTI_hkaAnimationBinding;
extern const void * RTTI_hkbClipGenerator;
extern const void * RTTI_hkbClipTriggerArray;
extern const void * RTTI_hkbBehaviorGraphStringData;
extern const void * RTTI_hkaAnimationContainer;
extern const void * RTTI_hkbBindableCollector;
extern const void * RTTI_hkbBindable__CacheBindablesCollector;
extern const void * RTTI_hkbNode__BoundVariablesCollector;
extern const void * RTTI_hkbReferencedGeneratorSyncInfo;
extern const void * RTTI_hkbWorld;
extern const void * RTTI_hkbSceneModifier;
extern const void * RTTI_hkbFootIkSceneModifier;
extern const void * RTTI_hkbHandIkSceneModifier;
extern const void * RTTI_hkbHandIkFixupSceneModifier;
extern const void * RTTI_hkbDockingSceneModifier;
extern const void * RTTI_hkbBoneWeightArray;
extern const void * RTTI_hkbBlenderGeneratorChild;
extern const void * RTTI_hkbBlenderGenerator;
extern const void * RTTI_hkbPoseMatchingGenerator;
extern const void * RTTI_hkbTransitionEffect;
extern const void * RTTI_hkbGeneratorTransitionEffect;
extern const void * RTTI_hkbPhysicsInterface;
extern const void * RTTI_hknpGroupCollisionFilter;
extern const void * RTTI_hkbnpPhysicsInterface;
extern const void * RTTI_hknpCharacterProxyCinfo;
extern const void * RTTI_hknpCharacterRigidBodyCinfo;
extern const void * RTTI_hknpRagdollData;
extern const void * RTTI_hknpRagdoll;
extern const void * RTTI_hknpBreakableConstraintData;
extern const void * RTTI_hkaDefaultAnimationControl;
extern const void * RTTI_hkaDefaultAnimationControlMapperData;
extern const void * RTTI_hkbProjectStringData;
extern const void * RTTI_hkbProjectData;
extern const void * RTTI_hkMemoryTrackStreamReader;
extern const void * RTTI_hkStackTracer;
extern const void * RTTI_hkDebugDisplay;
extern const void * RTTI_hkDebugDisplayHandler;
extern const void * RTTI_hkProcess;
extern const void * RTTI_hkDebugDisplayProcess;
extern const void * RTTI_hknpPairCollisionFilter;
extern const void * RTTI_hknpSolverData;
extern const void * RTTI_hknpSingleThreadedSolverData;
extern const void * RTTI_hknpPrepareNarrowPhaseTask;
extern const void * RTTI_hknpPrepare2ndRoundNarrowPhaseTask;
extern const void * RTTI_hknpPrepareConstraintsTask;
extern const void * RTTI_hknpBuildConstraintJacobiansTask;
extern const void * RTTI_hknpSolverTask;
extern const void * RTTI_hknpConvexConvexShapeBaseInterface;
extern const void * RTTI_hknpHBPUpdateDirtyBodiesTask;
extern const void * RTTI_hknpHBPUpdateTreeTask;
extern const void * RTTI_hknpHBPTreeVsTreeTask;
extern const void * RTTI_hknpHBPFinishUpdateTask;
extern const void * RTTI_hkDisplayGeometry;
extern const void * RTTI_hkDisplaySphere;
extern const void * RTTI_hkDisplayCapsule;
extern const void * RTTI_hkDisplayConvex;
extern const void * RTTI_hkDisplayAABB;
extern const void * RTTI_hkDisplayWireframe;
extern const void * RTTI_hkpConstraintData;
extern const void * RTTI_hkpLimitedHingeConstraintData;
extern const void * RTTI_hkpFixedConstraintData;
extern const void * RTTI_hkpDeformableFixedConstraintData;
extern const void * RTTI_hkpRagdollLimitsData;
extern const void * RTTI_hkpHingeLimitsData;
extern const void * RTTI_hkpStiffSpringConstraintData;
extern const void * RTTI_hkpBallAndSocketConstraintData;
extern const void * RTTI_hkpWheelConstraintData;
extern const void * RTTI_hkpHingeConstraintData;
extern const void * RTTI_hkpPrismaticConstraintData;
extern const void * RTTI_hkpRagdollConstraintData;
extern const void * RTTI_hkpPointToPlaneConstraintData;
extern const void * RTTI_hkpPulleyConstraintData;
extern const void * RTTI_hkpPointToPathConstraintData;
extern const void * RTTI_hkOffsetOnlyStreamWriter;
extern const void * RTTI_hkObjectWriter;
extern const void * RTTI_hkPlatformObjectWriter;
extern const void * RTTI_hkPlatformObjectWriter__Cache;
extern const void * RTTI_hkMemoryStreamReader;
extern const void * RTTI_hkTypeManager;
extern const void * RTTI_hkPackfileData;
extern const void * RTTI_hkObjectResource;
extern const void * RTTI_hkIArchive;
extern const void * RTTI_hkParserBuffer;
extern const void * RTTI_hkXmlStreamParser;
extern const void * RTTI_hkXmlParser;
extern const void * RTTI_hkXmlParser__StartElement;
extern const void * RTTI_hkXmlParser__EndElement;
extern const void * RTTI_hkXmlParser__Characters;
extern const void * RTTI_hkXmlParser__Node;
extern const void * RTTI_hkgpMesh;
extern const void * RTTI_hkgpMesh__IConvexOverlap;
extern const void * RTTI_hkgpMesh__IConvexOverlap__IConvexShape;
extern const void * RTTI_hkgpMesh__TriangleShape;
extern const void * RTTI_hkgpMesh__ExternShape;
extern const void * RTTI_hkgpTriangulatorBase;
extern const void * RTTI_hkgpJobQueue__IJob;
extern const void * RTTI_IConvexOverlapImpl;
extern const void * RTTI_IConvexOverlapImpl__ShapeInterface;
extern const void * RTTI_hkgpIndexedMesh;
extern const void * RTTI_hkgpIndexedMesh__IVertexRemoval;
extern const void * RTTI_hkgpIndexedMesh__ITriangleRemoval;
extern const void * RTTI_hkgpIndexedMesh__IEdgeCollapse;
extern const void * RTTI_hkgpIndexedMeshInternals__DefaultEdgeCollapseInterface;
extern const void * RTTI_hkbRealEventPayload;
extern const void * RTTI_hkbIntEventPayload;
extern const void * RTTI_hkbNamedEventPayload;
extern const void * RTTI_hkbNamedRealEventPayload;
extern const void * RTTI_hkbNamedIntEventPayload;
extern const void * RTTI_hkbNamedStringEventPayload;
extern const void * RTTI_hkaMirroredSkeleton;
extern const void * RTTI_hkSimpleLocalFrame;
extern const void * RTTI_hkbCharacterControllerDriver;
extern const void * RTTI_hkbCharacterData;
extern const void * RTTI_hkbProjectAssetManager;
extern const void * RTTI_hkDefaultError;
extern const void * RTTI_hkSocket;
extern const void * RTTI_hkSocket__ReaderAdapter;
extern const void * RTTI_hkSocket__WriterAdapter;
extern const void * RTTI_hkbStateMachineInternalState;
extern const void * RTTI_hkaAnimationControl;
extern const void * RTTI_hkbClipGeneratorInternalState;
extern const void * RTTI_hkaAnimation;
extern const void * RTTI_hkaReferencePoseAnimation;
extern const void * RTTI_hkbBehaviorGraphData;
extern const void * RTTI_hkbCondition;
extern const void * RTTI_hkbExpressionCondition;
extern const void * RTTI_hkbParametricMotionGenerator;
extern const void * RTTI_hkbAssetBundle;
extern const void * RTTI_hkbFootIkDriverInfo;
extern const void * RTTI_hkbCharacterStringData;
extern const void * RTTI_hkbHandIkDriverInfo;
extern const void * RTTI_hkbMirroredSkeletonInfo;
extern const void * RTTI_hkbVariableBindingSet;
extern const void * RTTI_hkbAttachmentSceneModifier;
extern const void * RTTI_hkbAttachmentFixupSceneModifier;
extern const void * RTTI_hkbRagdollSceneModifier;
extern const void * RTTI_hkbCharacterControllerSceneModifier;
extern const void * RTTI_hkbBlenderGeneratorInternalState;
extern const void * RTTI_hkbGeneratorTransitionEffectInternalState;
extern const void * RTTI_hkLocalFrameGroup;
extern const void * RTTI_hkLocalFrame;
extern const void * RTTI_hkBlockStreamAllocator;
extern const void * RTTI_hkFixedBlockStreamAllocator;
extern const void * RTTI_hkbnpCharacterProxyController;
extern const void * RTTI_hkbnpCharacterRigidBodyController;
extern const void * RTTI_hkbRagdollController;
extern const void * RTTI_hkbnpRagdollPoweredConstraintController;
extern const void * RTTI_hkbnpRagdollRigidBodyController;
extern const void * RTTI_hkVisualDebugger;
extern const void * RTTI_hkpWrappedConstraintData;
extern const void * RTTI_hkObjectCopier;
extern const void * RTTI_hkbSequencedData;
extern const void * RTTI_hkbEventSequencedData;
extern const void * RTTI_hkbRealVariableSequencedData;
extern const void * RTTI_hkbBoolVariableSequencedData;
extern const void * RTTI_hkbIntVariableSequencedData;
extern const void * RTTI_hkbSequenceStringData;
extern const void * RTTI_hkbModifier;
extern const void * RTTI_hkbSequence;
extern const void * RTTI_hkProcessFactory;
extern const void * RTTI_hknpSolverSchedulerTask;
extern const void * RTTI_hkXmlLexAnalyzer;
extern const void * RTTI_hkgpIndexedMesh__EdgeBarrier;
extern const void * RTTI_hkgpCgoInternal__ICollapse;
extern const void * RTTI_hkLocalFrameCollector;
extern const void * RTTI_hkbClosestLocalFrameCollector;
extern const void * RTTI_hkbInternal__hks__Visitor;
extern const void * RTTI_hkbInternal__hks__MemoryAllocationsByType;
extern const void * RTTI_hkbInternal__hks__netTransport;
extern const void * RTTI_hkbInternal__hks__netTransportTCPIP;
extern const void * RTTI_hkbInternal__LuaPlus__LuaStateOutFile;
extern const void * RTTI_hkbInternal__hks__CompilerStateInterface;
extern const void * RTTI_hkbInternal__hks__CompilerParseAcceptor;
extern const void * RTTI_hkbInternal__hks__CodeGenerator;
extern const void * RTTI_hkbInternal__hks__SimpleCompilerState;
extern const void * RTTI_hkbInternal__hks__Preprocessor;
extern const void * RTTI_hkbInternal__hks__Preprocessor__PreprocessorStateProxy;
extern const void * RTTI_hkbInternal__hks__IProfiler;
extern const void * RTTI_hkbInternal__hks__FrequencyProfiler;
extern const void * RTTI_hkbInternal__hks__GettableProfiler;
extern const void * RTTI_hkbInternal__hks__ChunkVisitor;
extern const void * RTTI_hkbInternal__hks__ReachableChunksAreValid;
extern const void * RTTI_hkbInternal__hks__HeapVisualizer;
extern const void * RTTI_hkbScriptAssetLoader;
extern const void * RTTI_hkBsdSocket;
extern const void * RTTI_hkbCompiledExpressionSet;
extern const void * RTTI_hkbProceduralBlenderGenerator;
extern const void * RTTI_hkxAttributeHolder;
extern const void * RTTI_hkxMesh__UserChannelInfo;
extern const void * RTTI_hkaMeshBinding;
extern const void * RTTI_hkbCharacterController;
extern const void * RTTI_hkbnpCharacterController;
extern const void * RTTI_hknpCharacterProxy;
extern const void * RTTI_hknpCharacterProxyInternals__QueryCollector;
extern const void * RTTI_hknpCharacterRigidBody;
extern const void * RTTI_hknpRagdollMotorController;
extern const void * RTTI_hknpRagdollController;
extern const void * RTTI_hknpRagdollKeyFrameHierarchyController;
extern const void * RTTI_hkProcessHandler;
extern const void * RTTI_hkServerProcessHandler;
extern const void * RTTI_hkCommandRouter;
extern const void * RTTI_hkbSequenceInternalState;
extern const void * RTTI_hkMemorySystem;
extern const void * RTTI_hkbDockingTarget;
extern const void * RTTI_hkbLineDockingTarget;
extern const void * RTTI_hkbPlaneDockingTarget;
extern const void * RTTI_hkxMeshSection;
extern const void * RTTI_hkxMesh;
extern const void * RTTI_hkInspectProcess;
extern const void * RTTI_hkMemorySnapshotProcess;
extern const void * RTTI_hkRemoteObjectProcess;
extern const void * RTTI_hkStatisticsProcess;
extern const void * RTTI_hkDisplaySerializeOStream;
extern const void * RTTI_hkReplayStreamReader;
extern const void * RTTI_hkServerDebugDisplayHandler;
extern const void * RTTI_hkDisplaySerializeIStream;
extern const void * RTTI_hkxIndexBuffer;
extern const void * RTTI_hkxMaterial;
extern const void * RTTI_hkxVertexAnimation;
extern const void * RTTI_hkVdbCommandWriter;
extern const void * RTTI_hkMonitorStreamColorTable;
extern const void * RTTI_hkDisplayCone;
extern const void * RTTI_hkDisplaySemiCircle;
extern const void * RTTI_hkDisplayPlane;
extern const void * RTTI_hkDisplayMesh;
extern const void * RTTI_hkDisplayBox;
extern const void * RTTI_hkDisplayCylinder;
extern const void * RTTI_hkDisplayTaperedCapsule;
extern const void * RTTI_hkxVertexBuffer;
extern const void * RTTI_hkIndexedTransformSet;
extern const void * RTTI_hkxSparselyAnimatedBool;
extern const void * RTTI_hkxSparselyAnimatedInt;
extern const void * RTTI_hkxEnum;
extern const void * RTTI_hkxSparselyAnimatedEnum;
extern const void * RTTI_hkxSparselyAnimatedString;
extern const void * RTTI_hkxAnimatedFloat;
extern const void * RTTI_hkxAnimatedVector;
extern const void * RTTI_hkxAnimatedQuaternion;
extern const void * RTTI_hkxAnimatedMatrix;
extern const void * RTTI_hkTrackerScanSnapshot;
extern const void * RTTI_hkTrackerTypeTreeCache;
extern const void * RTTI_hkTrackerArrayLayoutHandler;
extern const void * RTTI_hkTrackerPointerMapLayoutHandler;
extern const void * RTTI_hkTrackerStringPtrLayoutHandler;
extern const void * RTTI_hkTrackerStringMapLayoutHandler;
extern const void * RTTI_hkTrackerTypeLayout;
extern const void * RTTI_hkTrackerLayoutCalculator;
extern const void * RTTI_hkTrackerLayoutHandler;
extern const void * RTTI_hkTrackerRefPtrLayoutHandler;
extern const void * RTTI_hkTrackerQueueLayoutHandler;
extern const void * RTTI_hkTrackerPadSpuLayoutHandler;
extern const void * RTTI_hkTrackerJobQueueLayoutHandler;
extern const void * RTTI_hkTrackerJobQueueDynamicDataLayoutHandler;
extern const void * RTTI_hkTrackerSetLayoutHandler;
extern const void * RTTI_hkTrackerFlagsLayoutHandler;
extern const void * RTTI_hkTrackerEnumLayoutHandler;
extern const void * RTTI_hkMeshBody;
extern const void * RTTI_hkMemoryMeshBody;
extern const void * RTTI_hkMemoryTracker;
extern const void * RTTI_hkDummyMemoryTrackerImpl;
extern const void * RTTI_hkDefaultMemoryTracker;
extern const void * RTTI_AudioLoadForPlaybackTask;
extern const void * RTTI_AudioLoadToCacheTask;
extern const void * RTTI_BSAudioManagerThread;
extern const void * RTTI_BSNullImplAudio;
extern const void * RTTI_BSIAudioEffectParameters;
extern const void * RTTI_BSAudioEffects__BSOverdriveParams;
extern const void * RTTI_BSAudioEffects__BSStateVariableFilterParams;
extern const void * RTTI_BSAudioEffects__BSDelayEffectParams;
extern const void * RTTI_BSAudio;
extern const void * RTTI_BSGameSound;
extern const void * RTTI_BSXAudio2Audio;
extern const void * RTTI_BSAudioListener;
extern const void * RTTI_BSNullImplAudioListener;
extern const void * RTTI_BSNullImplGameSound;
extern const void * RTTI_BSXAudio2AudioListener;
extern const void * RTTI_BSAudioDataSrcBase;
extern const void * RTTI_BSXAudio2DataSrc;
extern const void * RTTI_BSXAudio2GameSound;
extern const void * RTTI_BSIAudioEffectVisitorBase;
extern const void * RTTI_BSCXAPOWrapper;
extern const void * RTTI_BSCompanionIListener;
extern const void * RTTI_BSCompanionThread;
extern const void * RTTI_BSCompanionAutodiscover;
extern const void * RTTI_BSByteBuffer;
extern const void * RTTI_BSCompanionConnection;
extern const void * RTTI_BSCompanionDirectListener;
extern const void * RTTI_BSCompanionDirectConnection;
extern const void * RTTI_BSCompanionSocket;
extern const void * RTTI_ScrapHeap;
extern const void * RTTI_BSThread;
extern const void * RTTI_CompactingStore__Store;
extern const void * RTTI_CompactingStore__MoveCallback;
extern const void * RTTI_CompactingStore__NoopMoveCallback;
extern const void * RTTI_MemoryHeap;
extern const void * RTTI_UnitTestMemoryHeap;
extern const void * RTTI_IMemoryHeap;
extern const void * RTTI_ZeroOverheadHeap;
extern const void * RTTI_UnitTestZeroOverheadHeap;
extern const void * RTTI_BSTGlobalEvent;
extern const void * RTTI_BSSmallBlockAllocator;
extern const void * RTTI_BSSmallBlockAllocatorUtil__UserPoolBase;
extern const void * RTTI_IMemoryStoreBase;
extern const void * RTTI_IMemoryStore;
extern const void * RTTI_AbstractHeap;
extern const void * RTTI_MouseMoveEvent;
extern const void * RTTI_CursorMoveEvent;
extern const void * RTTI_ThumbstickEvent;
extern const void * RTTI_CharacterEvent;
extern const void * RTTI_DeviceConnectEvent;
extern const void * RTTI_KinectEvent;
extern const void * RTTI_BSInputDevice;
extern const void * RTTI_BSGamepadDevice;
extern const void * RTTI_BSPCKeyboardDevice;
extern const void * RTTI_BSPCMouseDevice;
extern const void * RTTI_BSKeyboardDevice;
extern const void * RTTI_BSPCVirtualKeyboardDevice;
extern const void * RTTI_BSPCGamepadDeviceDelegate;
extern const void * RTTI_BSPCGamepadDeviceHandler;
extern const void * RTTI_BSPCGamepadDevice;
extern const void * RTTI_BSPCOrbisGamepadDevice;
extern const void * RTTI_BSMouseDevice;
extern const void * RTTI_BSVirtualKeyboardDevice;
extern const void * RTTI_NiFile;
extern const void * RTTI_NiBinaryStream;
extern const void * RTTI_NiAllocator;
extern const void * RTTI_BSNiAllocator;
extern const void * RTTI_NiStandardAllocator;
extern const void * RTTI_NiSearchPath;
extern const void * RTTI_NiMemStream;
extern const void * RTTI_BSStringPool__IterationCallback;
extern const void * RTTI_BSSystemFileAsyncFunctor;
extern const void * RTTI_BSSystemFileStreamer__Streamer;
extern const void * RTTI_BSSystemFileStreamer__Streamer__StreamerThread;
extern const void * RTTI_BSSystemFileStreamer__Streamer__ControlThread;
extern const void * RTTI_BSSystemFileStreamer__Streamer__PhysicalReadThread;
extern const void * RTTI_BSJobs__JobThread;
extern const void * RTTI_BSFile;
extern const void * RTTI_BSFile__PageCache__PhysReadType;
extern const void * RTTI_Archive;
extern const void * RTTI_ArchiveFile;
extern const void * RTTI_CompressedArchiveFile;
extern const void * RTTI_BSTaskJobber;
extern const void * RTTI_BSTaskJobber__Task;
extern const void * RTTI_BSSystemFileStorage;
extern const void * RTTI_BSSocket;
extern const void * RTTI_BSSearchPath;
extern const void * RTTI_BSListenSocket;
extern const void * RTTI_BSTaskletManager;
extern const void * RTTI_BSWin32TaskletManager;
extern const void * RTTI_BSTaskletGroupData;
extern const void * RTTI_BSTasklet;
extern const void * RTTI_BSTaskletData;
extern const void * RTTI_BSTaskletManagerCallback;
extern const void * RTTI_BSWin32TaskletGroupData;
extern const void * RTTI_BSResource__IEntryDB;
extern const void * RTTI_BSResource__IEntryDB__PostFlushNotify;
extern const void * RTTI_BSResource__Stream;
extern const void * RTTI_BSResource__AsyncStream;
extern const void * RTTI_BSResource__StreamBase;
extern const void * RTTI_BSResource__Archive2__ReaderStream;
extern const void * RTTI_BSResource__Archive2__Index;
extern const void * RTTI_BSResource__Archive2__Manager__MemoryCacheLocation;
extern const void * RTTI_BSResource__Archive2__AsyncReaderStream;
extern const void * RTTI_BSResource__SDirectory2__ThreadCursor;
extern const void * RTTI_BSResource__LocationTraverser;
extern const void * RTTI_BSResource__CacheDrive;
extern const void * RTTI_BSResource__ICacheDriveOp;
extern const void * RTTI_BSResource__CacheDrive__Impl;
extern const void * RTTI_BSResource__CacheDrive__Task;
extern const void * RTTI_BSResource__MemoryFileLocation;
extern const void * RTTI_BSResource__MemoryFileStream;
extern const void * RTTI_BSResourceNiBinaryStream;
extern const void * RTTI_NiObject;
extern const void * RTTI_NiExtraData;
extern const void * RTTI_NiObjectNET;
extern const void * RTTI_NiNode;
extern const void * RTTI_BSGeometrySegmentData;
extern const void * RTTI_IRendererResourceManager;
extern const void * RTTI_BSFlattenedBoneTree;
extern const void * RTTI_NiAVObject;
extern const void * RTTI_NiTexture;
extern const void * RTTI_NiTimeController;
extern const void * RTTI_NiSwitchNode;
extern const void * RTTI_NiPointLight;
extern const void * RTTI_NiStringExtraData;
extern const void * RTTI_BSPositionData;
extern const void * RTTI_NiCamera;
extern const void * RTTI_NiGeometryData;
extern const void * RTTI_BSGeometry;
extern const void * RTTI_BSSkin__BoneData;
extern const void * RTTI_BSSkin__Instance;
extern const void * RTTI_NiIntegerExtraData;
extern const void * RTTI_NiLight;
extern const void * RTTI_BSTriShape;
extern const void * RTTI_BSDynPosData;
extern const void * RTTI_NiParticles;
extern const void * RTTI_NiStream;
extern const void * RTTI_NiAVObjectPalette;
extern const void * RTTI_NiDefaultAVObjectPalette;
extern const void * RTTI_NiDirectionalLight;
extern const void * RTTI_BSDynamicTriShape;
extern const void * RTTI_NiIntegersExtraData;
extern const void * RTTI_NiCullingProcess;
extern const void * RTTI_BSSegmentedTriShape;
extern const void * RTTI_NiGeometry;
extern const void * RTTI_NiTriBasedGeom;
extern const void * RTTI_NiTriShape;
extern const void * RTTI_NiSkinPartition;
extern const void * RTTI_NiSkinData;
extern const void * RTTI_NiSkinInstance;
extern const void * RTTI_NiShadeProperty;
extern const void * RTTI_NiAlphaAccumulator;
extern const void * RTTI_NiAmbientLight;
extern const void * RTTI_NiBinaryExtraData;
extern const void * RTTI_NiBooleanExtraData;
extern const void * RTTI_NiBSPNode;
extern const void * RTTI_NiColorExtraData;
extern const void * RTTI_NiFloatExtraData;
extern const void * RTTI_NiFloatsExtraData;
extern const void * RTTI_NiFogProperty;
extern const void * RTTI_NiParticlesData;
extern const void * RTTI_NiParticleMeshesData;
extern const void * RTTI_NiParticleMeshes;
extern const void * RTTI_NiSpotLight;
extern const void * RTTI_NiStringsExtraData;
extern const void * RTTI_NiSwitchStringExtraData;
extern const void * RTTI_NiTriShapeData;
extern const void * RTTI_NiTriStripsData;
extern const void * RTTI_NiTriStrips;
extern const void * RTTI_NiVectorExtraData;
extern const void * RTTI_BSLODTriShape;
extern const void * RTTI_NiAdditionalGeometryData;
extern const void * RTTI_NiAccumulator;
extern const void * RTTI_NiBackToFrontAccumulator;
extern const void * RTTI_NiTriBasedGeomData;
extern const void * RTTI_NiPick__Results;
extern const void * RTTI_NiCollisionTraversals__IFindIntersections;
extern const void * RTTI_NiCollisionData;
extern const void * RTTI_NiBoundingVolume;
extern const void * RTTI_NiBoxBV;
extern const void * RTTI_NiCapsuleBV;
extern const void * RTTI_NiHalfSpaceBV;
extern const void * RTTI_NiSphereBV;
extern const void * RTTI_NiUnionBV;
extern const void * RTTI_NiOBBRoot;
extern const void * RTTI_NiIntersector;
extern const void * RTTI_NiBoxSphereIntersector;
extern const void * RTTI_NiBoxCapsuleIntersector;
extern const void * RTTI_NiCapsuleCapsuleIntersector;
extern const void * RTTI_NiCapsuleSphereIntersector;
extern const void * RTTI_NiCapsuleTriIntersector;
extern const void * RTTI_NiSphereTriIntersector;
extern const void * RTTI_NiOBBNode;
extern const void * RTTI_NiOBBLeaf;
extern const void * RTTI_NiControllerManager;
extern const void * RTTI_NiControllerSequence;
extern const void * RTTI_NiTextKeyMatch;
extern const void * RTTI_NiMultiTargetTransformController;
extern const void * RTTI_BSMultiTargetTreadTransfController;
extern const void * RTTI_NiInterpController;
extern const void * RTTI_NiFloatInterpolator;
extern const void * RTTI_NiColorInterpolator;
extern const void * RTTI_NiSingleInterpController;
extern const void * RTTI_NiTransformInterpolator;
extern const void * RTTI_NiPosData;
extern const void * RTTI_NiPathInterpolator;
extern const void * RTTI_NiBlendTransformInterpolator;
extern const void * RTTI_NiBlendFloatInterpolator;
extern const void * RTTI_NiFloatExtraDataController;
extern const void * RTTI_NiVisController;
extern const void * RTTI_NiTransformController;
extern const void * RTTI_NiBlendAccumTransformInterpolator;
extern const void * RTTI_NiBlendInterpolator;
extern const void * RTTI_BSBlendTreadTransfInterpolator;
extern const void * RTTI_NiInterpolator;
extern const void * RTTI_NiKeyBasedInterpolator;
extern const void * RTTI_NiTransformData;
extern const void * RTTI_NiBlendBoolInterpolator;
extern const void * RTTI_NiBlendColorInterpolator;
extern const void * RTTI_NiBlendPoint3Interpolator;
extern const void * RTTI_NiBlendQuaternionInterpolator;
extern const void * RTTI_NiBoolData;
extern const void * RTTI_NiBoolInterpolator;
extern const void * RTTI_NiBoolTimelineInterpolator;
extern const void * RTTI_NiBSplineBasisData;
extern const void * RTTI_NiBSplineData;
extern const void * RTTI_NiBSplineColorInterpolator;
extern const void * RTTI_NiBSplineCompColorInterpolator;
extern const void * RTTI_NiBSplineCompFloatInterpolator;
extern const void * RTTI_NiBSplineCompPoint3Interpolator;
extern const void * RTTI_NiBSplineCompTransformInterpolator;
extern const void * RTTI_NiBSplineFloatInterpolator;
extern const void * RTTI_NiBSplinePoint3Interpolator;
extern const void * RTTI_NiBSplineTransformInterpolator;
extern const void * RTTI_NiColorExtraDataController;
extern const void * RTTI_NiFloatsExtraDataController;
extern const void * RTTI_NiFloatsExtraDataPoint3Controller;
extern const void * RTTI_NiKeyframeManager;
extern const void * RTTI_NiLightColorController;
extern const void * RTTI_NiLightDimmerController;
extern const void * RTTI_NiLightRadiusController;
extern const void * RTTI_NiLookAtController;
extern const void * RTTI_NiLookAtInterpolator;
extern const void * RTTI_NiMorphData;
extern const void * RTTI_NiPathController;
extern const void * RTTI_NiPoint3Interpolator;
extern const void * RTTI_NiQuaternionInterpolator;
extern const void * RTTI_NiFloatController;
extern const void * RTTI_NiRollController;
extern const void * RTTI_NiRotData;
extern const void * RTTI_NiSequence;
extern const void * RTTI_NiSequenceStreamHelper;
extern const void * RTTI_NiStringPalette;
extern const void * RTTI_NiTextKeyExtraData;
extern const void * RTTI_NiUVData;
extern const void * RTTI_BSAnimNotes;
extern const void * RTTI_BSAnimNote;
extern const void * RTTI_BSGrabIKNote;
extern const void * RTTI_BSLookIKNote;
extern const void * RTTI_BSRotAccumTransfInterpolator;
extern const void * RTTI_BSTreadTransfInterpolator;
extern const void * RTTI_BSFrustumFOVController;
extern const void * RTTI_NiExtraDataController;
extern const void * RTTI_NiBoolInterpController;
extern const void * RTTI_NiBSplineInterpolator;
extern const void * RTTI_NiPoint3InterpController;
extern const void * RTTI_NiFloatInterpController;
extern const void * RTTI_NiParticleSystem;
extern const void * RTTI_NiPSysMeshEmitter;
extern const void * RTTI_BSPSysInheritVelocityModifier;
extern const void * RTTI_NiPSysEmitterCtlr;
extern const void * RTTI_NiPSysGravityModifier;
extern const void * RTTI_BSPSysHavokUpdateModifier;
extern const void * RTTI_NiMeshParticleSystem;
extern const void * RTTI_NiPSysCylinderEmitter;
extern const void * RTTI_BSStripParticleSystem;
extern const void * RTTI_NiPSysEmitter;
extern const void * RTTI_NiPSysData;
extern const void * RTTI_NiPSysModifierCtlr;
extern const void * RTTI_NiPSysModifier;
extern const void * RTTI_NiPSysMeshUpdateModifier;
extern const void * RTTI_NiMeshPSysData;
extern const void * RTTI_NiPSysUpdateCtlr;
extern const void * RTTI_NiPSysAirFieldAirFrictionCtlr;
extern const void * RTTI_NiPSysAirFieldInheritVelocityCtlr;
extern const void * RTTI_NiPSysAirFieldModifier;
extern const void * RTTI_NiPSysAirFieldSpreadCtlr;
extern const void * RTTI_NiPSysAgeDeathModifier;
extern const void * RTTI_NiPSysBombModifier;
extern const void * RTTI_NiPSysBoundUpdateModifier;
extern const void * RTTI_NiPSysBoxEmitter;
extern const void * RTTI_NiPSysColliderManager;
extern const void * RTTI_NiPSysColorModifier;
extern const void * RTTI_NiPSysDragFieldModifier;
extern const void * RTTI_NiPSysDragModifier;
extern const void * RTTI_NiPSysEmitterCtlrData;
extern const void * RTTI_NiPSysEmitterDeclinationCtlr;
extern const void * RTTI_NiPSysEmitterDeclinationVarCtlr;
extern const void * RTTI_NiPSysEmitterInitialRadiusCtlr;
extern const void * RTTI_NiPSysEmitterLifeSpanCtlr;
extern const void * RTTI_NiPSysEmitterPlanarAngleCtlr;
extern const void * RTTI_NiPSysEmitterPlanarAngleVarCtlr;
extern const void * RTTI_NiPSysEmitterSpeedCtlr;
extern const void * RTTI_NiPSysFieldAttenuationCtlr;
extern const void * RTTI_NiPSysFieldMagnitudeCtlr;
extern const void * RTTI_NiPSysFieldMaxDistanceCtlr;
extern const void * RTTI_NiPSysGravityFieldModifier;
extern const void * RTTI_NiPSysGravityStrengthCtlr;
extern const void * RTTI_NiPSysGrowFadeModifier;
extern const void * RTTI_NiPSysInitialRotAngleCtlr;
extern const void * RTTI_NiPSysInitialRotAngleVarCtlr;
extern const void * RTTI_NiPSysInitialRotSpeedCtlr;
extern const void * RTTI_NiPSysInitialRotSpeedVarCtlr;
extern const void * RTTI_NiPSysModifierActiveCtlr;
extern const void * RTTI_NiPSysPlanarCollider;
extern const void * RTTI_NiPSysPositionModifier;
extern const void * RTTI_NiPSysRadialFieldModifier;
extern const void * RTTI_NiPSysResetOnLoopCtlr;
extern const void * RTTI_NiPSysRotationModifier;
extern const void * RTTI_NiPSysSpawnModifier;
extern const void * RTTI_NiPSysSphereEmitter;
extern const void * RTTI_NiPSysSphericalCollider;
extern const void * RTTI_NiPSysTurbulenceFieldModifier;
extern const void * RTTI_NiPSysVortexFieldModifier;
extern const void * RTTI_BSStripPSysData;
extern const void * RTTI_BSPSysRecycleBoundModifier;
extern const void * RTTI_NiPSysVolumeEmitter;
extern const void * RTTI_NiPSysModifierFloatCtlr;
extern const void * RTTI_NiPSysFieldModifier;
extern const void * RTTI_NiPSysModifierBoolCtlr;
extern const void * RTTI_NiPSysCollider;
extern const void * RTTI_BSStaticTriShapeDB__QueuedHandles;
extern const void * RTTI_BSStaticTriShapeDB__Builder;
extern const void * RTTI_BSStaticTriShapeDB__Manager;
extern const void * RTTI_BSStaticTriShapeDB__CsgStream;
extern const void * RTTI_ITextureDB;
extern const void * RTTI_BSTextureDB__QueuedHandles;
extern const void * RTTI_BSMaterialDB__QueuedHandles;
extern const void * RTTI_BSTaskThread;
extern const void * RTTI_IOManager;
extern const void * RTTI_IOManagerThread;
extern const void * RTTI_IOTask;
extern const void * RTTI_IOSystemTask;
extern const void * RTTI_QueuedFile;
extern const void * RTTI_QueuedNamedFile;
extern const void * RTTI_BSQueuedResourceCollectionBase;
extern const void * RTTI_BSMultiBound;
extern const void * RTTI_BSMultiBoundRoom;
extern const void * RTTI_BSXFlags;
extern const void * RTTI_BSValueNode;
extern const void * RTTI_BSTextureStreamer__TextureModifyBatch;
extern const void * RTTI_BSTextureStreamer__Manager;
extern const void * RTTI_BSTextureStreamer__StreamDetailI;
extern const void * RTTI_BSTextureStreamer__zlibStreamDetail;
extern const void * RTTI_BSTextureStreamer__TextureModifyBatchNoLimit;
extern const void * RTTI_BSWindModifier;
extern const void * RTTI_BSPortalGraph;
extern const void * RTTI_BSPortalGraphEntry;
extern const void * RTTI_BSOcclusionShape;
extern const void * RTTI_BSRangeNode;
extern const void * RTTI_BSBlastNode;
extern const void * RTTI_BSDebrisNode;
extern const void * RTTI_BSDamageStage;
extern const void * RTTI_PArrayPoint;
extern const void * RTTI_BSPSysArrayEmitter;
extern const void * RTTI_BSMultiBoundShape;
extern const void * RTTI_BSInstanceTriShape;
extern const void * RTTI_BSMultiStreamInstanceTriShape;
extern const void * RTTI_BSIStream;
extern const void * RTTI_BSOStream;
extern const void * RTTI_BSFurnitureMarkerNode;
extern const void * RTTI_BSOcclusionBox;
extern const void * RTTI_BSOcclusionPlane;
extern const void * RTTI_BSPortalSharedNode;
extern const void * RTTI_BSBehaviorGraphExtraData;
extern const void * RTTI_BSCullingProcess;
extern const void * RTTI_BSNiNode;
extern const void * RTTI_BSSubIndexTriShape;
extern const void * RTTI_BSSegmentDataStorage;
extern const void * RTTI_BSParticleSystemManager;
extern const void * RTTI_BSBound;
extern const void * RTTI_BSMergeInstancedTriShape;
extern const void * RTTI_BSMultiBoundNode;
extern const void * RTTI_BSBoneMap;
extern const void * RTTI_BSSceneGraph;
extern const void * RTTI_BSReference;
extern const void * RTTI_BSNodeReferences;
extern const void * RTTI_BSShapeConstructor;
extern const void * RTTI_BSBoxConstructor;
extern const void * RTTI_BSOrientedBoxConstructor;
extern const void * RTTI_BSSphereConstructor;
extern const void * RTTI_BSCylinderConstructor;
extern const void * RTTI_BSCapsuleConstructor;
extern const void * RTTI_BSArrowConstructor;
extern const void * RTTI_BSCircleConstructor;
extern const void * RTTI_BSRingConstructor;
extern const void * RTTI_BSFlatQuadConstructor;
extern const void * RTTI_BSDiskConstructor;
extern const void * RTTI_BSPSysMultiTargetEmitterCtlr;
extern const void * RTTI_BSTextureArray__Texture;
extern const void * RTTI_BSTextureArray__StaticTexture;
extern const void * RTTI_BSTextureArray__StaticTextureIndexed;
extern const void * RTTI_BSTextureArray__MasterTexture;
extern const void * RTTI_BSProceduralLightningTasklet;
extern const void * RTTI_BSProceduralLightningController;
extern const void * RTTI_BSBoneLODExtraData;
extern const void * RTTI_BSMasterParticleSystem;
extern const void * RTTI_BSParentVelocityModifier;
extern const void * RTTI_BSInvMarker;
extern const void * RTTI_BSWArray;
extern const void * RTTI_BSMultiBoundCapsule;
extern const void * RTTI_BSPSysStripUpdateModifier;
extern const void * RTTI_BSPSysSubTexModifier;
extern const void * RTTI_BSPSysScaleModifier;
extern const void * RTTI_BSLagBoneController;
extern const void * RTTI_BSNonUniformScaleExtraData;
extern const void * RTTI_BSCombinedTriShape;
extern const void * RTTI_BSDistantObjectInstanceDataBlock;
extern const void * RTTI_BSTableCurve;
extern const void * RTTI__com_error;
extern const void * RTTI_BSD3DResourceCreator;
extern const void * RTTI_BSConnectPoint__Children;
extern const void * RTTI_BSConnectPoint__Parents;
extern const void * RTTI_hknpBSWorld;
extern const void * RTTI_bhkWorld;
extern const void * RTTI_bhkCharProxyManager;
extern const void * RTTI_bhkCharRigidBodyManager;
extern const void * RTTI_hclBSWorld;
extern const void * RTTI_hknpBackfaceCollisionModifier;
extern const void * RTTI_hknpBSShapeCodec;
extern const void * RTTI_bhkNPCollisionObject;
extern const void * RTTI_bhkNPCollisionObjectBase;
extern const void * RTTI_bhkNPCollisionObjectUnlinked;
extern const void * RTTI_bhkNPCollisionProxyObject;
extern const void * RTTI_bhkNPCollisionObjectUnlinked__LinkExtraData;
extern const void * RTTI_bhkPhysicsSystem;
extern const void * RTTI_bhkRagdollSystem;
extern const void * RTTI_bhkCollisionFilter;
extern const void * RTTI_hknpCompressedMeshShapeCinfo;
extern const void * RTTI_hknpDefaultCompressedMeshShapeCinfo;
extern const void * RTTI_hknpBSMaterial;
extern const void * RTTI_hknpCharacterState;
extern const void * RTTI_bhkCharacterState;
extern const void * RTTI_bhkCharacterController;
extern const void * RTTI_bhkICharOrientationController;
extern const void * RTTI_bhkCharacterControllerCinfo;
extern const void * RTTI_hknpBSMoveLimitModifier;
extern const void * RTTI_bhkCharacterStateClimbing;
extern const void * RTTI_bhkCharacterStateFlying;
extern const void * RTTI_BSClothExtraData;
extern const void * RTTI_hclTransformSet;
extern const void * RTTI_hclInstantiationUtil;
extern const void * RTTI_BSClothUtils__BSInstantiationUtil;
extern const void * RTTI_BSClothUtils__BSTransformSet;
extern const void * RTTI_BSClothUtils__BSTriShapeBuffer;
extern const void * RTTI_hknpClosestUniqueBodyIdHitCollector;
extern const void * RTTI_bhkWorldM;
extern const void * RTTI_hkaNpRagdollRaycastInterface;
extern const void * RTTI_bhkRagdollPenetrationUtil;
extern const void * RTTI_hkThreadPool;
extern const void * RTTI_bhkThreadPool;
extern const void * RTTI_hknpFixedClosestHitCollector;
extern const void * RTTI_hknpBSMouseSpringAction;
extern const void * RTTI_hknpCharacterProxyListener;
extern const void * RTTI_bhkCharProxyController;
extern const void * RTTI_bhkCharacterProxy;
extern const void * RTTI_bhkCharProxyControllerCinfo;
extern const void * RTTI_hknpCharacterRigidBodyListener;
extern const void * RTTI_bhkCharRigidBodyController;
extern const void * RTTI_bhkCharacterRigidBodyCinfo;
extern const void * RTTI_bhkCharacterRigidBody;
extern const void * RTTI_bhkCharRigidBodyControllerCinfo;
extern const void * RTTI_hknpBSBroadPhaseConfig;
extern const void * RTTI_hknpSafeEaseConstraintsAction;
extern const void * RTTI_BSPistonController;
extern const void * RTTI_hclWorld;
extern const void * RTTI_hclWorldListener;
extern const void * RTTI_bhkBipedOrientationController;
extern const void * RTTI_hkThreadMemory;
extern const void * RTTI_bhkMemorySystem;
extern const void * RTTI_hclBSClothParameterizedWindAction;
extern const void * RTTI_hkPackfileWriter__AddObjectListener;
extern const void * RTTI_hknpWorldSnapshot;
extern const void * RTTI_hclSimClothInstance;
extern const void * RTTI_hclCollidable;
extern const void * RTTI_hclClothInstance;
extern const void * RTTI_hkaSplineCompressedAnimation;
extern const void * RTTI_hkpConstraintMotor;
extern const void * RTTI_hkpLimitedForceConstraintMotor;
extern const void * RTTI_hkpPositionConstraintMotor;
extern const void * RTTI_hkbCustomIdSelector;
extern const void * RTTI_hkbStateChooserWrapper;
extern const void * RTTI_hkbAttachmentSetup;
extern const void * RTTI_hkbBehaviorGraphInternalState;
extern const void * RTTI_hkbBlendingTransitionEffectInternalState;
extern const void * RTTI_hkbBoneIndexArray;
extern const void * RTTI_hkbCharacterControllerModifierInternalState;
extern const void * RTTI_hkbCombineTransformsModifierInternalState;
extern const void * RTTI_hkbComputeDirectionModifierInternalState;
extern const void * RTTI_hkbComputeRotationFromAxisAngleModifierInternalState;
extern const void * RTTI_hkbComputeRotationToTargetModifierInternalState;
extern const void * RTTI_hkbDampingModifierInternalState;
extern const void * RTTI_hkbDelayedModifierInternalState;
extern const void * RTTI_hkbDetectCloseToGroundModifierInternalState;
extern const void * RTTI_hkbDockingGeneratorInternalState;
extern const void * RTTI_hkbExpressionDataArray;
extern const void * RTTI_hkbEvaluateExpressionModifierInternalState;
extern const void * RTTI_hkbEventDrivenModifierInternalState;
extern const void * RTTI_hkpSpringDamperConstraintMotor;
extern const void * RTTI_hkbEventRangeDataArray;
extern const void * RTTI_hkbEventsFromRangeModifierInternalState;
extern const void * RTTI_hkbExtrapolatingTransitionEffect;
extern const void * RTTI_hkbExtrapolatingTransitionEffectInternalState;
extern const void * RTTI_hkbGetUpModifierInternalState;
extern const void * RTTI_hkbGetWorldFromModelModifierInternalState;
extern const void * RTTI_hkbJigglerGroup;
extern const void * RTTI_hkbJigglerModifierInternalState;
extern const void * RTTI_hkbLayerGeneratorInternalState;
extern const void * RTTI_hkbLookAtModifierInternalState;
extern const void * RTTI_hkbManualSelectorGeneratorInternalState;
extern const void * RTTI_hkbManualSelectorTransitionEffectInternalState;
extern const void * RTTI_hkbModifierWrapper;
extern const void * RTTI_hkbMoveCharacterModifierInternalState;
extern const void * RTTI_hkStringObject;
extern const void * RTTI_hkbRotateCharacterModifierInternalState;
extern const void * RTTI_hkbScriptCondition;
extern const void * RTTI_hkbStringCondition;
extern const void * RTTI_hkbTimerModifierInternalState;
extern const void * RTTI_hkbTransformVectorModifierInternalState;
extern const void * RTTI_hkpVelocityConstraintMotor;
extern const void * RTTI_hkcdPlanarEntity;
extern const void * RTTI_hkcdPlanarSolid__NodeStorage;
extern const void * RTTI_hkbSimulationControlCommand;
extern const void * RTTI_hkbCharacterControlCommand;
extern const void * RTTI_hkbRaiseEventCommand;
extern const void * RTTI_hkbSetSelectedCharacterCommand;
extern const void * RTTI_hkbSetWordVariableCommand;
extern const void * RTTI_hkbSetLocalTimeOfClipGeneratorCommand;
extern const void * RTTI_hkbSetBehaviorCommand;
extern const void * RTTI_hkbSetNodePropertyCommand;
extern const void * RTTI_hkbRebuildScriptsCommand;
extern const void * RTTI_hkbCameraVariablesChangedCommand;
extern const void * RTTI_hkbAiControlPathToCommand;
extern const void * RTTI_hkbAiControlCancelPathCommand;
extern const void * RTTI_hkbCharacterAddedInfo;
extern const void * RTTI_hkbCharacterInfo;
extern const void * RTTI_hkbCharacterSteppedInfo;
extern const void * RTTI_hkbCharacterSkinInfo;
extern const void * RTTI_hkbBehaviorInfo;
extern const void * RTTI_hkbBehaviorEventsInfo;
extern const void * RTTI_hkbEventRaisedInfo;
extern const void * RTTI_hkbSimulationStateInfo;
extern const void * RTTI_hkbLinkedSymbolInfo;
extern const void * RTTI_hkbAuxiliaryNodeInfo;
extern const void * RTTI_hkbBehaviorGraphInternalStateInfo;
extern const void * RTTI_hkbCharacterSelectedInfo;
extern const void * RTTI_hkbCameraShakeEventPayload;
extern const void * RTTI_hkbHoldFromBlendingTransitionEffect;
extern const void * RTTI_hkbNullPhysicsInterface;
extern const void * RTTI_hkbParticleSystemEventPayload;
extern const void * RTTI_hkbGeneratorOutputListener;
extern const void * RTTI_hkbPoseStoringGeneratorOutputListener;
extern const void * RTTI_hkbPoseStoringGeneratorOutputListener__StoredPose;
extern const void * RTTI_hkbTestIdSelector;
extern const void * RTTI_hkMeshTexture;
extern const void * RTTI_hkMemoryMeshTexture;
extern const void * RTTI_BSIStateManagerModifier__BSIStateManagerStateListener;
extern const void * RTTI_hkpCallbackConstraintMotor;
extern const void * RTTI_hkpCogWheelConstraintData;
extern const void * RTTI_hkpLinearClearanceConstraintData;
extern const void * RTTI_hkpParametricCurve;
extern const void * RTTI_hkpLinearParametricCurve;
extern const void * RTTI_hkpRackAndPinionConstraintData;
extern const void * RTTI_hkpRotationalConstraintData;
extern const void * RTTI_hkpWheelFrictionConstraintData;
extern const void * RTTI_hclConstraintSet;
extern const void * RTTI_hclAntiPinchConstraintSet;
extern const void * RTTI_hclBendLinkConstraintSet;
extern const void * RTTI_hclBendLinkConstraintSetMx;
extern const void * RTTI_hclBendStiffnessConstraintSet;
extern const void * RTTI_hclBendStiffnessConstraintSetMx;
extern const void * RTTI_hclOperator;
extern const void * RTTI_hclBlendSomeVerticesOperator;
extern const void * RTTI_hclBonePlanesConstraintSet;
extern const void * RTTI_hclBoneSpaceMeshMeshDeformOperator;
extern const void * RTTI_hclBoneSpaceMeshMeshDeformPNOperator;
extern const void * RTTI_hclBoneSpaceMeshMeshDeformPNTBOperator;
extern const void * RTTI_hclBoneSpaceMeshMeshDeformPNTOperator;
extern const void * RTTI_hclBoneSpaceMeshMeshDeformPOperator;
extern const void * RTTI_hclBoneSpaceSkinOperator;
extern const void * RTTI_hclBoneSpaceSkinPNOperator;
extern const void * RTTI_hclBoneSpaceSkinPNTBOperator;
extern const void * RTTI_hclBoneSpaceSkinPNTOperator;
extern const void * RTTI_hclBoneSpaceSkinPOperator;
extern const void * RTTI_hclBufferDefinition;
extern const void * RTTI_hclShape;
extern const void * RTTI_hclCapsuleShape;
extern const void * RTTI_hclClothData;
extern const void * RTTI_hclClothState;
extern const void * RTTI_hclCompressibleLinkConstraintSet;
extern const void * RTTI_hclCompressibleLinkConstraintSetMx;
extern const void * RTTI_hclConvexGeometryShape;
extern const void * RTTI_hclConvexHeightFieldShape;
extern const void * RTTI_hclConvexPlanesShape;
extern const void * RTTI_hclCopyVerticesOperator;
extern const void * RTTI_hclGatherAllVerticesOperator;
extern const void * RTTI_hclGatherSomeVerticesOperator;
extern const void * RTTI_hclInputConvertOperator;
extern const void * RTTI_hclLocalRangeConstraintSet;
extern const void * RTTI_hclMeshBoneDeformOperator;
extern const void * RTTI_hclMeshMeshDeformOperator;
extern const void * RTTI_hclMoveParticlesOperator;
extern const void * RTTI_hclObjectSpaceMeshMeshDeformOperator;
extern const void * RTTI_hclObjectSpaceMeshMeshDeformPNOperator;
extern const void * RTTI_hclObjectSpaceMeshMeshDeformPNTBOperator;
extern const void * RTTI_hclObjectSpaceMeshMeshDeformPNTOperator;
extern const void * RTTI_hclObjectSpaceMeshMeshDeformPOperator;
extern const void * RTTI_hclObjectSpaceSkinOperator;
extern const void * RTTI_hclObjectSpaceSkinPNOperator;
extern const void * RTTI_hkpVehicleFrictionDescription;
extern const void * RTTI_hclObjectSpaceSkinPNTBOperator;
extern const void * RTTI_hclObjectSpaceSkinPNTOperator;
extern const void * RTTI_hclObjectSpaceSkinPOperator;
extern const void * RTTI_hclOutputConvertOperator;
extern const void * RTTI_hclPlaneShape;
extern const void * RTTI_hclScratchBufferDefinition;
extern const void * RTTI_hclShadowBufferDefinition;
extern const void * RTTI_hclSimClothData;
extern const void * RTTI_hclSimClothPose;
extern const void * RTTI_hclSimpleMeshBoneDeformOperator;
extern const void * RTTI_hclAction;
extern const void * RTTI_hclSimpleWindAction;
extern const void * RTTI_hclSimulateOperator;
extern const void * RTTI_hclSkinOperator;
extern const void * RTTI_hclSphereShape;
extern const void * RTTI_hclStandardLinkConstraintSet;
extern const void * RTTI_hclStandardLinkConstraintSetMx;
extern const void * RTTI_hclStaticShadowBufferDefinition;
extern const void * RTTI_hclStretchLinkConstraintSet;
extern const void * RTTI_hclStretchLinkConstraintSetMx;
extern const void * RTTI_hclTaperedCapsuleShape;
extern const void * RTTI_hknpBodyReference;
extern const void * RTTI_hclTransformSetDefinition;
extern const void * RTTI_hclTransitionConstraintSet;
extern const void * RTTI_hclUpdateAllVertexFramesOperator;
extern const void * RTTI_hknpCircularSurfaceVelocity;
extern const void * RTTI_hclUpdateSomeVertexFramesOperator;
extern const void * RTTI_hclVolumeConstraint;
extern const void * RTTI_hclVolumeConstraintMx;
extern const void * RTTI_hknpExternMeshShapeGeometry;
extern const void * RTTI_hknpDefaultExternMeshShapeGeometry;
extern const void * RTTI_hknpDisableCollisionFilter;
extern const void * RTTI_hknpMaterialPalette;
extern const void * RTTI_hknpRefWorldCinfo;
extern const void * RTTI_hknpTyremarksWheel;
extern const void * RTTI_hknpTyremarksInfo;
extern const void * RTTI_hknpVehicleData;
extern const void * RTTI_hknpVehicleAerodynamics;
extern const void * RTTI_hknpVehicleDefaultAerodynamics;
extern const void * RTTI_hknpVehicleDriverInputStatus;
extern const void * RTTI_hknpVehicleDriverInput;
extern const void * RTTI_hknpVehicleDriverInputAnalogStatus;
extern const void * RTTI_hknpVehicleDefaultAnalogDriverInput;
extern const void * RTTI_hknpVehicleBrake;
extern const void * RTTI_hknpVehicleDefaultBrake;
extern const void * RTTI_hknpVehicleEngine;
extern const void * RTTI_hknpVehicleDefaultEngine;
extern const void * RTTI_hknpVehicleSteering;
extern const void * RTTI_hknpVehicleDefaultSteering;
extern const void * RTTI_hknpVehicleSuspension;
extern const void * RTTI_hknpVehicleDefaultSuspension;
extern const void * RTTI_hknpVehicleTransmission;
extern const void * RTTI_hknpVehicleDefaultTransmission;
extern const void * RTTI_hknpVehicleVelocityDamper;
extern const void * RTTI_hknpVehicleDefaultVelocityDamper;
extern const void * RTTI_hknpVehicleInstance;
extern const void * RTTI_hknpVehicleWheelCollide;
extern const void * RTTI_hknpVehicleLinearCastWheelCollide;
extern const void * RTTI_hknpVehicleRayCastWheelCollide;
extern const void * RTTI_hknpStaticCompoundShapeInternals;
extern const void * RTTI_hkaAnimationPreviewColorContainer;
extern const void * RTTI_hkaAnimatedReferenceFrame;
extern const void * RTTI_hkaDefaultAnimatedReferenceFrame;
extern const void * RTTI_hkaFootstepAnalysisInfoContainer;
extern const void * RTTI_hkaInterleavedUncompressedAnimation;
extern const void * RTTI_hkaLosslessCompressedAnimation;
extern const void * RTTI_hkaParameterizedAnimationReferenceFrame;
extern const void * RTTI_hkaQuantizedAnimation;
extern const void * RTTI_hknpCompressedMeshShape;
extern const void * RTTI_hknpStaticCompoundShape;
extern const void * RTTI_hknpMaskedShape;
extern const void * RTTI_hknpMaskedShape__MaskWrapper;
extern const void * RTTI_bhkCharacterStateFloating;
extern const void * RTTI_bhkCharacterStateInAir;
extern const void * RTTI_bhkCharacterStateJumping;
extern const void * RTTI_bhkCharacterStateOnGround;
extern const void * RTTI_bhkCharacterStateSwimming;
extern const void * RTTI_bhkQuadOrientationController;
extern const void * RTTI_hclBuffer;
extern const void * RTTI_hkaNpRagdollPenetrationDetector;
extern const void * RTTI_bhkCharacterPointCollector;
extern const void * RTTI_hknpBSCharacterProxy;
extern const void * RTTI_hknpBSCharacterRigidBody;
extern const void * RTTI_hkSolverAllocator;
extern const void * RTTI_bhkThreadMemorySource;
extern const void * RTTI_hknpDummyShape;
extern const void * RTTI_hknpExternMeshShape;
extern const void * RTTI_hclPointContactPlanesShape;
extern const void * RTTI_hkbAttachmentModifier;
extern const void * RTTI_hkbAttributeModifier;
extern const void * RTTI_hkbBlendingTransitionEffect;
extern const void * RTTI_hkbCharacterControllerModifier;
extern const void * RTTI_hkbCombineTransformsModifier;
extern const void * RTTI_hkbComputeDirectionModifier;
extern const void * RTTI_hkbComputeRotationFromAxisAngleModifier;
extern const void * RTTI_hkbComputeRotationToTargetModifier;
extern const void * RTTI_hkbDampingModifier;
extern const void * RTTI_hkbDelayedModifier;
extern const void * RTTI_hkbDetectCloseToGroundModifier;
extern const void * RTTI_hkbDockingGenerator;
extern const void * RTTI_hkbEvaluateExpressionModifier;
extern const void * RTTI_hkbEvaluateHandleModifier;
extern const void * RTTI_hkbEventDrivenModifier;
extern const void * RTTI_hkbEventsFromRangeModifier;
extern const void * RTTI_hkbExtractRagdollPoseModifier;
extern const void * RTTI_hkbFootIkControlsModifier;
extern const void * RTTI_hkbFootIkModifier;
extern const void * RTTI_hkbGetHandleOnBoneModifier;
extern const void * RTTI_hkbGetUpModifier;
extern const void * RTTI_hkbGetWorldFromModelModifier;
extern const void * RTTI_hkbHandIkControlsModifier;
extern const void * RTTI_hkbHandIkModifier;
extern const void * RTTI_hkbJigglerModifier;
extern const void * RTTI_hkbKeyframeBonesModifier;
extern const void * RTTI_hkbLayer;
extern const void * RTTI_hkbLayerGenerator;
extern const void * RTTI_hkbLookAtModifier;
extern const void * RTTI_hkbManualSelectorGenerator;
extern const void * RTTI_hkbManualSelectorTransitionEffect;
extern const void * RTTI_hkbMirrorModifier;
extern const void * RTTI_hkbModifierGenerator;
extern const void * RTTI_hkbModifierList;
extern const void * RTTI_hkbMoveBoneAttachmentModifier;
extern const void * RTTI_hkbMoveCharacterModifier;
extern const void * RTTI_hkbPoweredRagdollControlsModifier;
extern const void * RTTI_hkbRigidBodyRagdollControlsModifier;
extern const void * RTTI_hkbRotateCharacterModifier;
extern const void * RTTI_hkbScriptGenerator;
extern const void * RTTI_hkbSenseHandleModifier;
extern const void * RTTI_hkbSetWorldFromModelModifier;
extern const void * RTTI_hkbTimerModifier;
extern const void * RTTI_hkbTransformVectorModifier;
extern const void * RTTI_hkbTwistModifier;
extern const void * RTTI_hkUuidPseudoRandomGenerator;
extern const void * RTTI_hkResourceContainer;
extern const void * RTTI_hkResourceMap;
extern const void * RTTI_hkResourceBase;
extern const void * RTTI_hkResourceHandle;
extern const void * RTTI_hkMemoryResourceHandle;
extern const void * RTTI_hkMemoryResourceContainer;
extern const void * RTTI_hkContainerResourceMap;
extern const void * RTTI_hkcdPlanarSolid__ArrayMgr;
extern const void * RTTI_hkcdConvexCellsCollection;
extern const void * RTTI_hkcdPlanarCsgOperand;
extern const void * RTTI_hkcdPlanarGeometry;
extern const void * RTTI_hkcdPlanarGeometry__VertexStorage;
extern const void * RTTI_hkcdPlanarGeometryPlanesCollection;
extern const void * RTTI_hkcdPlanarGeometryPolygonCollection;
extern const void * RTTI_hkcdPlanarSolid;
extern const void * RTTI_hkcdShape;
extern const void * RTTI_hkcdDynamicAabbTree;
extern const void * RTTI_hkcdStaticAabbTree;
extern const void * RTTI_hkbAlignBoneModifier;
extern const void * RTTI_hkbAnimatedSkeletonGenerator;
extern const void * RTTI_hkRemoteObjectClientSideListener;
extern const void * RTTI_hkbBehaviorClient;
extern const void * RTTI_hkbClientCharacterState;
extern const void * RTTI_hkbComputeWorldFromModelModifier;
extern const void * RTTI_hkbCustomTestGeneratorHiddenTypes;
extern const void * RTTI_hkbCustomTestGeneratorSimpleTypes;
extern const void * RTTI_hkbCustomTestGeneratorComplexTypes;
extern const void * RTTI_hkbCustomTestGeneratorNestedTypesBase;
extern const void * RTTI_hkbCustomTestGeneratorNestedTypes;
extern const void * RTTI_hkbCustomTestGeneratorBoneTypes;
extern const void * RTTI_hkbCustomTestGeneratorAnnotatedTypes;
extern const void * RTTI_hkbCustomTestGenerator;
extern const void * RTTI_hkbGravityModifier;
extern const void * RTTI_hkbPinBonesGenerator;
extern const void * RTTI_hkbRadialSelectorGenerator;
extern const void * RTTI_hkbStateDependentModifier;
extern const void * RTTI_hkSkinnedMeshShape;
extern const void * RTTI_hkStorageSkinnedMeshShape;
extern const void * RTTI_hkMeshMaterial;
extern const void * RTTI_hkMemoryMeshMaterial;
extern const void * RTTI_BSAlignBoneModifier;
extern const void * RTTI_hkMeshShape;
extern const void * RTTI_hkMemoryMeshShape;
extern const void * RTTI_BSAssignVariablesModifier;
extern const void * RTTI_hkMemoryMeshTexture__Sampler;
extern const void * RTTI_hkMeshVertexBuffer;
extern const void * RTTI_hkMemoryMeshVertexBuffer;
extern const void * RTTI_BSBoneSwitchGenerator;
extern const void * RTTI_hkMultipleVertexBuffer;
extern const void * RTTI_BSBoneSwitchGeneratorBoneData;
extern const void * RTTI_hkSkinBinding;
extern const void * RTTI_BSComputeAddBoneAnimModifier;
extern const void * RTTI_hkSkinnedRefMeshShape;
extern const void * RTTI_BSCyclicBlendTransitionGenerator;
extern const void * RTTI_BSDecomposeVectorModifier;
extern const void * RTTI_BSDirectAtCapturePoseModifier;
extern const void * RTTI_BSDirectAtModifier;
extern const void * RTTI_BSDistTriggerModifier;
extern const void * RTTI_BSEventEveryNEventsModifier;
extern const void * RTTI_BSEventOnDeactivateModifier;
extern const void * RTTI_BSEventOnFalseToTrueModifier;
extern const void * RTTI_BSGetTimeStepModifier;
extern const void * RTTI_BSIStateManagerModifier;
extern const void * RTTI_BSInterpValueModifier;
extern const void * RTTI_BSIsActiveModifier;
extern const void * RTTI_BSLimbCycleModifier;
extern const void * RTTI_BSLimbIKModifier;
extern const void * RTTI_BSLookAtCapturePoseModifier;
extern const void * RTTI_BSLookAtModifier;
extern const void * RTTI_BSModifyOnceModifier;
extern const void * RTTI_BSOffsetAnimationGenerator;
extern const void * RTTI_BSPassByTargetTriggerModifier;
extern const void * RTTI_BSRagdollContactListenerModifier;
extern const void * RTTI_BSRandomAlarmModifier;
extern const void * RTTI_BSRetargetBodyBlend;
extern const void * RTTI_BSReverseSpineTwistModifier;
extern const void * RTTI_BSRootTwistModifier;
extern const void * RTTI_BSSpeedSamplerModifier;
extern const void * RTTI_BSTimerModifier;
extern const void * RTTI_BSTweenerModifier;
extern const void * RTTI_DynamicAnimationTaggingGenerator;
extern const void * RTTI_hclAntiPinchConstraintInstanceData;
extern const void * RTTI_hclClothContainer;
extern const void * RTTI_hknpBallGun;
extern const void * RTTI_hknpFirstPersonGun;
extern const void * RTTI_hknpProjectileGun;
extern const void * RTTI_hknpGunProjectile;
extern const void * RTTI_hclTransitionConstraintInstanceData;
extern const void * RTTI_hclVolumeConstraintInstanceData;
extern const void * RTTI_hclVolumeConstraintMxInstanceData;
extern const void * RTTI_hknpDestructionShapeProperties;
extern const void * RTTI_hknpLodShape;
extern const void * RTTI_hknpMalleableConstraintData;
extern const void * RTTI_hknpPhysicsSceneData;
extern const void * RTTI_hkaParameterizedReferenceFrame;
extern const void * RTTI_hkaAngularReferenceFrame;
extern const void * RTTI_hkaDirectionalReferenceFrame;
extern const void * RTTI_hkaFootstepAnalysisInfo;
extern const void * RTTI_hkaPredictiveCompressedAnimation;
extern const void * RTTI_hclScratchBuffer;
extern const void * RTTI_hclShadowBuffer;
extern const void * RTTI_hclStaticShadowBuffer;
extern const void * RTTI_hkcdConvexCellsTree3D;
extern const void * RTTI_hkcdVertexGeometry;
extern const void * RTTI_hkcdVertexGeometry__VPolygonCollectionBase;
extern const void * RTTI_hkcdVertexGeometry__VPolygonCollection;
extern const void * RTTI_hkMeshTexture__Sampler;
extern const void * RTTI_hkcdConvexCellsTree2D;
extern const void * RTTI_hkImage;
extern const void * RTTI_hkDefaultImage;
extern const void * RTTI_UI;
extern const void * RTTI_Scaleform__Render__MappedTextureBase;
extern const void * RTTI_Scaleform__Render__RenderBuffer__RenderTargetData;
extern const void * RTTI_Scaleform__Render__D3D1x__MappedTexture;
extern const void * RTTI_Scaleform__Render__D3D1x__RenderTargetData;
extern const void * RTTI_BSUIScaleformData;
extern const void * RTTI_UIMessage;
extern const void * RTTI_BSGFxFunctionHandler;
extern const void * RTTI_BSGFxFunctionBase;
extern const void * RTTI_BSGFxShaderFXTarget;
extern const void * RTTI_BSGFxDisplayObject;
extern const void * RTTI_IMenu;
extern const void * RTTI_Scaleform__SysAllocPaged;
extern const void * RTTI_Scaleform__SysMemMapper;
extern const void * RTTI_Scaleform__Log;
extern const void * RTTI_Scaleform__GFx__Translator;
extern const void * RTTI_Scaleform__GFx__ZlibSupportBase;
extern const void * RTTI_Scaleform__GFx__State;
extern const void * RTTI_Scaleform__GFx__ZlibSupport;
extern const void * RTTI_BSScaleformTranslator;
extern const void * RTTI_BSScaleformManager;
extern const void * RTTI_BSStreamParserData;
extern const void * RTTI_BSResourceStreamParser;
extern const void * RTTI_MenuCursor;
extern const void * RTTI_Scaleform__File;
extern const void * RTTI_Scaleform__MemoryFile;
extern const void * RTTI_Scaleform__GFx__FileOpenerBase;
extern const void * RTTI_Scaleform__GFx__FileOpener;
extern const void * RTTI_BSScaleformFileOpener;
extern const void * RTTI_ScaleformFile__MemoryFile;
extern const void * RTTI_IDebugText;
extern const void * RTTI_DebugText;
extern const void * RTTI_Scaleform__RefCountVImpl;
extern const void * RTTI_Scaleform__Render__ImageBase;
extern const void * RTTI_Scaleform__Render__Image;
extern const void * RTTI_Scaleform__Render__TextureImage;
extern const void * RTTI_BSScaleformImageLoader;
extern const void * RTTI_SFRenderBufferManager;
extern const void * RTTI_Movie;
extern const void * RTTI_MoviePlayer;
extern const void * RTTI_ITrianglePathSplitter;
extern const void * RTTI_IPathSmootherRayCast;
extern const void * RTTI_FindTriangleForLocationTraversableFilter;
extern const void * RTTI_FindTriangleForLocationWaterFilter;
extern const void * RTTI_BSPathing;
extern const void * RTTI_BSPathing__EdgeFoundVisitor;
extern const void * RTTI_TrianglePathWaterAndLedgeSplitter;
extern const void * RTTI_BSNavmesh;
extern const void * RTTI_IPathBuilderTracker;
extern const void * RTTI_BSPathingRequest;
extern const void * RTTI_NullPathBuilderTracker;
extern const void * RTTI_BSPathSmootherPOVSearch;
extern const void * RTTI_DynamicNavmesh__BuildThread;
extern const void * RTTI_MovementAgent;
extern const void * RTTI_NullMovementState;
extern const void * RTTI_IMovementHandlerAgent;
extern const void * RTTI_MovementHandlerArbiter;
extern const void * RTTI_MovementHandlerAgent;
extern const void * RTTI_IMovementControllerRegisterInterface;
extern const void * RTTI_IMovementControllerDataTracker;
extern const void * RTTI_MovementControllerAI;
extern const void * RTTI_BSPathingStreamSimpleBufferRead;
extern const void * RTTI_MovementControllerNullDataTracker;
extern const void * RTTI_IMovementPlayIdleResult;
extern const void * RTTI_ISelectIdleFilter;
extern const void * RTTI_MovementSelectIdleUtils__SelectClosestIdleToPath;
extern const void * RTTI_MovementSelectIdleUtils__SelectClosestIdleToMovementSelectionData;
extern const void * RTTI_MovementMessageFreezeDirection;
extern const void * RTTI_IMovementQueryTweener;
extern const void * RTTI_IMovementSetTweener;
extern const void * RTTI_MovementTweenerArbiter;
extern const void * RTTI_MovementTweenerAgent;
extern const void * RTTI_IMovementSetCorrectionData;
extern const void * RTTI_IMovementQueryTweenerState;
extern const void * RTTI_MovementTweenerAgentFixedDelta;
extern const void * RTTI_BSNavmeshObstacleCoverData;
extern const void * RTTI_BSNavmeshObstacleData;
extern const void * RTTI_BSNavmeshInfoSearch;
extern const void * RTTI_BSPrecomputedNavmeshInfoSearch;
extern const void * RTTI_IMovementPathManagerAgent;
extern const void * RTTI_MovementPathManagerAgent;
extern const void * RTTI_IMovementSetGoal;
extern const void * RTTI_IMovementQueryPathingState;
extern const void * RTTI_IMovementPathManagerDataTracker;
extern const void * RTTI_MovementPathManagerArbiter;
extern const void * RTTI_MovementMessageNewPath;
extern const void * RTTI_MovementMessageUpdateRequestImmediate;
extern const void * RTTI_MovementPathManagerNullTracker;
extern const void * RTTI_IMovementSetState;
extern const void * RTTI_MovementAgentActorState;
extern const void * RTTI_IPathFollowerAction;
extern const void * RTTI_IMovementPlannerAgent;
extern const void * RTTI_IMovementQueryPathFollowing;
extern const void * RTTI_IMovementQueryPathFollowing__INodeVisitor;
extern const void * RTTI_IMovementSetPathFollowing;
extern const void * RTTI_ICheckEndReachedFunctorMapper;
extern const void * RTTI_CheckParameterReachedFunctor;
extern const void * RTTI_CheckGoalReachedFunctor;
extern const void * RTTI_CheckStoppedMovingFunctor;
extern const void * RTTI_MovementAgentPathFollowerStandard;
extern const void * RTTI_BSNavmeshInfoMap;
extern const void * RTTI_BSNavmeshInfoMap__IRecursiveVisitor;
extern const void * RTTI_BSPrecomputedNavmeshInfoPathMap__INavmeshInfoVisitor;
extern const void * RTTI_MovementArbitrationAverageFloat;
extern const void * RTTI_MovementArbitrationMaxWeightPoint;
extern const void * RTTI_MovementArbitrationMaxWeightParameters;
extern const void * RTTI_NullMovementSelectIdleResult;
extern const void * RTTI_INavmeshSearchFilterSet;
extern const void * RTTI_BSNavmeshSearchFilters;
extern const void * RTTI_BSNavmeshSearch;
extern const void * RTTI_BSPathingLOSGridCell;
extern const void * RTTI_BSPathingLOSGrid;
extern const void * RTTI_BSPathingLOSGridMap;
extern const void * RTTI_BSPathBuilder;
extern const void * RTTI_PathSmootherRayCastUsePreferredTris;
extern const void * RTTI_PathSmootherRayCastUseTrianglePath;
extern const void * RTTI_IMovementSetStaticAvoider;
extern const void * RTTI_IMovementQueryStaticAvoider;
extern const void * RTTI_MovementPathManagerAgentStaticAvoider;
extern const void * RTTI_BSPathEventManager;
extern const void * RTTI_MovementMessageDoor;
extern const void * RTTI_MovementMessageApproachingDoor;
extern const void * RTTI_MovementMessageActivateDoor;
extern const void * RTTI_MovementMessageWarpToLocation;
extern const void * RTTI_MovementMessageWarpToMultiple;
extern const void * RTTI_MovementMessageBlocked;
extern const void * RTTI_MovementMessagePlayIdle;
extern const void * RTTI_MovementMessageSetStaticPath;
extern const void * RTTI_MovementMessageJump;
extern const void * RTTI_IMovementQueryDeltas;
extern const void * RTTI_IMovementDeltaStore;
extern const void * RTTI_MovementPostUpdateArbiter;
extern const void * RTTI_MovementArbiter;
extern const void * RTTI_IMovementPlannerSetArbitration;
extern const void * RTTI_MovementPlannerArbiter;
extern const void * RTTI_MovementPlannerAgent;
extern const void * RTTI_MovementPathManagerAgentLoadedAreaMonitor;
extern const void * RTTI_IMovementQueryFlight;
extern const void * RTTI_MovementAgentPathFollowerFlight;
extern const void * RTTI_MovementAgentPathFollowerVirtual;
extern const void * RTTI_IMovementQueryActorAvoidance;
extern const void * RTTI_MovementAgentActorAvoider;
extern const void * RTTI_MovementHandlerAgentAngleGain;
extern const void * RTTI_MovementHandlerAgentSpeedPassThrough;
extern const void * RTTI_MovementHandlerAgentAnglePassThrough;
extern const void * RTTI_MovementHandlerAgentDirectionPassThrough;
extern const void * RTTI_MovementHandlerAgentStrafing;
extern const void * RTTI_MovementPlannerAgentNavmeshBounds;
extern const void * RTTI_MovementPathManagerAgentAvoidBox;
extern const void * RTTI_MovementStateTransformOverride;
extern const void * RTTI_MovementStateTweener;
extern const void * RTTI_MovementStateFollowPath;
extern const void * RTTI_MovementTweenerAgentTargetPosAndVel;
extern const void * RTTI_MovementHandlerAgentStorePlannerOutput;
extern const void * RTTI_MovementHandlerAgentStandard;
extern const void * RTTI_MovementMessagePathEvent;
extern const void * RTTI_MovementMessagePathComplete;
extern const void * RTTI_MovementMessagePathFailed;
extern const void * RTTI_MovementMessagePathCleared;
extern const void * RTTI_BSPathingSearchRayCast;
extern const void * RTTI_ISmoothingRayValidator;
extern const void * RTTI_GroundPathRayValidator;
extern const void * RTTI_WaterPathRayValidator;
extern const void * RTTI_IPathingNodeGenerator;
extern const void * RTTI_GroundPathPathingNodeGenerator;
extern const void * RTTI_WaterPathPathingNodeGenerator;
extern const void * RTTI_BSNavmeshObstacleUndoData;
extern const void * RTTI_VelocityObstacle__Utilities__BuildOpenEdgeListsVisitor;
extern const void * RTTI_IPathFollowerState;
extern const void * RTTI_ICheckEndReachedFunctor;
extern const void * RTTI_PathFollowerStatePlayIdle;
extern const void * RTTI_PathFollowerStateFollowPathToParameter;
extern const void * RTTI_PathFollowerStateKeepLastDirection;
extern const void * RTTI_PathFollowerStateShortcut;
extern const void * RTTI_PathFollowerStateTurnToAngle;
extern const void * RTTI_MovementArbitrationVectorAdd;
extern const void * RTTI_bnet__BaseCallback;
extern const void * RTTI_BSPlatform__BSTerminatedCallback;
extern const void * RTTI_BSPlatform__BSBethesdaPlatform;
extern const void * RTTI_BSPlatform__BSAsyncRequestBase;
extern const void * RTTI_bnet__EmptyTerminationCB;
extern const void * RTTI_bnet__ExternalAuthInfo;
extern const void * RTTI_bnet__SteamExternalAuthInfo;
extern const void * RTTI_BSPlatform__BSUploadRequest;
extern const void * RTTI_BSPlatform__BSDownloadRequest;
extern const void * RTTI_bnet___impl__RefCount;
extern const void * RTTI_bnet___impl__SharedMutex;
extern const void * RTTI_bnet__IDynamicVariableDeleter;
extern const void * RTTI_bnet__ConfigurationEntry;
extern const void * RTTI_bnet___impl__IPool;
extern const void * RTTI_bnet__ConfigurationEntryBoolean;
extern const void * RTTI_bnet__ConfigurationEntryInteger;
extern const void * RTTI_bnet__ConfigurationEntryFloat;
extern const void * RTTI_bnet__ConfigurationEntryLong;
extern const void * RTTI_bnet__ConfigurationEntryString;
extern const void * RTTI_bnet__IJobCollection;
extern const void * RTTI_bnet___detail__Composite;
extern const void * RTTI_std__bad_weak_ptr;
extern const void * RTTI_std___Ref_count_base;
extern const void * RTTI_bnet__IHeap;
extern const void * RTTI_bnet__IHttpConnectionProvider;
extern const void * RTTI_bnet__Network;
extern const void * RTTI_bnet__UserQueue;
extern const void * RTTI_bnet__UserProcessorCollection;
extern const void * RTTI_bnet__JobProcessorCollection;
extern const void * RTTI_bnet___impl__AsyncOperation;
extern const void * RTTI_bnet__SuspendFlow;
extern const void * RTTI_bnet__ResumeFlow;
extern const void * RTTI_bnet__BaseHttpRequest;
extern const void * RTTI_bnet__LogoutFlow;
extern const void * RTTI_bnet__IUgcUploader;
extern const void * RTTI_bnet__ChunkedUploadFlow;
extern const void * RTTI_bnet__IDownloader;
extern const void * RTTI_bnet__DownloadFlow;
extern const void * RTTI_bnet__FileDownloader;
extern const void * RTTI_bnet__UgcBrowseRequest;
extern const void * RTTI_bnet__UgcArgLessRequest;
extern const void * RTTI_bnet__UgcCategoryCountRequest;
extern const void * RTTI_bnet__UgcContentUploadRequest;
extern const void * RTTI_bnet__UgcImageUploadRequest;
extern const void * RTTI_bnet__UgcAddVideoRequest;
extern const void * RTTI_bnet__UgcContentRequest;
extern const void * RTTI_bnet__UgcContentUploadDetailsRequest;
extern const void * RTTI_bnet__UgcCreationRequest;
extern const void * RTTI_bnet__UgcEditRequest;
extern const void * RTTI_bnet__UgcFlagRequest;
extern const void * RTTI_bnet__UgcListContentRequest;
extern const void * RTTI_bnet__UgcListCategoriesRequest;
extern const void * RTTI_bnet__UgcListDlcRequest;
extern const void * RTTI_bnet__Ugc__ListPlatformsRequest;
extern const void * RTTI_bnet__Ugc__ListProductsRequest;
extern const void * RTTI_bnet__UgcListFollowedAuthorRequest;
extern const void * RTTI_bnet__UgcListNotificationRequest;
extern const void * RTTI_bnet__UgcListBlacklistedRequest;
extern const void * RTTI_bnet__UgcListFeaturedContentRequest;
extern const void * RTTI_bnet__UgcListByEntitlementIdsRequest;
extern const void * RTTI_bnet__UgcNotificationAcknowledgeRequest;
extern const void * RTTI_bnet__UgcPreviewUploadRequest;
extern const void * RTTI_bnet__UgcQueryRequest;
extern const void * RTTI_bnet__UgcRateRequest;
extern const void * RTTI_bnet__UgcAddReleaseNoteRequest;
extern const void * RTTI_bnet__UgcUpdateReleaseNoteRequest;
extern const void * RTTI_bnet__UgcRemoveReleaseNoteRequest;
extern const void * RTTI_bnet__Ugc__RefreshEntitlementRequest;
extern const void * RTTI_bnet__Job;
extern const void * RTTI_bnet__FreeLessHeap;
extern const void * RTTI_bnet__AcquirableFreeLessHeap;
extern const void * RTTI_bnet__NetworkLoop;
extern const void * RTTI_bnet__UserProcessor;
extern const void * RTTI_bnet__AcceptLegalDocumentsRequest;
extern const void * RTTI_bnet__ListLegalDocumentsFlow;
extern const void * RTTI_bnet__AccountLinkingRequest;
extern const void * RTTI_bnet__AccountQuickCreateFlow;
extern const void * RTTI_bnet__AnonymousAuthenticationFlow;
extern const void * RTTI_bnet__SessionAnonymousCreateFlow;
extern const void * RTTI_bnet__SessionQuickCreateFlow;
extern const void * RTTI_bnet__AccountDeletionRequest;
extern const void * RTTI_bnet__AddFingerprintRequest;
extern const void * RTTI_bnet__IsAccountLinkableRequest;
extern const void * RTTI_bnet__UserCredentialsAuthenticationFlow;
extern const void * RTTI_bnet__ExternalAuthenticationFlow;
extern const void * RTTI_bnet__GameCodeAuthenticationFlow;
extern const void * RTTI_bnet__UnlinkAccountFlow;
extern const void * RTTI_bnet__UsernameValidationRequest;
extern const void * RTTI_bnet__VerifyFingerprintRequest;
extern const void * RTTI_bnet__VerifyLinkRequest;
extern const void * RTTI_bnet__TwitchAccountInfoRequest;
extern const void * RTTI_bnet__CheckEmailRequest;
extern const void * RTTI_bnet__RecoverPasswordRequest;
extern const void * RTTI_bnet__RecoverUsernameRequest;
extern const void * RTTI_bnet__ResendVerificationRequest;
extern const void * RTTI_bnet__SessionValidateRequest;
extern const void * RTTI_bnet__AccountInfoRequest;
extern const void * RTTI_bnet__RetrieveExternalAccountJob;
extern const void * RTTI_bnet__ExternalServiceRetrieveAccountRequest;
extern const void * RTTI_bnet__AccountUpgradeAnonymousToQuickRequest;
extern const void * RTTI_bnet__GameAccountLinkFlow;
extern const void * RTTI_bnet__GameAccountLinkConflictResolveFlow;
extern const void * RTTI_bnet__GameAccountExternalLinkConflictResolveFlow;
extern const void * RTTI_bnet__GameAccountUserCredentialsAuthenticationFlow;
extern const void * RTTI_bnet__GameAccountExternalAuthenticationFlow;
extern const void * RTTI_bnet__GameAccountExternalLinkFlow;
extern const void * RTTI_bnet__GameAccountGameCodeAuthenticationFlow;
extern const void * RTTI_bnet__SessionResumeFlow;
extern const void * RTTI_bnet__NewGameSessionFlow;
extern const void * RTTI_bnet__Entitlements__ListRequest;
extern const void * RTTI_bnet__Entitlements__ConsumeRequest;
extern const void * RTTI_bnet__Entitlements__SearchRequest;
extern const void * RTTI_bnet__EventLog__LogEventRequest;
extern const void * RTTI_bnet__VCCS__Wallet__BalanceRequest;
extern const void * RTTI_bnet__VCCS__Wallet__PurchaseRequest;
extern const void * RTTI_bnet__UgcMtxPurchaseFlow;
extern const void * RTTI_bnet__VCCS__Fulfillment__UpdateFirstPartyEntitlementRequest;
extern const void * RTTI_bnet__VCCS__Catalog__GetItemRequest;
extern const void * RTTI_bnet__VCCS__Catalog__ListItemsRequest;
extern const void * RTTI_bnet__CMS__ListMessagesRequest;
extern const void * RTTI_bnet__Status__GetExtServerStatusRequest;
extern const void * RTTI_bnet__SessionLogoutRequest;
extern const void * RTTI_bnet__UgcCancelUploadRequest;
extern const void * RTTI_bnet__UgcChunkedUploadCompletionRequest;
extern const void * RTTI_bnet__UgcChunkedUploadInitiationRequest;
extern const void * RTTI_bnet__UgcChunkUploadRequest;
extern const void * RTTI_bnet__CdpFileInfoRequest;
extern const void * RTTI_bnet__CdpKeyRequest;
extern const void * RTTI_bnet__BaseFileDownloader;
extern const void * RTTI_bnet__HttpTransport;
extern const void * RTTI_bnet__WinHttpTransport;
extern const void * RTTI_bnet__SessionRefreshRequest;
extern const void * RTTI_bnet__SessionResumeRequest;
extern const void * RTTI_bnet__ListRequiredLegalDocumentsRequest;
extern const void * RTTI_bnet__AuthenticationFlow;
extern const void * RTTI_bnet__BeamQuickCreationRequest;
extern const void * RTTI_bnet__AnonymousAuthRequest;
extern const void * RTTI_bnet__SessionAnonymousAccountCreateRequest;
extern const void * RTTI_bnet__SessionQuickCreateRequest;
extern const void * RTTI_bnet__SessionAuthRequest;
extern const void * RTTI_bnet__BeamUserCredentialsAuthenticationRequest;
extern const void * RTTI_bnet__BeamExternalAuthenticationRequest;
extern const void * RTTI_bnet__SessionExternalAuthRequest;
extern const void * RTTI_bnet__Session__GameCodeAuthRequest;
extern const void * RTTI_bnet__TokenUpgradeRequest;
extern const void * RTTI_bnet__AccountUnlinkingRequest;
extern const void * RTTI_bnet__RetrieveExternalAccountRequest;
extern const void * RTTI_bnet__GameAccountLinkRequest;
extern const void * RTTI_bnet__GameAccountLinkConflictResolveRequest;
extern const void * RTTI_bnet__GameAccountExternalLinkConflictResolveRequest;
extern const void * RTTI_bnet__GameAccountAuthenticationRequest;
extern const void * RTTI_bnet__GameAccountExternalAuthRequest;
extern const void * RTTI_bnet__GameAccountExternalLinkRequest;
extern const void * RTTI_bnet__Session__GameAccountGameCodeAuthRequest;
extern const void * RTTI_bnet__SessionTokenRequest;
extern const void * RTTI_bnet__CdpAuthenticationRequest;
extern const void * RTTI_bnet__SessionResumeTokenRequest;
extern const void * RTTI_bnet__BeamAuthenticationRequest;
extern const void * RTTI_BSScript__IFindBoundObjectFunctor;
extern const void * RTTI_BSScript__IVMObjectBindInterface;
extern const void * RTTI_BSScript__ObjectTypeInfo;
extern const void * RTTI_BSScript__IComplexType;
extern const void * RTTI_BSScript__IVMSaveLoadInterface;
extern const void * RTTI_BSScript__IVirtualMachine;
extern const void * RTTI_BSScript__ITypeLinkedCallback;
extern const void * RTTI_BSScript__IVMDebugInterface;
extern const void * RTTI_BSScript__ICachedErrorMessage;
extern const void * RTTI_BSScript__ErrorLogger;
extern const void * RTTI_BSScript__IFunction;
extern const void * RTTI_BSScript__NF_util__NativeFunctionBase;
extern const void * RTTI_BSScript__StructTypeInfo;
extern const void * RTTI_BSScript__IMemoryPagePolicy;
extern const void * RTTI_BSScript__SimpleAllocMemoryPagePolicy;
extern const void * RTTI_BSScript__CompiledScriptLoader;
extern const void * RTTI_BSScript__Internal__VirtualMachine;
extern const void * RTTI_BSScript__Internal__IFuncCallQuery;
extern const void * RTTI_BSScript__Internal__RawFuncCallQuery;
extern const void * RTTI_BSScript__IObjectProcessor;
extern const void * RTTI_BSScript__Internal__AutoPropGetFunction;
extern const void * RTTI_BSScript__Internal__AutoPropSetFunction;
extern const void * RTTI_BSScript__Internal__CodeTasklet;
extern const void * RTTI_BSScript__ByteCode__PackedInstructionStream__InstructionFunctor;
extern const void * RTTI_BSScript__Internal__NativeFunctionStub;
extern const void * RTTI_BSScript__UnlinkedTypes__InstructionStream__InstructionFunctor;
extern const void * RTTI_BSScript__LinkerProcessor;
extern const void * RTTI_BSScript__Internal__ScriptFunction;
extern const void * RTTI_BSPrecomputedVisibility__MultiCellVisibilityData__TomeCollectionBuildTask;
extern const void * RTTI_BSShaderProperty;
extern const void * RTTI_BSLightingShaderMaterial;
extern const void * RTTI_BSEffectShaderProperty;
extern const void * RTTI_BSLightingShaderProperty;
extern const void * RTTI_BSFadeNode;
extern const void * RTTI_BSLeafAnimNode;
extern const void * RTTI_BSTreeNode;
extern const void * RTTI_BSImagespaceShaderVatsTargetDebug;
extern const void * RTTI_BSImagespaceShaderVatsTarget;
extern const void * RTTI_BSImagespaceShaderAlphaBlend;
extern const void * RTTI_BSImagespaceShaderBlur3;
extern const void * RTTI_BSImagespaceShaderBlur5;
extern const void * RTTI_BSImagespaceShaderBlur7;
extern const void * RTTI_BSImagespaceShaderBlur9;
extern const void * RTTI_BSImagespaceShaderBlur11;
extern const void * RTTI_BSImagespaceShaderBlur13;
extern const void * RTTI_BSImagespaceShaderBlur15;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur3;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur5;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur7;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur9;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur11;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur13;
extern const void * RTTI_BSImagespaceShaderNonHDRBlur15;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur3;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur5;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur7;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur9;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur11;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur13;
extern const void * RTTI_BSImagespaceShaderBrightPassBlur15;
extern const void * RTTI_BSImagespaceShaderHDRBlurX15_320CS;
extern const void * RTTI_BSImagespaceShaderHDRBlurX15_480CS;
extern const void * RTTI_BSImagespaceShaderHDRBlurX15_1024CS;
extern const void * RTTI_BSImagespaceShaderBlurX15_480CS;
extern const void * RTTI_BSImagespaceShaderBlurX13_480CS;
extern const void * RTTI_BSImagespaceShaderBlurX11_480CS;
extern const void * RTTI_BSImagespaceShaderBlurX9_480CS;
extern const void * RTTI_BSImagespaceShaderBlurX7_480CS;
extern const void * RTTI_BSImagespaceShaderBlurX5_480CS;
extern const void * RTTI_BSImagespaceShaderBlurX3_480CS;
extern const void * RTTI_BSImagespaceShaderBlurY15_270CS;
extern const void * RTTI_BSImagespaceShaderBlurY13_270CS;
extern const void * RTTI_BSImagespaceShaderBlurY11_270CS;
extern const void * RTTI_BSImagespaceShaderBlurY9_270CS;
extern const void * RTTI_BSImagespaceShaderBlurY7_270CS;
extern const void * RTTI_BSImagespaceShaderBlurY5_270CS;
extern const void * RTTI_BSImagespaceShaderBlurY3_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassHDRBlurY15_180CS;
extern const void * RTTI_BSImagespaceShaderBrightPassHDRBlurY15_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassHDRBlurY15_1024CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY15_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY13_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY11_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY9_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY7_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY5_270CS;
extern const void * RTTI_BSImagespaceShaderBrightPassBlurY3_270CS;
extern const void * RTTI_BSImagespaceShaderCopy;
extern const void * RTTI_BSImagespaceShaderCopyScaleBias;
extern const void * RTTI_BSImagespaceShaderCopyVisAlpha;
extern const void * RTTI_BSImagespaceShaderTextureMask;
extern const void * RTTI_BSImagespaceShaderGreyScale;
extern const void * RTTI_BSImagespaceShaderDownsampleDepth;
extern const void * RTTI_BSImagespaceShaderCopyStencil;
extern const void * RTTI_BSImagespaceShaderCopyWaterMask;
extern const void * RTTI_BSImagespaceShaderCopyShadowMapToArray;
extern const void * RTTI_BSImagespaceShaderDepthOfField;
extern const void * RTTI_BSImagespaceShaderDepthOfFieldFogged;
extern const void * RTTI_BSImagespaceShaderDepthOfFieldSplitScreen;
extern const void * RTTI_BSImagespaceShaderDistantBlur;
extern const void * RTTI_BSImagespaceShaderDistantBlurFogged;
extern const void * RTTI_BSImagespaceShaderDoubleVision;
extern const void * RTTI_BSImagespaceShaderFullScreenColor;
extern const void * RTTI_BSImagespaceShaderFXAA;
extern const void * RTTI_BSImagespaceShaderTemporalAA;
extern const void * RTTI_BSImagespaceShaderTemporalAAPipboy;
extern const void * RTTI_BSImagespaceShaderTemporalAAPowerArmorPipboy;
extern const void * RTTI_BSImagespaceShaderGammaCorrect;
extern const void * RTTI_BSImagespaceShaderGammaCorrectResize;
extern const void * RTTI_BSImagespaceShaderGammaLinearize;
extern const void * RTTI_BSImagespaceShaderGammaCorrectLUT;
extern const void * RTTI_BSImagespaceShaderHDRDownSample4;
extern const void * RTTI_BSImagespaceShaderHDRDownSample16Lum;
extern const void * RTTI_BSImagespaceShaderHDRDownSample4RGB2Lum;
extern const void * RTTI_BSImagespaceShaderHDRDownSample16;
extern const void * RTTI_BSImagespaceShaderHDRDownSample4LumClamp;
extern const void * RTTI_BSImagespaceShaderHDRDownSample16LumClamp;
extern const void * RTTI_BSImagespaceShaderHDRDownSample4LightAdapt;
extern const void * RTTI_BSImagespaceShaderHDRDownSample16LightAdapt;
extern const void * RTTI_BSImagespaceShaderHDRTonemapBlendCinematic;
extern const void * RTTI_BSImagespaceShaderHDRTonemapBlendCinematicFade;
extern const void * RTTI_BSImagespaceShaderHDRDownSample4CS;
extern const void * RTTI_BSImagespaceShaderHDRDownSample4LumCS;
extern const void * RTTI_BSImagespaceShaderHDRDownSample16LumCS;
extern const void * RTTI_BSImagespaceShaderHDRDownSample64RGB2LumCS;
extern const void * RTTI_BSImagespaceShaderHDRDownSample2LightAdaptCS;
extern const void * RTTI_BSImagespaceShaderLocalMap;
extern const void * RTTI_BSImagespaceShaderLocalMapCompanion;
extern const void * RTTI_BSImagespaceShaderMap;
extern const void * RTTI_BSImagespaceShaderNoiseScrollAndBlend;
extern const void * RTTI_BSImagespaceShaderNoiseNormalmap;
extern const void * RTTI_BSImagespaceShaderRadialBlur;
extern const void * RTTI_BSImagespaceShaderRadialBlurMedium;
extern const void * RTTI_BSImagespaceShaderRadialBlurHigh;
extern const void * RTTI_BSImagespaceShaderRefraction;
extern const void * RTTI_BSImagespaceShaderWaterDisplacementClearSimulation;
extern const void * RTTI_BSImagespaceShaderWaterDisplacementTexOffset;
extern const void * RTTI_BSImagespaceShaderWaterDisplacementWadingRipple;
extern const void * RTTI_BSImagespaceShaderWaterDisplacementRainRipple;
extern const void * RTTI_BSImagespaceShaderWaterWadingHeightmap;
extern const void * RTTI_BSImagespaceShaderWaterRainHeightmap;
extern const void * RTTI_BSImagespaceShaderWaterBlendHeightmaps;
extern const void * RTTI_BSImagespaceShaderWaterSmoothHeightmap;
extern const void * RTTI_BSImagespaceShaderWaterDisplacementNormals;
extern const void * RTTI_BSImagespaceShaderPipboyScreen;
extern const void * RTTI_BSImagespaceShaderHUDGlass;
extern const void * RTTI_BSImagespaceShaderHUDGlassDropShadow;
extern const void * RTTI_BSImagespaceShaderHUDGlassBlurY;
extern const void * RTTI_BSImagespaceShaderHUDGlassBlurX;
extern const void * RTTI_BSImagespaceShaderHUDGlassMarkers;
extern const void * RTTI_BSImagespaceShaderHUDGlassClear;
extern const void * RTTI_BSImagespaceShaderHUDGlassCopy;
extern const void * RTTI_BSImagespaceShaderVLSSliceCoord;
extern const void * RTTI_BSImagespaceShaderVLSSliceInterp;
extern const void * RTTI_BSImagespaceShaderVLSSliceStencil;
extern const void * RTTI_BSImagespaceShaderVLSSliceScatterRay;
extern const void * RTTI_BSImagespaceShaderVLSSliceScatterInterp;
extern const void * RTTI_BSImagespaceShaderVLSScatterAccum;
extern const void * RTTI_BSImagespaceShaderVLSSpotLight;
extern const void * RTTI_BSImagespaceShaderVLSApplication;
extern const void * RTTI_BSImagespaceShaderVLSComposite;
extern const void * RTTI_BSImagespaceShaderModMenuEffect;
extern const void * RTTI_BSImagespaceShaderModMenuGlowComposite;
extern const void * RTTI_BSImagespaceShaderAmbientOcclusion;
extern const void * RTTI_BSImagespaceShaderAmbientOcclusionBlur;
extern const void * RTTI_BSImagespaceShaderMotionBlur;
extern const void * RTTI_BSImagespaceShaderSAOCameraZ;
extern const void * RTTI_BSImagespaceShaderSAOMinify;
extern const void * RTTI_BSImagespaceShaderSAORawAO;
extern const void * RTTI_BSImagespaceShaderSAOBlurH;
extern const void * RTTI_BSImagespaceShaderSAOBlurV;
extern const void * RTTI_BSImagespaceShaderSAOCameraZCS;
extern const void * RTTI_BSImagespaceShaderSAOCameraAndMipsZCS;
extern const void * RTTI_BSImagespaceShaderSAOMipsZCS;
extern const void * RTTI_BSImagespaceShaderSAOMinifyCS;
extern const void * RTTI_BSImagespaceShaderSAORawAOCS;
extern const void * RTTI_BSImagespaceShaderSAOBlurHCS;
extern const void * RTTI_BSImagespaceShaderSAOBlurVCS;
extern const void * RTTI_BSImagespaceShaderSAORawAOEditor;
extern const void * RTTI_BSImagespaceShaderSSLRBlurH;
extern const void * RTTI_BSImagespaceShaderSSLRBlurV;
extern const void * RTTI_BSImagespaceShaderSSLRRaytracing;
extern const void * RTTI_BSImagespaceShaderSSLRPrepass;
extern const void * RTTI_BSImagespaceShaderSunbeams;
extern const void * RTTI_BSImagespaceShaderUpsampleDynamicResolution;
extern const void * RTTI_BSImagespaceShaderBokehDepthOfFieldPass1;
extern const void * RTTI_BSImagespaceShaderBokehDepthOfFieldPass2;
extern const void * RTTI_BSImagespaceShaderBokehDepthOfFieldPass3;
extern const void * RTTI_BSImagespaceShaderBokehDepthOfFieldPass4;
extern const void * RTTI_BSImagespaceShaderBokehDepthOfFieldPass4Fogged;
extern const void * RTTI_BSImagespaceShaderRainSplash;
extern const void * RTTI_BSImagespaceShaderRainSplashUpdate;
extern const void * RTTI_BSImagespaceShaderRainSplashDraw;
extern const void * RTTI_BSDeferredDecal__BSDFDecal;
extern const void * RTTI_ShadowSceneNode;
extern const void * RTTI_BSImagespaceShaderLensFlare;
extern const void * RTTI_BSImagespaceShaderLensFlareVisibility;
extern const void * RTTI_BSGrassShaderProperty;
extern const void * RTTI_BSLightingShaderMaterialEnvmap;
extern const void * RTTI_BSLightingShaderMaterialBase;
extern const void * RTTI_BSLightingShaderMaterialEye;
extern const void * RTTI_BSLightingShaderMaterialGlowmap;
extern const void * RTTI_BSLightingShaderMaterialParallax;
extern const void * RTTI_BSLightingShaderMaterialParallaxOcc;
extern const void * RTTI_BSLightingShaderMaterialDismemberment;
extern const void * RTTI_BSLightingShaderMaterialFace;
extern const void * RTTI_BSLightingShaderMaterialSkinTint;
extern const void * RTTI_BSLightingShaderMaterialHairTint;
extern const void * RTTI_BSLightingShaderMaterialLandscape;
extern const void * RTTI_BSLightingShaderMaterialLODLandscape;
extern const void * RTTI_BSLightingShaderMaterialSnow;
extern const void * RTTI_BSLightingShaderMaterialMultiLayerParallax;
extern const void * RTTI_ImageSpaceEffectParam;
extern const void * RTTI_ImageSpaceShaderParam;
extern const void * RTTI_BSShaderAccumulator;
extern const void * RTTI_BSWaterShaderProperty;
extern const void * RTTI_BSBloodSplatterShaderProperty;
extern const void * RTTI_BSBloodSplatterShader;
extern const void * RTTI_ImageSpaceEffectVatsTarget;
extern const void * RTTI_NVFlex__DebrisInstanceNode;
extern const void * RTTI_NVFlex__DebrisInstanceGroup;
extern const void * RTTI_NVFlex__DebrisInstanceGroupPass;
extern const void * RTTI_BSDismember__BSShaderDismembermentExtraData;
extern const void * RTTI_BSShaderMaterial;
extern const void * RTTI_BSPackedCombinedGeomDataExtra;
extern const void * RTTI_BSPackedSharedGeometryBuilder;
extern const void * RTTI_BSPackedCombinedSharedGeomDataExtra;
extern const void * RTTI_BSGeometryListCullingProcess;
extern const void * RTTI_BSImagespaceShaderCopyParam;
extern const void * RTTI_BSLight;
extern const void * RTTI_BSDFPrePassShader;
extern const void * RTTI_ImageSpaceEffectHDR;
extern const void * RTTI_ImageSpaceEffectAmbientOcclusion;
extern const void * RTTI_ImageSpaceEffectScalableAmbientObscuranceCS;
extern const void * RTTI_ImageSpaceEffectSunbeams;
extern const void * RTTI_ImageSpaceEffectMotionBlur;
extern const void * RTTI_ImageSpaceEffectScalableAmbientObscurance;
extern const void * RTTI_ImageSpaceEffectTemporalAA;
extern const void * RTTI_ImageSpaceEffectOption;
extern const void * RTTI_ImageSpaceEffectBokehDepthOfField;
extern const void * RTTI_BSDFCompositeShader;
extern const void * RTTI_BSSkyShader;
extern const void * RTTI_BSSkyShaderProperty;
extern const void * RTTI_ImageSpaceEffectRainSplash;
extern const void * RTTI_BSBatchRenderer;
extern const void * RTTI_BSFaceCustomizationShader;
extern const void * RTTI_BSEffectShaderMaterial;
extern const void * RTTI_BSEffectShader;
extern const void * RTTI_BSDistantTreeShaderProperty;
extern const void * RTTI_BSDistantTreeShader;
extern const void * RTTI_BSWaterShaderMaterial;
extern const void * RTTI_BSCubeMapCamera;
extern const void * RTTI_BSWaterShader;
extern const void * RTTI_ImageSpaceEffectWaterDisplacement;
extern const void * RTTI_ImageSpaceEffectModMenu;
extern const void * RTTI_BSShader;
extern const void * RTTI_BSReloadShaderI;
extern const void * RTTI_ImageSpaceEffectPipboyScreen;
extern const void * RTTI_ImageSpaceEffectBlur;
extern const void * RTTI_ImageSpaceEffectFullScreenBlur;
extern const void * RTTI_ImageSpaceEffectGetHit;
extern const void * RTTI_ImageSpaceEffectRadialBlur;
extern const void * RTTI_BSClearZNode;
extern const void * RTTI_BSFogProperty;
extern const void * RTTI_BSLightingShader;
extern const void * RTTI_ImageSpaceEffectFullScreenColor;
extern const void * RTTI_BSInstanceGroup;
extern const void * RTTI_BSCombinedNode;
extern const void * RTTI_BSEyeCenterExtraData;
extern const void * RTTI_BSUtilityShader;
extern const void * RTTI_BSMeshLODTriShape;
extern const void * RTTI_BSMultiIndexTriShape;
extern const void * RTTI_BSOrderedNode;
extern const void * RTTI_BSParticleShader;
extern const void * RTTI_BSDFLightShader;
extern const void * RTTI_BSLightingShaderPropertyFloatController;
extern const void * RTTI_BSLightingShaderPropertyUShortController;
extern const void * RTTI_BSLightingShaderPropertyColorController;
extern const void * RTTI_BSEffectShaderPropertyFloatController;
extern const void * RTTI_BSEffectShaderPropertyColorController;
extern const void * RTTI_BSNiAlphaPropertyTestRefController;
extern const void * RTTI_BSPSysSimpleColorModifier;
extern const void * RTTI_BSPSysLODModifier;
extern const void * RTTI_BSImagespaceShader;
extern const void * RTTI_BSShadowLight;
extern const void * RTTI_BSShadowDirectionalLight;
extern const void * RTTI_ImageSpaceEffect;
extern const void * RTTI_ImageSpaceEffectRefraction;
extern const void * RTTI_ImageSpaceEffectDepthOfField;
extern const void * RTTI_ImageSpaceEffectDepthOfFieldSplitScreen;
extern const void * RTTI_ImageSpaceEffectBlurCS;
extern const void * RTTI_ImageSpaceEffectHDRCS;
extern const void * RTTI_ImageSpaceEffectMap;
extern const void * RTTI_ImageSpaceEffectNoise;
extern const void * RTTI_ImageSpaceEffectHUDGlass;
extern const void * RTTI_ImageSpaceEffectVLSLight;
extern const void * RTTI_ImageSpaceEffectVLS;
extern const void * RTTI_ImageSpaceEffectUpsampleDynamicResolution;
extern const void * RTTI_BSImagespaceComputeShader;
extern const void * RTTI_BSShadowFrustumLight;
extern const void * RTTI_BSShadowParabolicLight;
extern const void * RTTI_NVFlex__DebrisInstanceData;
extern const void * RTTI_NVFlex__DebrisInstanceDataOwner;
extern const void * RTTI_BSComputeShader;
extern const void * RTTI_BSLODMultiIndexTriShape;
extern const void * RTTI_BSDirectoryMonitorThread;
extern const void * RTTI_BSShaderResourceManager;
extern const void * RTTI_BSSystemMonitor__SocketThread;
extern const void * RTTI_BSSystemMonitor__MemOpsThread;
extern const void * RTTI_BSGameDataSystemUtility;
extern const void * RTTI_BSSaveDataSystemUtility;
extern const void * RTTI_BSSystemUtility;
extern const void * RTTI_BSWin32GameDataSystemUtility;
extern const void * RTTI_BSSysInfoSystemUtility;
extern const void * RTTI_BSGameStreamUtility;
extern const void * RTTI_BSAwardsSystemUtility;
extern const void * RTTI_BSCacheDriveSystemUtility;
extern const void * RTTI_BSSystemUtilitiesStrings;
extern const void * RTTI_BSMsgDialogSystemUtility;
extern const void * RTTI_BSDiscBootSystemUtility;
extern const void * RTTI_type_info;
extern const void * RTTI_BSSocketServer;
extern const void * RTTI_NiCollisionObject;
extern const void * RTTI_BSLines;
extern const void * RTTI_BSDynamicLines;
extern const void * RTTI_BSParabolicCullingProcess;
